//////////////////////////////////////////////////////////////////
// Impulse C is Copyright(c) 2003-2007 Impulse Accelerated Technologies, Inc.
// 
// idct_sw.c: includes the software test bench processes and
// main() function.
//

#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>
#include "co.h"
#include "idct.h"

extern co_architecture co_initialize(void *);

void Producer(co_stream istream)
{
	int i;
	short block[64];

	for (i=0; i<64; i++) block[i]=i;

	printf("Sending:\r\n");
	for (i=0; i<64; i++) {
		if ((i&0x7)==0) printf("\r\n");
		printf("%04x ",(int)(unsigned short)block[i]);
	}
	printf("\r\n");

	co_stream_open(istream, O_WRONLY, UINT_TYPE(128));
	for (i=0; i<64; i+=8) {
		co_stream_write(istream, block+i, sizeof(co_uint128));
	}
	co_stream_close(istream);
}

void Consumer(co_stream ostream)
{
	int i;
	short block[64];

	co_stream_open(ostream, O_RDONLY, UINT_TYPE(128));
	for (i=0; i<64; i+=8) {
		co_stream_read(ostream, block+i, sizeof(co_uint128));
	}
	co_stream_close(ostream);

	printf("Received:\r\n");
	for (i=0; i<64; i++) {
		if ((i&0x7)==0) printf("\r\n");
		printf("%04x ",(int)(unsigned short)block[i]);
	}
	printf("\r\n");
}

#ifdef color

IF_SIM(
#define memalign(a,b) malloc(b)
)

//SW
void Color_Convert_Temp
(co_stream output_stream, 
 co_stream ya_stream, 
 co_stream yb_stream, 
 co_stream u_stream, 
 co_stream v_stream)
{
	co_error err;
	int i,j;
	static floop=1;
	co_uint8 *y = memalign(32, 1024*2);
	co_uint8 *u = memalign(32, 1024);
	co_uint8 *v = memalign(32, 1024);
	co_uint8 *pixelValue = memalign(32, 32);
	for(i=0;i<1024;i++)
	{
		y[i] = i;
		//y[2*i+1] = i;
		u[i] = 128;
		v[i] = 128;
	}
	for(i=0;i<32;i++)pixelValue[i]=-1; //default value to see if pixelValue is overwritten

	co_stream_open(output_stream, O_RDONLY, UINT_TYPE(128));
	co_stream_open(ya_stream, O_WRONLY, UINT_TYPE(128));
	co_stream_open(yb_stream, O_WRONLY, UINT_TYPE(128));
	co_stream_open(u_stream, O_WRONLY, UINT_TYPE(128));
	co_stream_open(v_stream, O_WRONLY, UINT_TYPE(128));

	if (floop)
	{
		co_stream_write(ya_stream, &y[32*i], sizeof(co_uint128));
		co_stream_write(yb_stream, &y[32*i+16], sizeof(co_uint128));
		co_stream_write(u_stream, &u[16*i], sizeof(co_uint128));
		co_stream_write(v_stream, &v[16*i], sizeof(co_uint128));
	}	
	//for(i=0;i<20;i++)printf("y: %d \n", y[i]);
	for(i=0;i<3;i++)
	{
		
		co_stream_write(ya_stream, &y[32*i], sizeof(co_uint128));
		co_stream_write(yb_stream, &y[32*i+16], sizeof(co_uint128));
		co_stream_write(u_stream, &u[16*i], sizeof(co_uint128));
		co_stream_write(v_stream, &v[16*i], sizeof(co_uint128));
		if (floop){
			floop=0;
			for(j=0;j<8;j++)co_stream_read(output_stream, pixelValue, sizeof(co_uint128));
		}
		for(j=0;j<8;j++){
			co_stream_read(output_stream, pixelValue, sizeof(co_uint128));
			printf("loop: %d-%d********pixels:[%d %d %d %d] - expect:[%d %d %d %d]\n"
			,i
			,j+1
			,pixelValue[1], pixelValue[5], pixelValue[9], pixelValue[13]
			,(co_uint8)(i*32+4*j), (co_uint8)(i*32+4*j+1), (co_uint8)(i*32+4*j+2), (co_uint8)(i*32+4*j+3)
			);
		}
	}
	

	co_stream_close(ya_stream);
	co_stream_close(yb_stream);
	co_stream_close(u_stream);
	co_stream_close(v_stream);
	co_stream_close(output_stream);
	
}
#endif

int main(int argc, char *argv[])
{
	co_architecture my_arch;
	void *param = NULL;
	int c;

	my_arch = co_initialize(param);
	co_execute(my_arch);

	printf("\r\n\r\nApplication!!!! complete.\r\n");
	c = getc(stdin);

	return(0);
}
