//*****************************************************************************
// Copyright  2006, Xilinx, Inc. 
// This design is confidential and proprietary of Xilinx, Inc. All Rights Reserved.
//*****************************************************************************
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Version: 1.0
//  \   \        Filename: 
//  /   /        Date Last Modified: 
// /___/   /\    Date Created: 10-sep-06 
// \   \  /  \ 
//  \___\/\___\ 
// 
// Device: 
// Purpose:   
// Reference: 
//----------------------------------------------------------------------------
 
//   
//*****************************************************************************
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
//              provided to you "as is." Xilinx and its licensors make and you
//              receive no warranties or conditions, express, implied,
//              statutory or otherwise, and Xilinx specifically disclaims any
//              implied warranties of merchantability, no infringement, or
//              fitness for a particular purpose. Xilinx does not warrant that
//              the functions contained in these designs will meet your
//              requirements, or that the operation of these designs will be
//              uninterrupted or error free, or that defects in the Designs
//              will be corrected. Furthermore, Xilinx does not warrant or
//              make any representations regarding use or the results of the
//              use of the designs in terms of correctness, accuracy,
//              reliability, or otherwise.
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its
//              licensors be liable for any loss of data, lost profits, cost
//              or procurement of substitute goods or services, or for any
//              special, incidental, consequential, or indirect damages
//              arising from the use or operation of the designs or
//              accompanying documentation, however caused and on any theory
//              of liability. This limitation will apply even if Xilinx
//              has been advised of the possibility of such damage. This
//              limitation shall apply notwithstanding the failure of the
//              essential purpose of any limited remedies herein.
//
//*****************************************************************************/

// tftdisplay.c,                                                  
//author: george yu
//for displaying decoded y/u/v data

 
#ifdef STANDALONE

 
#include "stop_watch.h"
#include "xparameters.h"
#include "xcache_l.h"
#include "xgpio_l.h"
#include "sleep.h"
#include "string.h"
#include <stdio.h>
#include <stdlib.h>
#include "config.h" 
#include "global.h"
#include <co.h>
#include "sleep.h"
#include "bootload_basicgraphics.h"
#include "xtft.h"
#include "xtft_l.h"


//software color space conversion and display
void Show_Image(int x, int y, unsigned char *src[])
{
	long pixelValue;
	long YY; 
	short U, V, R, G, B;
	char RR, GG, BB;
   int i,j;

	stop_watch(2,3);//restart
	//color space conversion and display
	for(j=0;j<Coded_Picture_Height; j++)
   {
		for(i=0;i<Coded_Picture_Width; i++)
      {
			//read source YUV data
			YY = src[0][Coded_Picture_Width*j+i];
			int idx = Coded_Picture_Width/2*(j>>1)+(i>>1);
			U = src[1][idx];
			V = src[2][idx];
			//8-b coeff version of fixed point color space conversion
			R = (YY*256 + (351 * (V-128)))/256;
			G = (YY*256 - (179 * (V-128)) - (97 * (U-128)))/256;
			B = (YY*256 + (443 * (U-128)))/256;
			//clamping the values
			if(R<0)R=0;
			if(G<0)G=0;
			if(B<0)B=0;
			if(R>255)R=255;
			if(G>255)G=255;
			if(B>255)B=255;
			//copy to the framebuffer
			RR = (unsigned char)R;
			GG = (unsigned char)G;
			BB = (unsigned char)B;
			pixelValue = ((RR<<16) | (GG<<8) | BB) & 0x00FFFFFF;
			XTft_SetPixel(&Tft, i+x, j+y, pixelValue);
		}
	}
	stop_watch(3,3);//pause the timer
}

#endif
