//*****************************************************************************
// Copyright  2006, Xilinx, Inc. 
// This design is confidential and proprietary of Xilinx, Inc. All Rights Reserved.
//*****************************************************************************
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Version: 1.0
//  \   \        Filename: 
//  /   /        Date Last Modified: 
// /___/   /\    Date Created: 10-sep-06 
// \   \  /  \ 
//  \___\/\___\ 
// 
// Device: 
// Purpose: the impulseC interface file  
// Reference: 
//----------------------------------------------------------------------------
 
//   
//*****************************************************************************
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
//              provided to you "as is." Xilinx and its licensors make and you
//              receive no warranties or conditions, express, implied,
//              statutory or otherwise, and Xilinx specifically disclaims any
//              implied warranties of merchantability, no infringement, or
//              fitness for a particular purpose. Xilinx does not warrant that
//              the functions contained in these designs will meet your
//              requirements, or that the operation of these designs will be
//              uninterrupted or error free, or that defects in the Designs
//              will be corrected. Furthermore, Xilinx does not warrant or
//              make any representations regarding use or the results of the
//              use of the designs in terms of correctness, accuracy,
//              reliability, or otherwise.
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its
//              licensors be liable for any loss of data, lost profits, cost
//              or procurement of substitute goods or services, or for any
//              special, incidental, consequential, or indirect damages
//              arising from the use or operation of the designs or
//              accompanying documentation, however caused and on any theory
//              of liability. This limitation will apply even if Xilinx
//              has been advised of the possibility of such damage. This
//              limitation shall apply notwithstanding the failure of the
//              essential purpose of any limited remedies herein.
//
//*****************************************************************************/

//dcba = data cache block allocate
#define dcba(adr)    __asm__ __volatile__(\
                           "dcba 0,%0\n"\
                           : : "r" (adr)\
                         )

 
#include "stop_watch.h"
#include "xparameters.h"
#include "xcache_l.h"
#include "xgpio_l.h"
#include "sleep.h"
#include "string.h"
#include <stdio.h>
#include <stdlib.h>
#include "config.h" 
#include "global.h"
#include "co.h"
#include "sleep.h"
#include "bootload_basicgraphics.h"
#include "xtft.h"
#include "xtft_l.h"

#include "xtime_l.h"

#define UNIT_TEST 0

static co_stream Producer_stream,Consumer_stream;
static co_stream Toutput_stream, Ty_stream, Tu_stream, Tv_stream;

//void impc_IDCT(short *block, short *next);

//dummy interfacial function, see impulseC project
void Producer(co_stream s)

{
  Producer_stream=s;
}
//dummy interfacial function, see impulseC project
void Consumer(co_stream s)

{
  Consumer_stream=s;
}

#if UNIT_TEST  //for test only
__attribute__ ((aligned (16))) short testblock[]={
0xff5c,0xffea,0xfeff,0xff92,
0x00b3,0x009f,0xff7a,0x0045,
0xff39,0x00e3,0xff4a,0xff94,
0xffe1,0xffb1,0xffb5,0xff97,
0xff64,0x004c,0xff42,0xff91,
0xff74,0x00c0,0x00a3,0xffc9,
0xfff5,0xffd4,0x00d4,0x0026,
0x00b7,0x0074,0xffac,0xff67,
0xfe69,0xff74,0xffcb,0x001c,
0xff42,0x006c,0xffda,0xffbe,
0x007c,0xffd6,0xff95,0xffa4,
0x003c,0xffa6,0xff8c,0x01ff,
0xffee,0xff7c,0xffb6,0xffa7,
0x0085,0x0078,0xffc7,0x0034,
0x002a,0xfff6,0x0077,0xfff8,
0x0067,0xffe1,0x0160,0x000b
};
#endif

__attribute__ ((aligned (16))) short junk[64];
//init the impulseC arch
void impc_init_IDCT()
     
{
  co_architecture my_arch;
  void *param = NULL;
  
  my_arch = co_initialize(param);
  co_execute(my_arch);

#if UNIT_TEST
  for (i=0; i<64; i+=8)
    co_stream_write(Producer_stream,testblock+i,16);
  for (i=0; i<64; i+=8)
    co_stream_read(Consumer_stream,junk+i,16);
  for (i=0; i<64; i+=8)
    co_stream_write(Producer_stream,testblock+i,16);
  for (i=0; i<64; i+=8)
    co_stream_read(Consumer_stream,junk+i,16);

	 xil_printf("%08x->%08x:\r\n",testblock,junk);
  for (i=0; i<64; i+=8) {
	for (j=0; j<8; j++) {
		xil_printf("%04x ",(unsigned short)junk[i+j]);
	}
	xil_printf("\r\n");
  }
  while(1);
#endif
}

#if 1
#define impc_IDCT_write(block) \
	nextPtr = (unsigned char *)block; \
	HW_STREAM_WRITE_16(Producer,istream,nextPtr); \
	for(i=0;i<7;i++) { \
		nextPtr += 16; \
		PUT_QWORD(Producer,istream,nextPtr); \
	}
	
#define impc_IDCT_read(block) \
	nextPtr2 = (unsigned char *)block; \
   	GET_QWORD(Consumer,ostream,nextPtr2); \
  	for (i=0; i<7; i++) { \
    	nextPtr2 += 16; \
    	GET_QWORD(Consumer,ostream,nextPtr2); \
  	}

#else
void impc_IDCT_write(short *block)
{
	int i;
	unsigned char *nextPtr = (unsigned char *)block;
	HW_STREAM_WRITE_16(Producer,istream,nextPtr); 

	for(i=0;i<7;i++) {
		nextPtr += 16;
		PUT_QWORD(Producer,istream,nextPtr); 
	}
}

void impc_IDCT_read(short *block)
{
	int i;
	int err;
	unsigned char *nextPtr2 = (unsigned char *)block;
//   	HW_STREAM_READ_16(Consumer,ostream,nextPtr2,err);
   	GET_QWORD(Consumer,ostream,nextPtr2);
  	for (i=0; i<7; i++) {
    	nextPtr2 += 16;
    	GET_QWORD(Consumer,ostream,nextPtr2);
  	}
}
#endif
#define IDCT_PIPELINE_LAG	2	// must be >1
#if 1
void prep_IDCT(int blknum)
{
	int i,j;
	int err;
	unsigned char *nextPtr2;
	unsigned char *nextPtr;
	
	impc_IDCT_write(ld->block[blknum]);
	impc_IDCT_read(junk);
	for( j = 1; j < IDCT_PIPELINE_LAG; j++) {
		impc_IDCT_write(ld->block[blknum+j]);
	}
}

void impc_IDCT(int blknum, int blktotal)
{
	int i;
	int err;
	unsigned char *nextPtr2;
	unsigned char *nextPtr;

	impc_IDCT_read(ld->block[blknum]);	
	if ( blknum < (blktotal - (IDCT_PIPELINE_LAG - 1)) ) {
		impc_IDCT_write(ld->block[blknum+IDCT_PIPELINE_LAG]);
	}
}

#else
// ORIGINAL functions for 1-pipelined read/write
//fill the pipeline
void prep_IDCT(short *block)
{
  int i;
  int err;
static first = 1;
#if 0
  co_stream_write(Producer_stream,block,128);
#else
	unsigned char *nextPtr = (unsigned char *)block;
	HW_STREAM_WRITE_16(Producer,istream,nextPtr); 

	for(i=0;i<7;i++) {
		nextPtr += 16;
		PUT_QWORD(Producer,istream,nextPtr); 
	}
#endif

#if 0
  for (i=0; i<64; i+=8) {
//  	HW_STREAM_READ_16(Consumer,ostream,junk+i,err);
    GET_QWORD(Consumer,ostream,junk+i);
  }
#else
	{
	unsigned char *nextPtr2 = (unsigned char *)junk;
	  for (i=0; i<8; i++) {
	    GET_QWORD(Consumer,ostream,nextPtr2);
	    nextPtr2 += 16;
	  }
	}	
#endif
}

void impc_IDCT(short *block, short *next)
{
  int i;
  
#if 0
  co_stream_write(Producer_stream,next,128);
#else
	unsigned char *nextPtr = (unsigned char *)next;
	HW_STREAM_WRITE_16(Producer,istream,nextPtr); 

	for(i=0;i<7;i++) {
		nextPtr += 16;
		PUT_QWORD(Producer,istream,nextPtr); 
	}
#endif

#if 0
  for (i=0; i<64; i+=8) {
    GET_QWORD(Consumer,ostream,block+i);
  }
#else
	{
	unsigned char *nextPtr2 = (unsigned char *)block;
	  for (i=0; i<8; i++) {
	    GET_QWORD(Consumer,ostream,nextPtr2);
	    nextPtr2 += 16;
	  }
	}	
#endif

}
#endif

/**************APU Color Conv********************************/

//dummy interfacial function, see impulseC project
void Color_Convert_Temp
(co_stream output_stream, 
 co_stream y_stream, 
 co_stream u_stream, 
 co_stream v_stream)
{
		//open up streams
		co_stream_open(output_stream, O_RDONLY, UINT_TYPE(128));
		co_stream_open(y_stream, O_WRONLY, UINT_TYPE(128));
		co_stream_open(u_stream, O_WRONLY, UINT_TYPE(128));
		co_stream_open(v_stream, O_WRONLY, UINT_TYPE(128));
		//copy pointers
		Toutput_stream = output_stream;
		Ty_stream = y_stream;
		Tu_stream = u_stream;
		Tv_stream = v_stream;
}	


#define write_apu_yuv() \
	PUT_QWORD(sw_proc,y_stream,&src[0][idxY]); \
	PUT_QWORD(sw_proc,y_stream,&src[0][idxY+16]); \
	PUT_QWORD(sw_proc,u_stream,&src[1][idx]); \
	PUT_QWORD(sw_proc,v_stream,&src[2][idx]);

#if 1
#define read_apu_rgb() \
	dcba(FB); \
	dcba(FB+8); \
	GET_QWORD(sw_proc,output_stream,FB+0); \
	GET_QWORD(sw_proc,output_stream,FB+4); \
	GET_QWORD(sw_proc,output_stream,FB+8); \
	GET_QWORD(sw_proc,output_stream,FB+12); \
	dcba(FB+16); \
	dcba(FB+24); \
	GET_QWORD(sw_proc,output_stream,FB+16); \
	GET_QWORD(sw_proc,output_stream,FB+20); \
	GET_QWORD(sw_proc,output_stream,FB+24); \
	GET_QWORD(sw_proc,output_stream,FB+28); 

#else

#define read_apu_rgb() \
	HW_STREAM_READ_16(sw_proc,output_stream,&Fbuf[0],err); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[4]); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[8]); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[12]); \
	dcba(FB); \
	dcba(FB+8); \
	memcpy(FB, Fbuf, 64); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[16]); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[20]); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[24]); \
	GET_QWORD(sw_proc,output_stream,&Fbuf[28]); \
	dcba(FB+16); \
	dcba(FB+24); \
	memcpy(FB+16, Fbuf+16, 64);
#endif

static int first = 1;

#define NUM_ACC_TIMES	32
static XTime ACC_times[NUM_ACC_TIMES];


//the real color conversion function is here
void APU_Color_Convert(int x, int y, unsigned char *src[])
{
	int i, j, idx, idxY, pxlCol;
	Xuint32 *FB;
volatile unsigned int status;
int err;
//static XTime start, end;
//static Xuint32 tot_wr, tot_rd, count_rd, count_wr;

//printf("APU_Color_Convert(x=%d, y=%d, unsigned char *src[])\n",x,y);

//	tot_wr = tot_rd = count_rd = count_wr = 0;
	stop_watch(2,3);//restart the timer
//	XTime_GetTime(&ACC_times[0]);
   if (first)
	{
		//put some garbage to fill the pipe
//XTime_GetTime(&start);
		idx=0; idxY=0;
		write_apu_yuv();
//write_apu_yuv();
//write_apu_yuv();
//write_apu_yuv();

/*XTime_GetTime(&end);
count_wr++;
tot_wr += (Xuint32)end - start;*/
		first=0;
	}
//	idx=16; idxY=0;
//	write_apu_yuv();

//	XTime_GetTime(&ACC_times[1]);
	// x MUST be a multiple of 4 to be 16-byte aligned for direct APU->memory
	FB = *(Xuint32 *)Tft.BaseAddress+4*(y*1024 + x);
#if 1

#define YUV_PIPELINE_LAG	2
	j = 0;
	i = 0;
	pxlCol = 0;
#if YUV_PIPELINE_LAG > 0
	idxY = Coded_Picture_Width*j+i;
	idx = Coded_Picture_Width/2*(j>>1)+(i>>1);
	write_apu_yuv();
	i+=32;
#endif
#if YUV_PIPELINE_LAG > 1
	idxY = Coded_Picture_Width*j+i;
	idx = Coded_Picture_Width/2*(j>>1)+(i>>1);
	write_apu_yuv();
	i+=32;
#endif
#if YUV_PIPELINE_LAG > 2
	idxY = Coded_Picture_Width*j+i;
	idx = Coded_Picture_Width/2*(j>>1)+(i>>1);
	write_apu_yuv();
	i+=32;
#endif
#if YUV_PIPELINE_LAG > -1
	i+=32;
#endif

//	for(j=0;j<Coded_Picture_Height; j++)
	do 
	{
//	  for(i=0;i<Coded_Picture_Width; i=i+32)
//	  {
			//calculate the address of the YUV data
			
//			idxY = Coded_Picture_Width*j+(i+32);
//			idx = Coded_Picture_Width/2*(j>>1)+((i+32)>>1);
			
			idxY = Coded_Picture_Width*j+i;
			idx = Coded_Picture_Width/2*(j>>1)+(i>>1);

			//send one set of YUV data
			read_apu_rgb();
			write_apu_yuv();

/*XTime_GetTime(&end);
count_wr++;
tot_wr += (Xuint32)end - start;*/

//XTime_GetTime(&start);
			
/*XTime_GetTime(&end);
count_rd++;
tot_rd += (Xuint32)end - start;*/
/*
			if (i) {
				FB+=32;
			} 
			else {
				if (j) {
				   	FB = *(Xuint32 *)Tft.BaseAddress+4*((j+y)*1024 + x);
				}
			}*/
			i += 32;
			if ( i>=Coded_Picture_Width ) {
				i = 0;
				j++;
			}
			pxlCol += 32;
			if ( pxlCol>=Coded_Picture_Width ) {
				FB = *(Xuint32 *)Tft.BaseAddress+4*((j+y)*1024 + x);
				pxlCol = 0;
			}
			else {
				FB += 32;
			}
//		}
	} while(j<Coded_Picture_Height);
	
//XTime_GetTime(&start);
	write_apu_yuv();
/*XTime_GetTime(&end);
count_wr++;
tot_wr += (Xuint32)end - start;*/

//XTime_GetTime(&start);
	read_apu_rgb();
#if YUV_PIPELINE_LAG > 0
	FB+=32;
	read_apu_rgb();
#endif
#if YUV_PIPELINE_LAG > 1
	FB+=32;
	read_apu_rgb();
#endif
#if YUV_PIPELINE_LAG > 2
	FB+=32;
	read_apu_rgb();
#endif

/*XTime_GetTime(&end);
count_rd++;
tot_wr += (Xuint32)end - start;*/

//printf("count_wr= %u tot_wr= %u avg= %u\n", count_wr,tot_wr,tot_wr/count_wr);
//printf("count_rd= %u tot_rd= %u avg= %u\n", count_rd,tot_rd,tot_rd/count_rd);

#endif
#if 0
j = 2;
XTime_GetTime(&ACC_times[j++]);
	HW_STREAM_WRITE_16(sw_proc,y_stream,&src[0][idxY]);
XTime_GetTime(&ACC_times[j++]);
//	HW_STREAM_WRITE_16(sw_proc,y_stream,&src[0][idxY+16]);
	PUT_QWORD(sw_proc,y_stream,&src[0][idxY+16]);
XTime_GetTime(&ACC_times[j++]);
	PUT_QWORD(sw_proc,u_stream,&src[1][idx]);
XTime_GetTime(&ACC_times[j++]);
	PUT_QWORD(sw_proc,v_stream,&src[2][idx]);
XTime_GetTime(&ACC_times[j++]);
	HW_STREAM_READ_16(sw_proc,output_stream,&Fbuf[0],err);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[4]);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[8]);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[12]);
XTime_GetTime(&ACC_times[j++]);
	dcba(FB);
	dcba(FB+8);
	memcpy(FB, Fbuf, 64);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[16]);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[20]);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[24]);
XTime_GetTime(&ACC_times[j++]);
	GET_QWORD(sw_proc,output_stream,&Fbuf[28]);
XTime_GetTime(&ACC_times[j++]);
	dcba(FB+16);
	dcba(FB+24);
	memcpy(FB+16, Fbuf+16, 64);
XTime_GetTime(&ACC_times[j++]);
XTime_GetTime(&ACC_times[j++]);

print_results:
for( i =0; i < j; i++) {
	printf("time[%d]=0x%08lx%08lx",i,(Xuint32)(ACC_times[i]>>32),(Xuint32)ACC_times[i]);
	if (i) {
		printf("  abs=%8lu delta=%8lu\n",
			(Xuint32)(ACC_times[i]-ACC_times[0]),
			(Xuint32)(ACC_times[i]-ACC_times[i-1]));
	} 
	else {
		printf("\n");
	}
}
#endif
	stop_watch(3,3);//pause
}


