//*****************************************************************************
// Copyright  2006, Xilinx, Inc. 
// This design is confidential and proprietary of Xilinx, Inc. All Rights Reserved.
//*****************************************************************************
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Version: 1.0
//  \   \        Filename: 
//  /   /        Date Last Modified: 
// /___/   /\    Date Created: 10-sep-06 
// \   \  /  \ 
//  \___\/\___\ 
// 
// Device: 
// Purpose:   
// Reference: 
//----------------------------------------------------------------------------
 
//   
//*****************************************************************************
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
//              provided to you "as is." Xilinx and its licensors make and you
//              receive no warranties or conditions, express, implied,
//              statutory or otherwise, and Xilinx specifically disclaims any
//              implied warranties of merchantability, no infringement, or
//              fitness for a particular purpose. Xilinx does not warrant that
//              the functions contained in these designs will meet your
//              requirements, or that the operation of these designs will be
//              uninterrupted or error free, or that defects in the Designs
//              will be corrected. Furthermore, Xilinx does not warrant or
//              make any representations regarding use or the results of the
//              use of the designs in terms of correctness, accuracy,
//              reliability, or otherwise.
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its
//              licensors be liable for any loss of data, lost profits, cost
//              or procurement of substitute goods or services, or for any
//              special, incidental, consequential, or indirect damages
//              arising from the use or operation of the designs or
//              accompanying documentation, however caused and on any theory
//              of liability. This limitation will apply even if Xilinx
//              has been advised of the possibility of such damage. This
//              limitation shall apply notwithstanding the failure of the
//              essential purpose of any limited remedies herein.
//
//*****************************************************************************/


/* mpeg2dec.c, main(), initialization, option processing                    */

/* Copyright (C) 1996, MPEG Software Simulation Group. All Rights Reserved. */

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  The MPEG Software Simulation Group disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 * The MPEG Software Simulation Group does not represent or warrant that the
 * programs furnished hereunder are free of infringement of any third-party
 * patents.
 *
 * Commercial implementations of MPEG-1 and MPEG-2 video, including shareware,
 * are subject to royalty fees to patent holders.  Many of these patents are
 * general enough such that they are unavoidable regardless of implementation
 * design.
 * 
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <fcntl.h>

#define GLOBAL
#include "config.h"
#include "global.h"
#include "xpseudo_asm_gcc.h"

/* private prototypes */
static int  video_sequence _ANSI_ARGS_((int *framenum));
static int Decode_Bitstream _ANSI_ARGS_((void));
static int  Headers _ANSI_ARGS_((void));
static void Initialize_Sequence _ANSI_ARGS_((void));
static void Initialize_Decoder _ANSI_ARGS_((void));
static void Deinitialize_Sequence _ANSI_ARGS_((void));
static void Process_Options _ANSI_ARGS_((int argc, char *argv[]));


/* #define DEBUG */
static void Clear_Options();


//int main(argc,argv)
//int argc;
//char *argv[];
int main()
{

/******work around for standalone environment*******/
  int argc = 5 ;
  char *argv[5] = 
  {"./mpeg2decode", 
   "-b", 
   "testvideo/f14a.vob", 
   "-o3",   //3-no display 4-display to x11
   "log"};
  
  int ret, code;

  Clear_Options();

  printf("\n\n*************mpeg2decode() start!****************\n");


  /* decode command line arguments */
  Process_Options(argc,argv);

#ifdef DEBUG 
  //Print_Options(); 
#endif

  ld = &base; /* select base layer context */
 

#ifdef STANDALONE
   #define TFT_DEVICE_ID 0
	#include "bootload_basicgraphics.h"
	#include "xtft.h"
	#include "xtft_l.h"
	#include "xparameters.h"
	#include "xuartns550_l.h"
	#include "xcache_l.h"
	#include "xgpio_l.h"
	#include "sleep.h"
	#include "string.h"
	#include "stop_watch.h"
	#include <co.h>

	XUartNs550_SetBaud(XPAR_XPS_UART16550_0_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 9600);
	XUartNs550_mSetLineControlReg(XPAR_XPS_UART16550_0_BASEADDR, XUN_LCR_8_DATA_BITS);

	Dram_File = Dummy = 0x3000000; //xmd load video file to 0x3000000

	printf("Running Standalone mode, video data @ 0x%x\n", Dram_File);
   base.Infile = 3;//hack!!!
   //enable caches for DDR and BRAMs, MSB -> lowest 128MB?
  	XCache_EnableICache(0x80000001);
  	XCache_EnableDCache(0x80000001); 
  	//XCache_EnableICache(0x70000001);
  	//XCache_EnableDCache(0x78000001);    //display information on the LCD screen
	#ifdef XPAR_OPTIONAL_BASEADDR
      char line1[17], line2[17]; // LCD Output buffers
		LCD_Init();
		strcpy (line1, "Mpeg1/2  Decoder");
		strcpy (line2, " s/w v.s. hybrid");
		LCD_Write (line1, line2);
	#endif
	// Initialize TFT display 
	printf("initializing TFT \n");
	printf("mfdcr(XPAR_PLBV46_DVI_CNTLR_0_DCR_BASEADDR) = 0x%08x\n", mfdcr(XPAR_PLBV46_DVI_CNTLR_0_DCR_BASEADDR) );
	XTft_Initialize(&Tft, TFT_DEVICE_ID);
	printf("Tft->BaseAddress = 0x%p\n", Tft.BaseAddress );
   XTft_SetPos(&Tft, 46, 195);
   XTft_WriteColorString(&Tft, "Init color table...", 0xFF0000, 0x00000000);
	printf("initializing TFT done! \n");
   XTft_SetPos(&Tft, 46, 195);
   XTft_WriteColorString(&Tft, "                   ", 0xFF0000, 0x00000000);
   XTft_SetPos(&Tft, 200, 15);
	XTft_WriteColorString(&Tft,"Virtex-5 MPEG1/2 DECODE", 0xFFF0F0, 0x00000000);
	XTft_DrawSolidBox(&Tft, 270, 45, 610, 305, 0xd0d0d0);
   XTft_SetPos(&Tft, 100, 150);
	XTft_DrawSolidBox(&Tft, 97, 112, 222, 114, 0xa000ff);
	XTft_BlinkingString(&Tft, "SOFTWARE ONLY -", 0xff00ff, 0x00000000,5, 100, 100);
//APU init
	opmode = 1; //0-sw, 1-hw
	printf("init APU \n");
	impc_init_IDCT();

  
#else
  
  //for running on OS
  /* open MPEG base layer bitstream file(s) */
  /* NOTE: this is either a base layer stream or a spatial enhancement stream */

   if ((base.Infile=open(Main_Bitstream_Filename,O_RDONLY|O_BINARY))<0)
   {
     fprintf(stderr,"Base layer input file %s not found\n", Main_Bitstream_Filename);
     exit(1);
   }
   Dram_File = (unsigned char*)malloc(1024*1024);
   Dummy = Dram_File;
   read(base.Infile, Dram_File, (1024*1024));
   close(base.Infile);
#endif
  
  if(base.Infile != 0)
  {
    Initialize_Buffer(); 
  
    if(Show_Bits(8)==0x47)
    {
      sprintf(Error_Text,"Decoder currently does not parse transport streams\n");
      Error(Error_Text);
    }

    next_start_code();
    code = Show_Bits(32);
    switch(code)
    {
    case SEQUENCE_HEADER_CODE:
      break;
    case PACK_START_CODE:
      System_Stream_Flag = 1;
    case VIDEO_ELEMENTARY_STREAM:
      System_Stream_Flag = 1;
      break;
    default:
      sprintf(Error_Text,"Unable to recognize stream type\n");
      Error(Error_Text);
      break;
    }
    Dram_File = Dummy;
    Initialize_Buffer(); 
  }

  if(base.Infile!=0) 
  {
    //lseek(base.Infile, 0l, 0);
    Dram_File=Dummy;
  }

  Initialize_Buffer(); 


  if(Two_Streams)
  {
    printf("TWO Streams! \n");
    ld = &enhan; // select enhancement layer context 

    if ((enhan.Infile = open(Enhancement_Layer_Bitstream_Filename,O_RDONLY|O_BINARY))<0)
    {
      sprintf(Error_Text,"enhancment layer bitstream file %s not found\n",
        Enhancement_Layer_Bitstream_Filename);

      Error(Error_Text);
    }

    Initialize_Buffer();
    ld = &base;
  }
  
  Initialize_Decoder();

/*************the loop for embedded routine, no returns*******************/
static loopcnt = 0;
opmode = 1;
while(1)
{
  loopcnt++;
  opmode = !(loopcnt & 0x1); //toggle hw and sw modes
  char stringt[256];
  Cnt = 0;
  Dram_File=Dummy;
  Initialize_Buffer(); 
#ifdef STANDALONE
	stop_watch(1,1);
   stop_watch(0,2);
	stop_watch(0,3);
#endif

   ret = Decode_Bitstream();

#ifdef STANDALONE
   //calculate and print statistics
   float time = stop_watch(4,1);
	float frt;
   float dct_percent = (float)stop_watch(6,2)/time;
	float ccvt_percent = (float)stop_watch(6,3)/time;
	
	static float last_idct_time;
	static float last_color_conv_time;
	static float last_frame_rate;
	float ccvt_abstime, idct_abstime, overall_gain;
	
	ccvt_abstime = (float)stop_watch(6,3)/1000;
	idct_abstime = (float)stop_watch(6,2)/1000;
	
	float idct_gain, color_conv_gain;
	int in_file_size = (Dram_File - Dummy)/1024*8;
	int offset;
	int offsetx=40;
   frt = PBlength*1000000/time;
	printf("total time = %3.2f\n",time/1000000);
   printf("dct percent = %2.3f%%, %d ms\n",dct_percent*100, time/1000000);
	
	XTft_DrawSolidBox(&Tft, 270, 45, 610, 305, 0xd0d0d0);
	if(opmode)
	{
		XTft_BlinkingString(&Tft, "SOFTWARE ONLY -   ", 0xFF00FF, 0x00000000,5, 100, 100);
	}else{
		XTft_BlinkingString(&Tft, "APU ACCELERATED -", 0xFF00FF, 0x00000000,5, 100, 100);
   }
	 
	if(!opmode)offset=305; else offset=390;
	XTft_DrawSolidBox(&Tft, 40, 395, 520, 398, 0xa0ffff);
	if(!opmode)
	{
		sprintf(stringt, "loop time ======== %3.2f sec for %d frames, software only", time/1000000, PBlength);
		printf("     IDCT(ms/%)\tYUV(ms/%)\tTotal(s)\tFPS\n");
		printf("CPU: %5.1f/%2.1f\t%5.1f/%2.1f\t%2.2f\t%2.2f\n", 
					idct_abstime, dct_percent*100,
					ccvt_abstime, ccvt_percent*100,
					time/1000000,
					frt);
   }else{
		idct_gain = last_idct_time / idct_abstime;
		color_conv_gain = last_color_conv_time / ccvt_abstime;
		overall_gain = frt/last_frame_rate;
		sprintf(stringt, "  IDCT    acceleration = %1.2f X", idct_gain);
		XTft_SetPos(&Tft, 0, 175);
		XTft_WriteColorString(&Tft, stringt, 0xFFFF00, 0x00000000);
		sprintf(stringt, "  YUV-RGB acceleration = %1.2f X", color_conv_gain);
		XTft_SetPos(&Tft, 0, 195);
		XTft_WriteColorString(&Tft, stringt, 0x00FFFF, 0x00000000);
		sprintf(stringt, "  Overall acceleration = %1.2f X", overall_gain);
		XTft_SetPos(&Tft, 0, 215);
		XTft_WriteColorString(&Tft, stringt, 0x00a000, 0x00000000);
		sprintf(stringt, "loop time ======== %3.2f sec for %d frames, APU accelerated", time/1000000, PBlength);
		
		printf("FPGA: %5.1f/%2.1f\t%5.1f/%2.1f\t%2.2f\t%2.2f\n", 
					idct_abstime, dct_percent*100,
					ccvt_abstime, ccvt_percent*100,
					time/1000000,
					frt);


	}
#if 1
	XTft_SetPos(&Tft, offsetx, offset+15);
   XTft_WriteColorString(&Tft, stringt, 0xFFFF00, 0x00000000);
   sprintf(stringt, "frame rate ======= %2.2f frames/sec", frt);
   XTft_SetPos(&Tft, offsetx, offset+30);
   XTft_WriteColorString(&Tft, stringt, 0x00FF00, 0x00000000);
	sprintf(stringt, "idct time  ======= %2.1f%%, %5.1f ms   ",dct_percent*100, idct_abstime);
   XTft_SetPos(&Tft, offsetx, offset+45);
   XTft_WriteColorString(&Tft, stringt, 0x00FFFF, 0x00000000);
	sprintf(stringt, "color conversion = %2.1f%%, %5.1f ms   ",ccvt_percent*100, ccvt_abstime);
   XTft_SetPos(&Tft, offsetx, offset+60);
   XTft_WriteColorString(&Tft, stringt, 0x00FFFF, 0x00000000);
	sprintf(stringt, "average bitrate  = %d kb/sec",in_file_size/(int)(time/1000000));
   XTft_SetPos(&Tft, offsetx, offset+75);
   XTft_WriteColorString(&Tft, stringt, 0xFFFFFF, 0x00000000);
#endif 

#endif
	last_idct_time = idct_abstime;
	last_color_conv_time = ccvt_abstime;
	last_frame_rate = (frt);

}
  
#ifndef STANDALONE
  free(Dummy); //free the pointer to the source data
  //close(base.Infile);
  //if (Two_Streams)close(enhan.Infile);
#endif
  return 0;
}

/* IMPLEMENTAION specific rouintes */
static void Initialize_Decoder()
{
  int i;

  /* Clip table */
  if (!(Clip=(unsigned char *)malloc(1024)))
    Error("Clip[] malloc failed\n");

  Clip += 384;

  for (i=-384; i<640; i++)
    Clip[i] = (i<0) ? 0 : ((i>255) ? 255 : i);

  /* IDCT */
  if (Reference_IDCT_Flag)
    Initialize_Reference_IDCT();
  else
    Initialize_Fast_IDCT();

}

/* mostly IMPLEMENTAION specific rouintes */
static void Initialize_Sequence()
{
  int cc, size;
  static int Table_6_20[3] = {6,8,12};

  /* check scalability mode of enhancement layer */
  if (Two_Streams && (enhan.scalable_mode!=SC_SNR) && (base.scalable_mode!=SC_DP))
    Error("unsupported scalability mode\n");

  /* force MPEG-1 parameters for proper decoder behavior */
  /* see ISO/IEC 13818-2 section D.9.14 */
  if (!base.MPEG2_Flag)
  {
    progressive_sequence = 1;
    progressive_frame = 1;
    picture_structure = FRAME_PICTURE;
    frame_pred_frame_dct = 1;
    chroma_format = CHROMA420;
    matrix_coefficients = 5;
  }

  /* round to nearest multiple of coded macroblocks */
  /* ISO/IEC 13818-2 section 6.3.3 sequence_header() */
  mb_width = (horizontal_size+15)/16;
  mb_height = (base.MPEG2_Flag && !progressive_sequence) ? 2*((vertical_size+31)/32)
                                        : (vertical_size+15)/16;

  Coded_Picture_Width = 16*mb_width;
  Coded_Picture_Height = 16*mb_height;

  /* ISO/IEC 13818-2 sections 6.1.1.8, 6.1.1.9, and 6.1.1.10 */
  Chroma_Width = (chroma_format==CHROMA444) ? Coded_Picture_Width
                                           : Coded_Picture_Width>>1;
  Chroma_Height = (chroma_format!=CHROMA420) ? Coded_Picture_Height
                                            : Coded_Picture_Height>>1;
  
  /* derived based on Table 6-20 in ISO/IEC 13818-2 section 6.3.17 */
  block_count = Table_6_20[chroma_format-1];

  for (cc=0; cc<3; cc++)
  {
    if (cc==0)
      size = Coded_Picture_Width*Coded_Picture_Height;
    else
      size = Chroma_Width*Chroma_Height;

    if (!(backward_reference_frame[cc] = (unsigned char *)memalign(16,size)))
      Error("backward_reference_frame[] malloc failed\n");

    if (!(forward_reference_frame[cc] = (unsigned char *)memalign(16,size)))
      Error("forward_reference_frame[] malloc failed\n");

    if (!(auxframe[cc] = (unsigned char *)memalign(16,size)))
      Error("auxframe[] malloc failed\n");

    if(Ersatz_Flag)
      if (!(substitute_frame[cc] = (unsigned char *)malloc(size)))
        Error("substitute_frame[] malloc failed\n");


    if (base.scalable_mode==SC_SPAT)
    {
      /* this assumes lower layer is 4:2:0 */
      if (!(llframe0[cc] = (unsigned char *)malloc((lower_layer_prediction_horizontal_size*lower_layer_prediction_vertical_size)/(cc?4:1))))
        Error("llframe0 malloc failed\n");
      if (!(llframe1[cc] = (unsigned char *)malloc((lower_layer_prediction_horizontal_size*lower_layer_prediction_vertical_size)/(cc?4:1))))
        Error("llframe1 malloc failed\n");
    }
  }

  /* SCALABILITY: Spatial */
  if (base.scalable_mode==SC_SPAT)
  {
    if (!(lltmp = (short *)malloc(lower_layer_prediction_horizontal_size*((lower_layer_prediction_vertical_size*vertical_subsampling_factor_n)/vertical_subsampling_factor_m)*sizeof(short))))
      Error("lltmp malloc failed\n");
  }

#ifdef DISPLAY
  if (Output_Type==T_X11)
  {
    Initialize_Display_Process("");
    Initialize_Dither_Matrix();
  }
#endif /* DISPLAY */

}

void Error(text)
char *text;
{
  fprintf(stderr,text);
  exit(1);
}

/* Trace_Flag output */
void Print_Bits(code,bits,len)
int code,bits,len;
{
  int i;
  for (i=0; i<len; i++)
    printf("%d",(code>>(bits-1-i))&1);
}

/* option processing */
static void Process_Options(argc,argv)
int argc;                  /* argument count  */
char *argv[];              /* argument vector */
{
  int i, LastArg, NextArg;

  /* at least one argument should be present */
  if (argc<2)
  {
    printf("\n%s, %s\n",Version,Author);
    printf("Usage:  mpeg2decode {options}\n\
Options: -b  file  main bitstream (base or spatial enhancement layer)\n\
         -cn file  conformance report (n: level)\n\
         -e  file  enhancement layer bitstream (SNR or Data Partitioning)\n\
         -f        store/display interlaced video in frame format\n\
         -g        concatenated file format for substitution method (-x)\n\
         -in file  information & statistics report  (n: level)\n\
         -l  file  file name pattern for lower layer sequence\n\
                   (for spatial scalability)\n\
         -on file  output format (0:YUV 1:SIF 2:TGA 3:PPM 4:X11 5:X11HiQ)\n\
         -q        disable warnings to stderr\n\
         -r        use double precision reference IDCT\n\
         -t        enable low level tracing to stdout\n\
         -u  file  print user_data to stdio or file\n\
         -vn       verbose output (n: level)\n\
         -x  file  filename pattern of picture substitution sequence\n\n\
File patterns:  for sequential filenames, \"printf\" style, e.g. rec%%d\n\
                 or rec%%d%%c for fieldwise storage\n\
Levels:        0:none 1:sequence 2:picture 3:slice 4:macroblock 5:block\n\n\
Example:       mpeg2decode -b bitstream.mpg -f -r -o0 rec%%d\n\
         \n");
    exit(0);
  }


  Output_Type = -1;
  i = 1;

  /* command-line options are proceeded by '-' */

  while(i < argc)
  {
    /* check if this is the last argument */
    LastArg = ((argc-i)==1);

    /* parse ahead to see if another flag immediately follows current
       argument (this is used to tell if a filename is missing) */
    if(!LastArg)
      NextArg = (argv[i+1][0]=='-');
    else
      NextArg = 0;

    /* second character, [1], after '-' is the switch */
    if(argv[i][0]=='-')
    {
      switch(toupper(argv[i][1]))
      {
        /* third character. [2], is the value */
      case 'B':
        Main_Bitstream_Flag = 1;

        if(NextArg || LastArg)
        {
          printf("ERROR: -b must be followed the main bitstream filename\n");
	}
        else
          Main_Bitstream_Filename = argv[++i]; 

        break;


      case 'C':

#ifdef VERIFY
        Verify_Flag = atoi(&argv[i][2]); 

        if((Verify_Flag < NO_LAYER) || (Verify_Flag > ALL_LAYERS))
        {
          printf("ERROR: -c level (%d) out of range [%d,%d]\n",
            Verify_Flag, NO_LAYER, ALL_LAYERS);
          exit(ERROR);
        }
#else  /* VERIFY */
        printf("This program not compiled for Verify_Flag option\n");
#endif /* VERIFY */
        break;

      case 'E':
        Two_Streams = 1; /* either Data Partitioning (DP) or SNR Scalability enhancment */
	                   
        if(NextArg || LastArg)
        {
          printf("ERROR: -e must be followed by filename\n");
          exit(ERROR);
        }
        else
          Enhancement_Layer_Bitstream_Filename = argv[++i]; 

        break;


      case 'F':
        Frame_Store_Flag = 1;
        break;

      case 'G':
        Big_Picture_Flag = 1;
        break;


      case 'I':
#ifdef VERIFY
        Stats_Flag = atoi(&argv[i][2]); 
#else /* VERIFY */
        printf("WARNING: This program not compiled for -i option\n");
#endif /* VERIFY */     
        break;
    
      case 'L':  /* spatial scalability flag */
        Spatial_Flag = 1;

       if(NextArg || LastArg)
       {
         printf("ERROR: -l must be followed by filename\n");
         exit(ERROR);
       }
       else
         Lower_Layer_Picture_Filename = argv[++i]; 

        break;

      case 'O':
  
        Output_Type = atoi(&argv[i][2]); 
  
        if((Output_Type==4) || (Output_Type==5))
          Output_Picture_Filename = "";  /* no need of filename */
        else if(NextArg || LastArg)  
        {
          printf("ERROR: -o must be followed by filename\n");
          exit(ERROR);
        }
        else
        /* filename is separated by space, so it becomes the next argument */
          Output_Picture_Filename = argv[++i]; 

#ifdef DISPLAY
        if (Output_Type==T_X11HIQ)
        {
          hiQdither = 1;
          Output_Type=T_X11;
        }
#endif /* DISPLAY */
        break;

      case 'Q':
        Quiet_Flag = 1;
        break;

      case 'R':
        Reference_IDCT_Flag = 1;
        break;
    
      case 'T':
#ifdef TRACE
        Trace_Flag = 1;
#else /* TRACE */
        printf("WARNING: This program not compiled for -t option\n");
#endif /* TRACE */
        break;

      case 'U':
        User_Data_Flag = 1;

      case 'V':
#ifdef VERBOSE
        Verbose_Flag = atoi(&argv[i][2]); 
#else /* VERBOSE */
        printf("This program not compiled for -v option\n");
#endif /* VERBOSE */
        break;


      case 'X':
        Ersatz_Flag = 1;

       if(NextArg || LastArg)
       {
         printf("ERROR: -x must be followed by filename\n"); 
         exit(ERROR);
       }
       else
        Substitute_Picture_Filename = argv[++i]; 

        break;



      default:
        fprintf(stderr,"undefined option -%c ignored. Exiting program\n", 
          argv[i][1]);

        exit(ERROR);
    
      } /* switch() */
    } /* if argv[i][0] == '-' */
    
    i++;

  	/* check for bitstream filename argument (there must always be one, at the very end
	   of the command line arguments */

  } /* while() */


  /* options sense checking */

  if(Main_Bitstream_Flag!=1)
  {
    printf("There must be a main bitstream specified (-b filename)\n");
  }

  /* force display process to show frame pictures */
  if((Output_Type==4 || Output_Type==5) && Frame_Store_Flag)
    Display_Progressive_Flag = 1;
  else
    Display_Progressive_Flag = 0;

#ifdef VERIFY
  /* parse the bitstream, do not actually decode it completely */
  

#if 0
  if(Output_Type==-1)
  {
    Decode_Layer = Verify_Flag;
    printf("FYI: Decoding bitstream elements up to: %s\n", 
      Layer_Table[Decode_Layer]);
  }
  else
#endif
    Decode_Layer = ALL_LAYERS;

#endif /* VERIFY */

  /* no output type specified */
  if(Output_Type==-1)
  {
    Output_Type = 9; 
    Output_Picture_Filename = "";
  }


#ifdef DISPLAY
  if (Output_Type==T_X11)
  {
    if(Frame_Store_Flag)
      Display_Progressive_Flag = 1;
    else
      Display_Progressive_Flag = 0;

    Frame_Store_Flag = 1; /* to avoid calling dither() twice */
  }
#endif


}




static int Headers()
{
  int ret;

  ld = &base;
  

  /* return when end of sequence (0) or picture
     header has been parsed (1) */

  ret = Get_Hdr();


  if (Two_Streams)
  {
    ld = &enhan;
    if (Get_Hdr()!=ret && !Quiet_Flag)
      fprintf(stderr,"streams out of sync\n");
    ld = &base;
  }

  return ret;
}



static int Decode_Bitstream()
{
  int ret;
  int Bitstream_Framenum;

  Bitstream_Framenum = 0;

  //static frame_cnt=0;
  for(;;)
  {

    ret = Headers();
    
    if(ret==1)
    {
      //printf("frame: ");
      ret = video_sequence(&Bitstream_Framenum);
    }
    else
      return(ret);
  }

}


static void Deinitialize_Sequence()
{
  int i;

  /* clear flags */
  base.MPEG2_Flag=0;


  //printf("free memory!!! \n");
  for(i=0;i<3;i++)
  {
    free(backward_reference_frame[i]);
    free(forward_reference_frame[i]);
    free(auxframe[i]);

    if (base.scalable_mode==SC_SPAT)
    {
     free(llframe0[i]);
     free(llframe1[i]);
    }
  }

  if (base.scalable_mode==SC_SPAT)
    free(lltmp);

#ifdef DISPLAY
  if (Output_Type==T_X11) 
    Terminate_Display_Process();
#endif
}


static int video_sequence(Bitstream_Framenumber)
int *Bitstream_Framenumber;
{
  int Bitstream_Framenum;
  int Sequence_Framenum;
  int Return_Value;

  Bitstream_Framenum = *Bitstream_Framenumber;
  Sequence_Framenum=0;

  Initialize_Sequence();

  /* decode picture whose header has already been parsed in 
     Decode_Bitstream() */


  Decode_Picture(Bitstream_Framenum, Sequence_Framenum);

  /* update picture numbers */
  if (!Second_Field)
  {
    Bitstream_Framenum++;
    Sequence_Framenum++;
  }



  /* loop through the rest of the pictures in the sequence */
  while ((Return_Value=Headers()))
  {
    Decode_Picture(Bitstream_Framenum, Sequence_Framenum);

    if (!Second_Field)
    {
      Bitstream_Framenum++;
      Sequence_Framenum++;
    }
   
  }

  /* put last frame */
  if (Sequence_Framenum!=0)
  {
    Output_Last_Frame_of_Sequence(Bitstream_Framenum);
  }

  Deinitialize_Sequence();

  *Bitstream_Framenumber = Bitstream_Framenum;
  return(Return_Value);
}



static void Clear_Options()
{
  Verbose_Flag = 0;
  Output_Type = 0;
  Output_Picture_Filename = " ";
  hiQdither  = 0;
  Output_Type = 0;
  Frame_Store_Flag = 0;
  Spatial_Flag = 0;
  Lower_Layer_Picture_Filename = " ";
  Reference_IDCT_Flag = 0;
  Trace_Flag = 0;
  Quiet_Flag = 0;
  Ersatz_Flag = 0;
  Substitute_Picture_Filename  = " ";
  Two_Streams = 0;
  Enhancement_Layer_Bitstream_Filename = " ";
  Big_Picture_Flag = 0;
  Main_Bitstream_Flag = 0;
  Main_Bitstream_Filename = " ";
  Verify_Flag = 0;
  Stats_Flag  = 0;
  User_Data_Flag = 0; 
}


