#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "co.h"

#ifdef IMPULSE_C_TARGET
#include "xparameters.h"
#include "xcache_l.h"

#define printf xil_printf
#endif

#include "yuv_test.h"

void print_rgb(co_uint32 *buf)

{
  int i;

  for (i=0; i<8; i++) {
    printf("%06x ",buf[i]);
  }
  printf("\r\n");
}

void yuv_check()
{
  int i,j,ok,failed;
  co_int32 YY;
  co_int16 UU,VV;
  co_int32 R,G,B;
  co_uint32 expected[32];
  co_uint32 *fbuf=(co_uint32 *) 0x0100000;
  co_uint32 *outp;

  PUT_QWORD(sw_proc,y_stream,fbuf);
  PUT_QWORD(sw_proc,y_stream,fbuf);
  PUT_QWORD(sw_proc,u_stream,fbuf);
  PUT_QWORD(sw_proc,v_stream,fbuf);
  outp=fbuf;
  for (i=0; i<=NUM_PIXELS; i+=32) {
    PUT_QWORD(sw_proc,y_stream,&y[i]);
    PUT_QWORD(sw_proc,y_stream,&y[i+16]);
    PUT_QWORD(sw_proc,u_stream,&u[i>>1]);
    PUT_QWORD(sw_proc,v_stream,&v[i>>1]);
    GET_QWORD(sw_proc,output_stream,&outp[0]);
    GET_QWORD(sw_proc,output_stream,&outp[4]);
    GET_QWORD(sw_proc,output_stream,&outp[8]);
    GET_QWORD(sw_proc,output_stream,&outp[12]);
    GET_QWORD(sw_proc,output_stream,&outp[16]);
    GET_QWORD(sw_proc,output_stream,&outp[20]);
    GET_QWORD(sw_proc,output_stream,&outp[24]);
    GET_QWORD(sw_proc,output_stream,&outp[28]);
	if (i) outp+=32;
  }

  failed=0;
  outp=fbuf;
  for (i=0; i<NUM_PIXELS; i+=32) {
    ok=1;
    for (j=0; j<32; j++) {
		YY = ((co_int32)y[i+j])<<8;
		UU = ((co_int16)u[(i>>1)+(j>>1)])-128;
		VV = ((co_int16)v[(i>>1)+(j>>1)])-128;
		R=(co_int16)((YY + (351 * VV)) >> 8);
		G=(co_int16)((YY - (179 * VV) - (87 * UU)) >> 8);
		B=(co_int16)((YY + (443 * UU)) >> 8);
		if(R<0)R=0;
		if(G<0)G=0;
		if(B<0)B=0;
		if(R>255)R=255;
		if(G>255)G=255;
		if(B>255)B=255;
		expected[j]=(((co_uint32)R<<16) | ((co_uint32)G<<8) | (co_uint32)B);
		ok=ok&&(outp[j]==expected[j]);
	}
    if (!ok) {
		failed++;
	}
	if (failed==0) {
		if ((i&0xff)==0) {
			printf("block %d\r\n",i>>5);
			print_rgb(outp);
			print_rgb(outp+8);
			print_rgb(outp+16);
			print_rgb(outp+24);
		}
	} else if (!ok&&(failed==1)) {
		printf("failure ");
		printf("block %d\r\n",i>>5);
		print_rgb(expected);
		print_rgb(outp);
		print_rgb(expected+8);
		print_rgb(outp+8);
		print_rgb(expected+16);
		print_rgb(outp+16);
		print_rgb(expected+24);
		print_rgb(outp+24);
	}
    outp+=32;
  }
  if (failed==0)
	printf("passed\r\n");
}

int main(int argc, char **argv)
{
#ifdef IMPULSE_C_TARGET
#ifdef WITH_CACHE
	XCache_EnableDCache(0x80000001);
	XCache_EnableICache(0x80000001);
#endif
#endif

    printf("begin\r\n");
	run_impc();
    printf("done\r\n");
	IF_SIM(getchar();)
    return 0;
}
