-------------------------------------------------------------------------------
-- apu_idct_colorconv_arch_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library apu_idct_colorconv_arch_v1_00_a;
use apu_idct_colorconv_arch_v1_00_a.all;

entity apu_idct_colorconv_arch_0_wrapper is
  port (
    FCMAPURESULT : out std_logic_vector(0 to 31);
    FCMAPUDONE : out std_logic;
    FCMAPUSLEEPNOTREADY : out std_logic;
    FCMAPURESULTVALID : out std_logic;
    FCMAPUCR : out std_logic_vector(0 to 3);
    FCMAPUEXCEPTION : out std_logic;
    FCMAPUSTOREDATA : out std_logic_vector(0 to 127);
    FCMAPUCONFIRMINSTR : out std_logic;
    FCMAPUFPSCRFEX : out std_logic;
    APUFCMINSTRUCTION : in std_logic_vector(0 to 31);
    APUFCMINSTRVALID : in std_logic;
    APUFCMRADATA : in std_logic_vector(0 to 31);
    APUFCMRBDATA : in std_logic_vector(0 to 31);
    APUFCMOPERANDVALID : in std_logic;
    APUFCMFLUSH : in std_logic;
    APUFCMWRITEBACKOK : in std_logic;
    APUFCMLOADDATA : in std_logic_vector(0 to 127);
    APUFCMLOADDVALID : in std_logic;
    APUFCMLOADBYTEADDR : in std_logic_vector(0 to 3);
    APUFCMENDIAN : in std_logic;
    APUFCMDECUDI : in std_logic_vector(0 to 3);
    APUFCMDECUDIVALID : in std_logic;
    APUFCMDECFPUOP : in std_logic;
    APUFCMDECLOAD : in std_logic;
    APUFCMDECSTORE : in std_logic;
    APUFCMDECLDSTXFERSIZE : in std_logic_vector(0 to 2);
    APUFCMDECNONAUTON : in std_logic;
    APUFCMNEXTINSTRREADY : in std_logic;
    udidebug : out std_logic_vector(153 downto 0);
    apu_clk : in std_logic;
    reset : in std_logic
  );

  attribute x_core_info : STRING;
  attribute x_core_info of apu_idct_colorconv_arch_0_wrapper : entity is "apu_idct_colorconv_arch_v1_00_a";

end apu_idct_colorconv_arch_0_wrapper;

architecture STRUCTURE of apu_idct_colorconv_arch_0_wrapper is

  component apu_idct_colorconv_arch is
    generic (
      c_family : string
    );
    port (
      FCMAPURESULT : out std_logic_vector(0 to 31);
      FCMAPUDONE : out std_logic;
      FCMAPUSLEEPNOTREADY : out std_logic;
      FCMAPURESULTVALID : out std_logic;
      FCMAPUCR : out std_logic_vector(0 to 3);
      FCMAPUEXCEPTION : out std_logic;
      FCMAPUSTOREDATA : out std_logic_vector(0 to 127);
      FCMAPUCONFIRMINSTR : out std_logic;
      FCMAPUFPSCRFEX : out std_logic;
      APUFCMINSTRUCTION : in std_logic_vector(0 to 31);
      APUFCMINSTRVALID : in std_logic;
      APUFCMRADATA : in std_logic_vector(0 to 31);
      APUFCMRBDATA : in std_logic_vector(0 to 31);
      APUFCMOPERANDVALID : in std_logic;
      APUFCMFLUSH : in std_logic;
      APUFCMWRITEBACKOK : in std_logic;
      APUFCMLOADDATA : in std_logic_vector(0 to 127);
      APUFCMLOADDVALID : in std_logic;
      APUFCMLOADBYTEADDR : in std_logic_vector(0 to 3);
      APUFCMENDIAN : in std_logic;
      APUFCMDECUDI : in std_logic_vector(0 to 3);
      APUFCMDECUDIVALID : in std_logic;
      APUFCMDECFPUOP : in std_logic;
      APUFCMDECLOAD : in std_logic;
      APUFCMDECSTORE : in std_logic;
      APUFCMDECLDSTXFERSIZE : in std_logic_vector(0 to 2);
      APUFCMDECNONAUTON : in std_logic;
      APUFCMNEXTINSTRREADY : in std_logic;
      udidebug : out std_logic_vector(153 downto 0);
      apu_clk : in std_logic;
      reset : in std_logic
    );
  end component;

begin

  apu_idct_colorconv_arch_0 : apu_idct_colorconv_arch
    generic map (
      c_family => "virtex5"
    )
    port map (
      FCMAPURESULT => FCMAPURESULT,
      FCMAPUDONE => FCMAPUDONE,
      FCMAPUSLEEPNOTREADY => FCMAPUSLEEPNOTREADY,
      FCMAPURESULTVALID => FCMAPURESULTVALID,
      FCMAPUCR => FCMAPUCR,
      FCMAPUEXCEPTION => FCMAPUEXCEPTION,
      FCMAPUSTOREDATA => FCMAPUSTOREDATA,
      FCMAPUCONFIRMINSTR => FCMAPUCONFIRMINSTR,
      FCMAPUFPSCRFEX => FCMAPUFPSCRFEX,
      APUFCMINSTRUCTION => APUFCMINSTRUCTION,
      APUFCMINSTRVALID => APUFCMINSTRVALID,
      APUFCMRADATA => APUFCMRADATA,
      APUFCMRBDATA => APUFCMRBDATA,
      APUFCMOPERANDVALID => APUFCMOPERANDVALID,
      APUFCMFLUSH => APUFCMFLUSH,
      APUFCMWRITEBACKOK => APUFCMWRITEBACKOK,
      APUFCMLOADDATA => APUFCMLOADDATA,
      APUFCMLOADDVALID => APUFCMLOADDVALID,
      APUFCMLOADBYTEADDR => APUFCMLOADBYTEADDR,
      APUFCMENDIAN => APUFCMENDIAN,
      APUFCMDECUDI => APUFCMDECUDI,
      APUFCMDECUDIVALID => APUFCMDECUDIVALID,
      APUFCMDECFPUOP => APUFCMDECFPUOP,
      APUFCMDECLOAD => APUFCMDECLOAD,
      APUFCMDECSTORE => APUFCMDECSTORE,
      APUFCMDECLDSTXFERSIZE => APUFCMDECLDSTXFERSIZE,
      APUFCMDECNONAUTON => APUFCMDECNONAUTON,
      APUFCMNEXTINSTRREADY => APUFCMNEXTINSTRREADY,
      udidebug => udidebug,
      apu_clk => apu_clk,
      reset => reset
    );

end architecture STRUCTURE;

