//-----------------------------------------------------------------------------
// xps_bram_if_cntlr_1_bram_elaborate.v
//-----------------------------------------------------------------------------

module xps_bram_if_cntlr_1_bram_elaborate
  (
    BRAM_Rst_A,
    BRAM_Clk_A,
    BRAM_EN_A,
    BRAM_WEN_A,
    BRAM_Addr_A,
    BRAM_Din_A,
    BRAM_Dout_A,
    BRAM_Rst_B,
    BRAM_Clk_B,
    BRAM_EN_B,
    BRAM_WEN_B,
    BRAM_Addr_B,
    BRAM_Din_B,
    BRAM_Dout_B
  );
  parameter
    C_MEMSIZE = 'h10000,
    C_PORT_DWIDTH = 128,
    C_PORT_AWIDTH = 32,
    C_NUM_WE = 16,
    C_FAMILY = "virtex5";
  input BRAM_Rst_A;
  input BRAM_Clk_A;
  input BRAM_EN_A;
  input [0:C_NUM_WE-1] BRAM_WEN_A;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_A;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_A;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_A;
  input BRAM_Rst_B;
  input BRAM_Clk_B;
  input BRAM_EN_B;
  input [0:C_NUM_WE-1] BRAM_WEN_B;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_B;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_B;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_B;

  // Internal signals

  wire net_gnd0;
  wire [3:0] net_gnd4;
  wire [0:0] pgassign1;
  wire [0:2] pgassign2;
  wire [0:23] pgassign3;
  wire [15:0] pgassign4;
  wire [31:0] pgassign5;
  wire [31:0] pgassign6;
  wire [3:0] pgassign7;
  wire [15:0] pgassign8;
  wire [31:0] pgassign9;
  wire [31:0] pgassign10;
  wire [3:0] pgassign11;
  wire [15:0] pgassign12;
  wire [31:0] pgassign13;
  wire [31:0] pgassign14;
  wire [3:0] pgassign15;
  wire [15:0] pgassign16;
  wire [31:0] pgassign17;
  wire [31:0] pgassign18;
  wire [3:0] pgassign19;
  wire [15:0] pgassign20;
  wire [31:0] pgassign21;
  wire [31:0] pgassign22;
  wire [3:0] pgassign23;
  wire [15:0] pgassign24;
  wire [31:0] pgassign25;
  wire [31:0] pgassign26;
  wire [3:0] pgassign27;
  wire [15:0] pgassign28;
  wire [31:0] pgassign29;
  wire [31:0] pgassign30;
  wire [3:0] pgassign31;
  wire [15:0] pgassign32;
  wire [31:0] pgassign33;
  wire [31:0] pgassign34;
  wire [3:0] pgassign35;
  wire [15:0] pgassign36;
  wire [31:0] pgassign37;
  wire [31:0] pgassign38;
  wire [3:0] pgassign39;
  wire [15:0] pgassign40;
  wire [31:0] pgassign41;
  wire [31:0] pgassign42;
  wire [3:0] pgassign43;
  wire [15:0] pgassign44;
  wire [31:0] pgassign45;
  wire [31:0] pgassign46;
  wire [3:0] pgassign47;
  wire [15:0] pgassign48;
  wire [31:0] pgassign49;
  wire [31:0] pgassign50;
  wire [3:0] pgassign51;
  wire [15:0] pgassign52;
  wire [31:0] pgassign53;
  wire [31:0] pgassign54;
  wire [3:0] pgassign55;
  wire [15:0] pgassign56;
  wire [31:0] pgassign57;
  wire [31:0] pgassign58;
  wire [3:0] pgassign59;
  wire [15:0] pgassign60;
  wire [31:0] pgassign61;
  wire [31:0] pgassign62;
  wire [3:0] pgassign63;
  wire [15:0] pgassign64;
  wire [31:0] pgassign65;
  wire [31:0] pgassign66;
  wire [3:0] pgassign67;
  wire [15:0] pgassign68;
  wire [31:0] pgassign69;
  wire [31:0] pgassign70;
  wire [3:0] pgassign71;
  wire [15:0] pgassign72;
  wire [31:0] pgassign73;
  wire [31:0] pgassign74;
  wire [3:0] pgassign75;
  wire [15:0] pgassign76;
  wire [31:0] pgassign77;
  wire [31:0] pgassign78;
  wire [3:0] pgassign79;
  wire [15:0] pgassign80;
  wire [31:0] pgassign81;
  wire [31:0] pgassign82;
  wire [3:0] pgassign83;
  wire [15:0] pgassign84;
  wire [31:0] pgassign85;
  wire [31:0] pgassign86;
  wire [3:0] pgassign87;
  wire [15:0] pgassign88;
  wire [31:0] pgassign89;
  wire [31:0] pgassign90;
  wire [3:0] pgassign91;
  wire [15:0] pgassign92;
  wire [31:0] pgassign93;
  wire [31:0] pgassign94;
  wire [3:0] pgassign95;
  wire [15:0] pgassign96;
  wire [31:0] pgassign97;
  wire [31:0] pgassign98;
  wire [3:0] pgassign99;
  wire [15:0] pgassign100;
  wire [31:0] pgassign101;
  wire [31:0] pgassign102;
  wire [3:0] pgassign103;
  wire [15:0] pgassign104;
  wire [31:0] pgassign105;
  wire [31:0] pgassign106;
  wire [3:0] pgassign107;
  wire [15:0] pgassign108;
  wire [31:0] pgassign109;
  wire [31:0] pgassign110;
  wire [3:0] pgassign111;
  wire [15:0] pgassign112;
  wire [31:0] pgassign113;
  wire [31:0] pgassign114;
  wire [3:0] pgassign115;
  wire [15:0] pgassign116;
  wire [31:0] pgassign117;
  wire [31:0] pgassign118;
  wire [3:0] pgassign119;
  wire [15:0] pgassign120;
  wire [31:0] pgassign121;
  wire [31:0] pgassign122;
  wire [3:0] pgassign123;
  wire [15:0] pgassign124;
  wire [31:0] pgassign125;
  wire [31:0] pgassign126;
  wire [3:0] pgassign127;
  wire [15:0] pgassign128;
  wire [31:0] pgassign129;
  wire [31:0] pgassign130;
  wire [3:0] pgassign131;

  // Internal assignments

  assign pgassign1[0:0] = 1'b1;
  assign pgassign2[0:2] = 3'b000;
  assign pgassign3[0:23] = 24'b000000000000000000000000;
  assign pgassign4[15:15] = 1'b1;
  assign pgassign4[14:3] = BRAM_Addr_A[16:27];
  assign pgassign4[2:0] = 3'b000;
  assign pgassign5[31:8] = 24'b000000000000000000000000;
  assign pgassign5[7:0] = BRAM_Dout_A[0:7];
  assign BRAM_Din_A[0:7] = pgassign6[7:0];
  assign pgassign7[3:3] = BRAM_WEN_A[0:0];
  assign pgassign7[2:2] = BRAM_WEN_A[0:0];
  assign pgassign7[1:1] = BRAM_WEN_A[0:0];
  assign pgassign7[0:0] = BRAM_WEN_A[0:0];
  assign pgassign8[15:15] = 1'b1;
  assign pgassign8[14:3] = BRAM_Addr_B[16:27];
  assign pgassign8[2:0] = 3'b000;
  assign pgassign9[31:8] = 24'b000000000000000000000000;
  assign pgassign9[7:0] = BRAM_Dout_B[0:7];
  assign BRAM_Din_B[0:7] = pgassign10[7:0];
  assign pgassign11[3:3] = BRAM_WEN_B[0:0];
  assign pgassign11[2:2] = BRAM_WEN_B[0:0];
  assign pgassign11[1:1] = BRAM_WEN_B[0:0];
  assign pgassign11[0:0] = BRAM_WEN_B[0:0];
  assign pgassign12[15:15] = 1'b1;
  assign pgassign12[14:3] = BRAM_Addr_A[16:27];
  assign pgassign12[2:0] = 3'b000;
  assign pgassign13[31:8] = 24'b000000000000000000000000;
  assign pgassign13[7:0] = BRAM_Dout_A[8:15];
  assign BRAM_Din_A[8:15] = pgassign14[7:0];
  assign pgassign15[3:3] = BRAM_WEN_A[1:1];
  assign pgassign15[2:2] = BRAM_WEN_A[1:1];
  assign pgassign15[1:1] = BRAM_WEN_A[1:1];
  assign pgassign15[0:0] = BRAM_WEN_A[1:1];
  assign pgassign16[15:15] = 1'b1;
  assign pgassign16[14:3] = BRAM_Addr_B[16:27];
  assign pgassign16[2:0] = 3'b000;
  assign pgassign17[31:8] = 24'b000000000000000000000000;
  assign pgassign17[7:0] = BRAM_Dout_B[8:15];
  assign BRAM_Din_B[8:15] = pgassign18[7:0];
  assign pgassign19[3:3] = BRAM_WEN_B[1:1];
  assign pgassign19[2:2] = BRAM_WEN_B[1:1];
  assign pgassign19[1:1] = BRAM_WEN_B[1:1];
  assign pgassign19[0:0] = BRAM_WEN_B[1:1];
  assign pgassign20[15:15] = 1'b1;
  assign pgassign20[14:3] = BRAM_Addr_A[16:27];
  assign pgassign20[2:0] = 3'b000;
  assign pgassign21[31:8] = 24'b000000000000000000000000;
  assign pgassign21[7:0] = BRAM_Dout_A[16:23];
  assign BRAM_Din_A[16:23] = pgassign22[7:0];
  assign pgassign23[3:3] = BRAM_WEN_A[2:2];
  assign pgassign23[2:2] = BRAM_WEN_A[2:2];
  assign pgassign23[1:1] = BRAM_WEN_A[2:2];
  assign pgassign23[0:0] = BRAM_WEN_A[2:2];
  assign pgassign24[15:15] = 1'b1;
  assign pgassign24[14:3] = BRAM_Addr_B[16:27];
  assign pgassign24[2:0] = 3'b000;
  assign pgassign25[31:8] = 24'b000000000000000000000000;
  assign pgassign25[7:0] = BRAM_Dout_B[16:23];
  assign BRAM_Din_B[16:23] = pgassign26[7:0];
  assign pgassign27[3:3] = BRAM_WEN_B[2:2];
  assign pgassign27[2:2] = BRAM_WEN_B[2:2];
  assign pgassign27[1:1] = BRAM_WEN_B[2:2];
  assign pgassign27[0:0] = BRAM_WEN_B[2:2];
  assign pgassign28[15:15] = 1'b1;
  assign pgassign28[14:3] = BRAM_Addr_A[16:27];
  assign pgassign28[2:0] = 3'b000;
  assign pgassign29[31:8] = 24'b000000000000000000000000;
  assign pgassign29[7:0] = BRAM_Dout_A[24:31];
  assign BRAM_Din_A[24:31] = pgassign30[7:0];
  assign pgassign31[3:3] = BRAM_WEN_A[3:3];
  assign pgassign31[2:2] = BRAM_WEN_A[3:3];
  assign pgassign31[1:1] = BRAM_WEN_A[3:3];
  assign pgassign31[0:0] = BRAM_WEN_A[3:3];
  assign pgassign32[15:15] = 1'b1;
  assign pgassign32[14:3] = BRAM_Addr_B[16:27];
  assign pgassign32[2:0] = 3'b000;
  assign pgassign33[31:8] = 24'b000000000000000000000000;
  assign pgassign33[7:0] = BRAM_Dout_B[24:31];
  assign BRAM_Din_B[24:31] = pgassign34[7:0];
  assign pgassign35[3:3] = BRAM_WEN_B[3:3];
  assign pgassign35[2:2] = BRAM_WEN_B[3:3];
  assign pgassign35[1:1] = BRAM_WEN_B[3:3];
  assign pgassign35[0:0] = BRAM_WEN_B[3:3];
  assign pgassign36[15:15] = 1'b1;
  assign pgassign36[14:3] = BRAM_Addr_A[16:27];
  assign pgassign36[2:0] = 3'b000;
  assign pgassign37[31:8] = 24'b000000000000000000000000;
  assign pgassign37[7:0] = BRAM_Dout_A[32:39];
  assign BRAM_Din_A[32:39] = pgassign38[7:0];
  assign pgassign39[3:3] = BRAM_WEN_A[4:4];
  assign pgassign39[2:2] = BRAM_WEN_A[4:4];
  assign pgassign39[1:1] = BRAM_WEN_A[4:4];
  assign pgassign39[0:0] = BRAM_WEN_A[4:4];
  assign pgassign40[15:15] = 1'b1;
  assign pgassign40[14:3] = BRAM_Addr_B[16:27];
  assign pgassign40[2:0] = 3'b000;
  assign pgassign41[31:8] = 24'b000000000000000000000000;
  assign pgassign41[7:0] = BRAM_Dout_B[32:39];
  assign BRAM_Din_B[32:39] = pgassign42[7:0];
  assign pgassign43[3:3] = BRAM_WEN_B[4:4];
  assign pgassign43[2:2] = BRAM_WEN_B[4:4];
  assign pgassign43[1:1] = BRAM_WEN_B[4:4];
  assign pgassign43[0:0] = BRAM_WEN_B[4:4];
  assign pgassign44[15:15] = 1'b1;
  assign pgassign44[14:3] = BRAM_Addr_A[16:27];
  assign pgassign44[2:0] = 3'b000;
  assign pgassign45[31:8] = 24'b000000000000000000000000;
  assign pgassign45[7:0] = BRAM_Dout_A[40:47];
  assign BRAM_Din_A[40:47] = pgassign46[7:0];
  assign pgassign47[3:3] = BRAM_WEN_A[5:5];
  assign pgassign47[2:2] = BRAM_WEN_A[5:5];
  assign pgassign47[1:1] = BRAM_WEN_A[5:5];
  assign pgassign47[0:0] = BRAM_WEN_A[5:5];
  assign pgassign48[15:15] = 1'b1;
  assign pgassign48[14:3] = BRAM_Addr_B[16:27];
  assign pgassign48[2:0] = 3'b000;
  assign pgassign49[31:8] = 24'b000000000000000000000000;
  assign pgassign49[7:0] = BRAM_Dout_B[40:47];
  assign BRAM_Din_B[40:47] = pgassign50[7:0];
  assign pgassign51[3:3] = BRAM_WEN_B[5:5];
  assign pgassign51[2:2] = BRAM_WEN_B[5:5];
  assign pgassign51[1:1] = BRAM_WEN_B[5:5];
  assign pgassign51[0:0] = BRAM_WEN_B[5:5];
  assign pgassign52[15:15] = 1'b1;
  assign pgassign52[14:3] = BRAM_Addr_A[16:27];
  assign pgassign52[2:0] = 3'b000;
  assign pgassign53[31:8] = 24'b000000000000000000000000;
  assign pgassign53[7:0] = BRAM_Dout_A[48:55];
  assign BRAM_Din_A[48:55] = pgassign54[7:0];
  assign pgassign55[3:3] = BRAM_WEN_A[6:6];
  assign pgassign55[2:2] = BRAM_WEN_A[6:6];
  assign pgassign55[1:1] = BRAM_WEN_A[6:6];
  assign pgassign55[0:0] = BRAM_WEN_A[6:6];
  assign pgassign56[15:15] = 1'b1;
  assign pgassign56[14:3] = BRAM_Addr_B[16:27];
  assign pgassign56[2:0] = 3'b000;
  assign pgassign57[31:8] = 24'b000000000000000000000000;
  assign pgassign57[7:0] = BRAM_Dout_B[48:55];
  assign BRAM_Din_B[48:55] = pgassign58[7:0];
  assign pgassign59[3:3] = BRAM_WEN_B[6:6];
  assign pgassign59[2:2] = BRAM_WEN_B[6:6];
  assign pgassign59[1:1] = BRAM_WEN_B[6:6];
  assign pgassign59[0:0] = BRAM_WEN_B[6:6];
  assign pgassign60[15:15] = 1'b1;
  assign pgassign60[14:3] = BRAM_Addr_A[16:27];
  assign pgassign60[2:0] = 3'b000;
  assign pgassign61[31:8] = 24'b000000000000000000000000;
  assign pgassign61[7:0] = BRAM_Dout_A[56:63];
  assign BRAM_Din_A[56:63] = pgassign62[7:0];
  assign pgassign63[3:3] = BRAM_WEN_A[7:7];
  assign pgassign63[2:2] = BRAM_WEN_A[7:7];
  assign pgassign63[1:1] = BRAM_WEN_A[7:7];
  assign pgassign63[0:0] = BRAM_WEN_A[7:7];
  assign pgassign64[15:15] = 1'b1;
  assign pgassign64[14:3] = BRAM_Addr_B[16:27];
  assign pgassign64[2:0] = 3'b000;
  assign pgassign65[31:8] = 24'b000000000000000000000000;
  assign pgassign65[7:0] = BRAM_Dout_B[56:63];
  assign BRAM_Din_B[56:63] = pgassign66[7:0];
  assign pgassign67[3:3] = BRAM_WEN_B[7:7];
  assign pgassign67[2:2] = BRAM_WEN_B[7:7];
  assign pgassign67[1:1] = BRAM_WEN_B[7:7];
  assign pgassign67[0:0] = BRAM_WEN_B[7:7];
  assign pgassign68[15:15] = 1'b1;
  assign pgassign68[14:3] = BRAM_Addr_A[16:27];
  assign pgassign68[2:0] = 3'b000;
  assign pgassign69[31:8] = 24'b000000000000000000000000;
  assign pgassign69[7:0] = BRAM_Dout_A[64:71];
  assign BRAM_Din_A[64:71] = pgassign70[7:0];
  assign pgassign71[3:3] = BRAM_WEN_A[8:8];
  assign pgassign71[2:2] = BRAM_WEN_A[8:8];
  assign pgassign71[1:1] = BRAM_WEN_A[8:8];
  assign pgassign71[0:0] = BRAM_WEN_A[8:8];
  assign pgassign72[15:15] = 1'b1;
  assign pgassign72[14:3] = BRAM_Addr_B[16:27];
  assign pgassign72[2:0] = 3'b000;
  assign pgassign73[31:8] = 24'b000000000000000000000000;
  assign pgassign73[7:0] = BRAM_Dout_B[64:71];
  assign BRAM_Din_B[64:71] = pgassign74[7:0];
  assign pgassign75[3:3] = BRAM_WEN_B[8:8];
  assign pgassign75[2:2] = BRAM_WEN_B[8:8];
  assign pgassign75[1:1] = BRAM_WEN_B[8:8];
  assign pgassign75[0:0] = BRAM_WEN_B[8:8];
  assign pgassign76[15:15] = 1'b1;
  assign pgassign76[14:3] = BRAM_Addr_A[16:27];
  assign pgassign76[2:0] = 3'b000;
  assign pgassign77[31:8] = 24'b000000000000000000000000;
  assign pgassign77[7:0] = BRAM_Dout_A[72:79];
  assign BRAM_Din_A[72:79] = pgassign78[7:0];
  assign pgassign79[3:3] = BRAM_WEN_A[9:9];
  assign pgassign79[2:2] = BRAM_WEN_A[9:9];
  assign pgassign79[1:1] = BRAM_WEN_A[9:9];
  assign pgassign79[0:0] = BRAM_WEN_A[9:9];
  assign pgassign80[15:15] = 1'b1;
  assign pgassign80[14:3] = BRAM_Addr_B[16:27];
  assign pgassign80[2:0] = 3'b000;
  assign pgassign81[31:8] = 24'b000000000000000000000000;
  assign pgassign81[7:0] = BRAM_Dout_B[72:79];
  assign BRAM_Din_B[72:79] = pgassign82[7:0];
  assign pgassign83[3:3] = BRAM_WEN_B[9:9];
  assign pgassign83[2:2] = BRAM_WEN_B[9:9];
  assign pgassign83[1:1] = BRAM_WEN_B[9:9];
  assign pgassign83[0:0] = BRAM_WEN_B[9:9];
  assign pgassign84[15:15] = 1'b1;
  assign pgassign84[14:3] = BRAM_Addr_A[16:27];
  assign pgassign84[2:0] = 3'b000;
  assign pgassign85[31:8] = 24'b000000000000000000000000;
  assign pgassign85[7:0] = BRAM_Dout_A[80:87];
  assign BRAM_Din_A[80:87] = pgassign86[7:0];
  assign pgassign87[3:3] = BRAM_WEN_A[10:10];
  assign pgassign87[2:2] = BRAM_WEN_A[10:10];
  assign pgassign87[1:1] = BRAM_WEN_A[10:10];
  assign pgassign87[0:0] = BRAM_WEN_A[10:10];
  assign pgassign88[15:15] = 1'b1;
  assign pgassign88[14:3] = BRAM_Addr_B[16:27];
  assign pgassign88[2:0] = 3'b000;
  assign pgassign89[31:8] = 24'b000000000000000000000000;
  assign pgassign89[7:0] = BRAM_Dout_B[80:87];
  assign BRAM_Din_B[80:87] = pgassign90[7:0];
  assign pgassign91[3:3] = BRAM_WEN_B[10:10];
  assign pgassign91[2:2] = BRAM_WEN_B[10:10];
  assign pgassign91[1:1] = BRAM_WEN_B[10:10];
  assign pgassign91[0:0] = BRAM_WEN_B[10:10];
  assign pgassign92[15:15] = 1'b1;
  assign pgassign92[14:3] = BRAM_Addr_A[16:27];
  assign pgassign92[2:0] = 3'b000;
  assign pgassign93[31:8] = 24'b000000000000000000000000;
  assign pgassign93[7:0] = BRAM_Dout_A[88:95];
  assign BRAM_Din_A[88:95] = pgassign94[7:0];
  assign pgassign95[3:3] = BRAM_WEN_A[11:11];
  assign pgassign95[2:2] = BRAM_WEN_A[11:11];
  assign pgassign95[1:1] = BRAM_WEN_A[11:11];
  assign pgassign95[0:0] = BRAM_WEN_A[11:11];
  assign pgassign96[15:15] = 1'b1;
  assign pgassign96[14:3] = BRAM_Addr_B[16:27];
  assign pgassign96[2:0] = 3'b000;
  assign pgassign97[31:8] = 24'b000000000000000000000000;
  assign pgassign97[7:0] = BRAM_Dout_B[88:95];
  assign BRAM_Din_B[88:95] = pgassign98[7:0];
  assign pgassign99[3:3] = BRAM_WEN_B[11:11];
  assign pgassign99[2:2] = BRAM_WEN_B[11:11];
  assign pgassign99[1:1] = BRAM_WEN_B[11:11];
  assign pgassign99[0:0] = BRAM_WEN_B[11:11];
  assign pgassign100[15:15] = 1'b1;
  assign pgassign100[14:3] = BRAM_Addr_A[16:27];
  assign pgassign100[2:0] = 3'b000;
  assign pgassign101[31:8] = 24'b000000000000000000000000;
  assign pgassign101[7:0] = BRAM_Dout_A[96:103];
  assign BRAM_Din_A[96:103] = pgassign102[7:0];
  assign pgassign103[3:3] = BRAM_WEN_A[12:12];
  assign pgassign103[2:2] = BRAM_WEN_A[12:12];
  assign pgassign103[1:1] = BRAM_WEN_A[12:12];
  assign pgassign103[0:0] = BRAM_WEN_A[12:12];
  assign pgassign104[15:15] = 1'b1;
  assign pgassign104[14:3] = BRAM_Addr_B[16:27];
  assign pgassign104[2:0] = 3'b000;
  assign pgassign105[31:8] = 24'b000000000000000000000000;
  assign pgassign105[7:0] = BRAM_Dout_B[96:103];
  assign BRAM_Din_B[96:103] = pgassign106[7:0];
  assign pgassign107[3:3] = BRAM_WEN_B[12:12];
  assign pgassign107[2:2] = BRAM_WEN_B[12:12];
  assign pgassign107[1:1] = BRAM_WEN_B[12:12];
  assign pgassign107[0:0] = BRAM_WEN_B[12:12];
  assign pgassign108[15:15] = 1'b1;
  assign pgassign108[14:3] = BRAM_Addr_A[16:27];
  assign pgassign108[2:0] = 3'b000;
  assign pgassign109[31:8] = 24'b000000000000000000000000;
  assign pgassign109[7:0] = BRAM_Dout_A[104:111];
  assign BRAM_Din_A[104:111] = pgassign110[7:0];
  assign pgassign111[3:3] = BRAM_WEN_A[13:13];
  assign pgassign111[2:2] = BRAM_WEN_A[13:13];
  assign pgassign111[1:1] = BRAM_WEN_A[13:13];
  assign pgassign111[0:0] = BRAM_WEN_A[13:13];
  assign pgassign112[15:15] = 1'b1;
  assign pgassign112[14:3] = BRAM_Addr_B[16:27];
  assign pgassign112[2:0] = 3'b000;
  assign pgassign113[31:8] = 24'b000000000000000000000000;
  assign pgassign113[7:0] = BRAM_Dout_B[104:111];
  assign BRAM_Din_B[104:111] = pgassign114[7:0];
  assign pgassign115[3:3] = BRAM_WEN_B[13:13];
  assign pgassign115[2:2] = BRAM_WEN_B[13:13];
  assign pgassign115[1:1] = BRAM_WEN_B[13:13];
  assign pgassign115[0:0] = BRAM_WEN_B[13:13];
  assign pgassign116[15:15] = 1'b1;
  assign pgassign116[14:3] = BRAM_Addr_A[16:27];
  assign pgassign116[2:0] = 3'b000;
  assign pgassign117[31:8] = 24'b000000000000000000000000;
  assign pgassign117[7:0] = BRAM_Dout_A[112:119];
  assign BRAM_Din_A[112:119] = pgassign118[7:0];
  assign pgassign119[3:3] = BRAM_WEN_A[14:14];
  assign pgassign119[2:2] = BRAM_WEN_A[14:14];
  assign pgassign119[1:1] = BRAM_WEN_A[14:14];
  assign pgassign119[0:0] = BRAM_WEN_A[14:14];
  assign pgassign120[15:15] = 1'b1;
  assign pgassign120[14:3] = BRAM_Addr_B[16:27];
  assign pgassign120[2:0] = 3'b000;
  assign pgassign121[31:8] = 24'b000000000000000000000000;
  assign pgassign121[7:0] = BRAM_Dout_B[112:119];
  assign BRAM_Din_B[112:119] = pgassign122[7:0];
  assign pgassign123[3:3] = BRAM_WEN_B[14:14];
  assign pgassign123[2:2] = BRAM_WEN_B[14:14];
  assign pgassign123[1:1] = BRAM_WEN_B[14:14];
  assign pgassign123[0:0] = BRAM_WEN_B[14:14];
  assign pgassign124[15:15] = 1'b1;
  assign pgassign124[14:3] = BRAM_Addr_A[16:27];
  assign pgassign124[2:0] = 3'b000;
  assign pgassign125[31:8] = 24'b000000000000000000000000;
  assign pgassign125[7:0] = BRAM_Dout_A[120:127];
  assign BRAM_Din_A[120:127] = pgassign126[7:0];
  assign pgassign127[3:3] = BRAM_WEN_A[15:15];
  assign pgassign127[2:2] = BRAM_WEN_A[15:15];
  assign pgassign127[1:1] = BRAM_WEN_A[15:15];
  assign pgassign127[0:0] = BRAM_WEN_A[15:15];
  assign pgassign128[15:15] = 1'b1;
  assign pgassign128[14:3] = BRAM_Addr_B[16:27];
  assign pgassign128[2:0] = 3'b000;
  assign pgassign129[31:8] = 24'b000000000000000000000000;
  assign pgassign129[7:0] = BRAM_Dout_B[120:127];
  assign BRAM_Din_B[120:127] = pgassign130[7:0];
  assign pgassign131[3:3] = BRAM_WEN_B[15:15];
  assign pgassign131[2:2] = BRAM_WEN_B[15:15];
  assign pgassign131[1:1] = BRAM_WEN_B[15:15];
  assign pgassign131[0:0] = BRAM_WEN_B[15:15];
  assign net_gnd0 = 1'b0;
  assign net_gnd4[3:0] = 4'b0000;

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_0 (
      .ADDRA ( pgassign4 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign5 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign6 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign7 ),
      .ADDRB ( pgassign8 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign9 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign10 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign11 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_1 (
      .ADDRA ( pgassign12 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign13 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign14 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign15 ),
      .ADDRB ( pgassign16 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign17 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign18 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign19 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_2 (
      .ADDRA ( pgassign20 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign21 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign22 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign23 ),
      .ADDRB ( pgassign24 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign25 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign26 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign27 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_3 (
      .ADDRA ( pgassign28 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign29 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign30 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign31 ),
      .ADDRB ( pgassign32 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign33 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign34 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign35 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_4 (
      .ADDRA ( pgassign36 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign37 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign38 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign39 ),
      .ADDRB ( pgassign40 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign41 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign42 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign43 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_5 (
      .ADDRA ( pgassign44 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign45 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign46 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign47 ),
      .ADDRB ( pgassign48 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign49 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign50 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign51 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_6 (
      .ADDRA ( pgassign52 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign53 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign54 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign55 ),
      .ADDRB ( pgassign56 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign57 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign58 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign59 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_7 (
      .ADDRA ( pgassign60 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign61 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign62 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign63 ),
      .ADDRB ( pgassign64 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign65 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign66 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign67 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_8 (
      .ADDRA ( pgassign68 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign69 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign70 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign71 ),
      .ADDRB ( pgassign72 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign73 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign74 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign75 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_9 (
      .ADDRA ( pgassign76 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign77 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign78 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign79 ),
      .ADDRB ( pgassign80 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign81 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign82 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign83 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_10 (
      .ADDRA ( pgassign84 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign85 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign86 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign87 ),
      .ADDRB ( pgassign88 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign89 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign90 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign91 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_11 (
      .ADDRA ( pgassign92 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign93 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign94 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign95 ),
      .ADDRB ( pgassign96 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign97 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign98 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign99 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_12 (
      .ADDRA ( pgassign100 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign101 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign102 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign103 ),
      .ADDRB ( pgassign104 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign105 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign106 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign107 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_13 (
      .ADDRA ( pgassign108 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign109 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign110 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign111 ),
      .ADDRB ( pgassign112 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign113 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign114 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign115 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_14 (
      .ADDRA ( pgassign116 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign117 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign118 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign119 ),
      .ADDRB ( pgassign120 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign121 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign122 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign123 )
    );

  RAMB36
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .READ_WIDTH_A ( 9 ),
      .READ_WIDTH_B ( 9 ),
      .WRITE_WIDTH_A ( 9 ),
      .WRITE_WIDTH_B ( 9 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36_15 (
      .ADDRA ( pgassign124 ),
      .CASCADEINLATA ( net_gnd0 ),
      .CASCADEINREGA ( net_gnd0 ),
      .CASCADEOUTLATA (  ),
      .CASCADEOUTREGA (  ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( pgassign125 ),
      .DIPA ( net_gnd4 ),
      .DOA ( pgassign126 ),
      .DOPA (  ),
      .ENA ( BRAM_EN_A ),
      .REGCEA ( net_gnd0 ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( pgassign127 ),
      .ADDRB ( pgassign128 ),
      .CASCADEINLATB ( net_gnd0 ),
      .CASCADEINREGB ( net_gnd0 ),
      .CASCADEOUTLATB (  ),
      .CASCADEOUTREGB (  ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( pgassign129 ),
      .DIPB ( net_gnd4 ),
      .DOB ( pgassign130 ),
      .DOPB (  ),
      .ENB ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( pgassign131 )
    );

endmodule

// synthesis attribute keep_hierarchy of xps_bram_if_cntlr_1_bram_elaborate is yes;

