--------------------------------------------------------------------------
-- Copyright (c) 2002-2007 by Impulse Accelerated Technologies, Inc.    --
-- All rights reserved.                                                 --
--                                                                      --
-- This source file may be used and redistributed without charge        --
-- subject to the provisions of the IMPULSE ACCELERATED TECHNOLOGIES,   --
-- INC. REDISTRIBUTABLE IP LICENSE AGREEMENT, and provided that this    --
-- copyright statement is not removed from the file, and that any       --
-- derivative work contains this copyright notice.                      -
--------------------------------------------------------------------------

-- myip.vhd
--
-- The file contains user created VHDL entities that are instantiated in
-- Impulse C via the "implementation" pragma.  If this file is placed in the
-- userip sub-directory of the project directory, then it will be automatically
-- exported with the Impulse C generated files.
--
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity mul_16x32_32 is
  port (
    signal a : in std_ulogic_vector(15 downto 0);
    signal b : in std_ulogic_vector(31 downto 0);
    signal r_e_t_u_r_n : out std_ulogic_vector(31 downto 0));
  attribute mult_style : string;
  attribute mult_style of mul_16x32_32 : entity is "block";
end;

architecture dsp of mul_16x32_32 is
  signal ai : signed(15 downto 0);
  signal bi : signed(31 downto 0);
  signal res : signed(47 downto 0);
begin  -- test
  ai <= signed(a);
  bi <= signed(b);
  res <= ai * bi;
  
  r_e_t_u_r_n <= std_ulogic_vector(res(31 downto 0));

end dsp;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity mul_16x16_24 is
  port (
    signal a : in std_ulogic_vector(15 downto 0);
    signal b : in std_ulogic_vector(15 downto 0);
    signal r_e_t_u_r_n : out std_ulogic_vector(23 downto 0));
  attribute mult_style : string;
  attribute mult_style of mul_16x16_24 : entity is "block";
end;

architecture dsp of mul_16x16_24 is
  signal ai : signed(15 downto 0);
  signal bi : signed(15 downto 0);
  signal res : signed(31 downto 0);
begin  -- test
  ai <= signed(a);
  bi <= signed(b);
  res <= ai * bi;
  
  r_e_t_u_r_n <= std_ulogic_vector(res(23 downto 0));

end dsp;
