//-----------------------------------------------------------------------------
// system.v
//-----------------------------------------------------------------------------

module system
  (
    fpga_0_RS232_Uart_1_sin_pin,
    fpga_0_RS232_Uart_1_sout_pin,
    fpga_0_LEDs_8Bit_GPIO_IO_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin,
    DDR2_DQS,
    DDR2_DQS_N,
    DDR2_DQ,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin,
    fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin,
    phy_mii_int_n,
    sys_clk_pin,
    sys_rst_pin,
    ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_DE_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin,
    plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin,
    xps_iic_0_Scl,
    xps_iic_0_Sda,
    vga_reset_pin
  );
  input fpga_0_RS232_Uart_1_sin_pin;
  output fpga_0_RS232_Uart_1_sout_pin;
  inout [0:7] fpga_0_LEDs_8Bit_GPIO_IO_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin;
  output [12:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin;
  output fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin;
  output [7:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin;
  inout [7:0] DDR2_DQS;
  inout [7:0] DDR2_DQS_N;
  inout [63:0] DDR2_DQ;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin;
  output [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin;
  output phy_mii_int_n;
  input sys_clk_pin;
  input sys_rst_pin;
  output ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin;
  output [11:0] plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_DE_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin;
  output plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin;
  inout xps_iic_0_Scl;
  inout xps_iic_0_Sda;
  output vga_reset_pin;

  // Internal signals

  wire apu_clk_s;
  wire clock_generator_0_locked;
  wire dcm_clk_s;
  wire dcr_intc_0_Irq;
  wire [0:0] dcr_rst;
  wire [0:19] dcr_v29_0_DCR_ABus;
  wire dcr_v29_0_DCR_Ack;
  wire [0:31] dcr_v29_0_DCR_M_DBus;
  wire [0:1] dcr_v29_0_DCR_Read;
  wire [0:63] dcr_v29_0_DCR_Sl_DBus;
  wire [0:1] dcr_v29_0_DCR_Write;
  wire [0:9] dcr_v29_0_M_dcrABus;
  wire [0:31] dcr_v29_0_M_dcrDBus;
  wire dcr_v29_0_M_dcrRead;
  wire dcr_v29_0_M_dcrWrite;
  wire [0:1] dcr_v29_0_Sl_dcrAck;
  wire [0:63] dcr_v29_0_Sl_dcrDBus;
  wire fcb_v20_0_APUFCMDECFPUOP;
  wire [0:2] fcb_v20_0_APUFCMDECLDSTXFERSIZE;
  wire fcb_v20_0_APUFCMDECLOAD;
  wire fcb_v20_0_APUFCMDECNONAUTON;
  wire fcb_v20_0_APUFCMDECSTORE;
  wire [0:3] fcb_v20_0_APUFCMDECUDI;
  wire [0:0] fcb_v20_0_APUFCMDECUDIVALID;
  wire [0:0] fcb_v20_0_APUFCMENDIAN;
  wire [0:0] fcb_v20_0_APUFCMFLUSH;
  wire [0:31] fcb_v20_0_APUFCMINSTRUCTION;
  wire fcb_v20_0_APUFCMINSTRVALID;
  wire [0:3] fcb_v20_0_APUFCMLOADBYTEADDR;
  wire [0:127] fcb_v20_0_APUFCMLOADDATA;
  wire fcb_v20_0_APUFCMLOADDVALID;
  wire fcb_v20_0_APUFCMMSRFE0;
  wire fcb_v20_0_APUFCMMSRFE1;
  wire fcb_v20_0_APUFCMNEXTINSTRREADY;
  wire [0:0] fcb_v20_0_APUFCMOPERANDVALID;
  wire [0:31] fcb_v20_0_APUFCMRADATA;
  wire [0:31] fcb_v20_0_APUFCMRBDATA;
  wire [0:0] fcb_v20_0_APUFCMWRITEBACKOK;
  wire fcb_v20_0_FCB_DECFPUOP;
  wire [0:2] fcb_v20_0_FCB_DECLDSTXFERSIZE;
  wire fcb_v20_0_FCB_DECLOAD;
  wire fcb_v20_0_FCB_DECNONAUTON;
  wire fcb_v20_0_FCB_DECSTORE;
  wire [0:3] fcb_v20_0_FCB_DECUDI;
  wire fcb_v20_0_FCB_DECUDIVALID;
  wire fcb_v20_0_FCB_ENDIAN;
  wire fcb_v20_0_FCB_FLUSH;
  wire [0:31] fcb_v20_0_FCB_INSTRUCTION;
  wire fcb_v20_0_FCB_INSTRVALID;
  wire [0:3] fcb_v20_0_FCB_LOADBYTEADDR;
  wire [0:127] fcb_v20_0_FCB_LOADDATA;
  wire fcb_v20_0_FCB_LOADDVALID;
  wire fcb_v20_0_FCB_NEXTINSTRREADY;
  wire fcb_v20_0_FCB_OPERANDVALID;
  wire [0:31] fcb_v20_0_FCB_RADATA;
  wire [0:31] fcb_v20_0_FCB_RBDATA;
  wire fcb_v20_0_FCB_Rst;
  wire fcb_v20_0_FCB_WRITEBACKOK;
  wire fcb_v20_0_FCMAPUCONFIRMINSTR;
  wire [0:3] fcb_v20_0_FCMAPUCR;
  wire fcb_v20_0_FCMAPUDONE;
  wire fcb_v20_0_FCMAPUEXCEPTION;
  wire fcb_v20_0_FCMAPUFPSCRFEX;
  wire [0:31] fcb_v20_0_FCMAPURESULT;
  wire fcb_v20_0_FCMAPURESULTVALID;
  wire fcb_v20_0_FCMAPUSLEEPNOTREADY;
  wire [0:127] fcb_v20_0_FCMAPUSTOREDATA;
  wire [0:0] fcb_v20_0_Sl_CONFIRMINSTR;
  wire [0:3] fcb_v20_0_Sl_CR;
  wire [0:0] fcb_v20_0_Sl_DONE;
  wire [0:0] fcb_v20_0_Sl_EXCEPTION;
  wire [0:0] fcb_v20_0_Sl_FPSCRFEX;
  wire [0:31] fcb_v20_0_Sl_RESULT;
  wire [0:0] fcb_v20_0_Sl_RESULTVALID;
  wire [0:0] fcb_v20_0_Sl_SLEEPNOTREADY;
  wire [0:127] fcb_v20_0_Sl_STOREDATA;
  wire [12:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr;
  wire [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr;
  wire fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn;
  wire [0:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE;
  wire [0:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn;
  wire [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk;
  wire [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn;
  wire [7:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_DM;
  wire [1:0] fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT;
  wire fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn;
  wire fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn;
  wire [0:7] fpga_0_LEDs_8Bit_GPIO_IO_I;
  wire [0:7] fpga_0_LEDs_8Bit_GPIO_IO_O;
  wire [0:7] fpga_0_LEDs_8Bit_GPIO_IO_T;
  wire fpga_0_RS232_Uart_1_sin;
  wire fpga_0_RS232_Uart_1_sout;
  wire interc_clk;
  wire jtagppc_C405JTGTDO;
  wire jtagppc_C405JTGTDOEN;
  wire jtagppc_JTGC405TCK;
  wire jtagppc_JTGC405TDI;
  wire jtagppc_JTGC405TMS;
  wire jtagppc_JTGC405TRSTNEG;
  wire ll_clk;
  wire mc_200_mhz_s;
  wire mc_bus_reset;
  wire mc_clk;
  wire mc_clk_90;
  wire [0:127] mc_mcmireaddata;
  wire mc_mcmireaddataerr;
  wire mc_mcmireaddatavalid;
  wire [35:0] mc_mimcaddress;
  wire mc_mimcaddressvalid;
  wire mc_mimcbankconflict;
  wire [15:0] mc_mimcbyteenable;
  wire mc_mimcreadnotwrite;
  wire mc_mimcrowconflict;
  wire [127:0] mc_mimcwritedata;
  wire mc_mimcwritedatavalid;
  wire net_gnd0;
  wire [0:0] net_gnd1;
  wire [0:1] net_gnd2;
  wire [0:2] net_gnd3;
  wire [0:3] net_gnd4;
  wire [0:4] net_gnd5;
  wire [0:7] net_gnd8;
  wire [0:9] net_gnd10;
  wire [0:15] net_gnd16;
  wire [0:31] net_gnd32;
  wire [0:127] net_gnd128;
  wire net_vcc0;
  wire [0:2] pgassign1;
  wire [3:0] pgassign2;
  wire plb46_dvi_cntlr_0_clk;
  wire [0:31] plb_v46_0_M_ABus;
  wire [0:15] plb_v46_0_M_BE;
  wire [0:1] plb_v46_0_M_MSize;
  wire [0:0] plb_v46_0_M_RNW;
  wire [0:15] plb_v46_0_M_TAttribute;
  wire [0:31] plb_v46_0_M_UABus;
  wire [0:0] plb_v46_0_M_abort;
  wire [0:0] plb_v46_0_M_busLock;
  wire [0:0] plb_v46_0_M_lockErr;
  wire [0:1] plb_v46_0_M_priority;
  wire [0:0] plb_v46_0_M_rdBurst;
  wire [0:0] plb_v46_0_M_request;
  wire [0:3] plb_v46_0_M_size;
  wire [0:2] plb_v46_0_M_type;
  wire [0:0] plb_v46_0_M_wrBurst;
  wire [0:127] plb_v46_0_M_wrDBus;
  wire [0:31] plb_v46_0_PLB_ABus;
  wire [0:15] plb_v46_0_PLB_BE;
  wire [0:0] plb_v46_0_PLB_MAddrAck;
  wire [0:0] plb_v46_0_PLB_MBusy;
  wire [0:0] plb_v46_0_PLB_MIRQ;
  wire [0:0] plb_v46_0_PLB_MRdBTerm;
  wire [0:0] plb_v46_0_PLB_MRdDAck;
  wire [0:127] plb_v46_0_PLB_MRdDBus;
  wire [0:0] plb_v46_0_PLB_MRdErr;
  wire [0:3] plb_v46_0_PLB_MRdWdAddr;
  wire [0:0] plb_v46_0_PLB_MRearbitrate;
  wire [0:1] plb_v46_0_PLB_MSSize;
  wire [0:1] plb_v46_0_PLB_MSize;
  wire [0:0] plb_v46_0_PLB_MTimeout;
  wire [0:0] plb_v46_0_PLB_MWrBTerm;
  wire [0:0] plb_v46_0_PLB_MWrDAck;
  wire [0:0] plb_v46_0_PLB_MWrErr;
  wire plb_v46_0_PLB_PAValid;
  wire plb_v46_0_PLB_RNW;
  wire plb_v46_0_PLB_SAValid;
  wire [0:15] plb_v46_0_PLB_TAttribute;
  wire [0:31] plb_v46_0_PLB_UABus;
  wire plb_v46_0_PLB_abort;
  wire plb_v46_0_PLB_busLock;
  wire plb_v46_0_PLB_lockErr;
  wire [0:0] plb_v46_0_PLB_masterID;
  wire plb_v46_0_PLB_rdBurst;
  wire [0:1] plb_v46_0_PLB_rdPendPri;
  wire plb_v46_0_PLB_rdPendReq;
  wire [0:5] plb_v46_0_PLB_rdPrim;
  wire [0:1] plb_v46_0_PLB_reqPri;
  wire [0:3] plb_v46_0_PLB_size;
  wire [0:2] plb_v46_0_PLB_type;
  wire plb_v46_0_PLB_wrBurst;
  wire [0:127] plb_v46_0_PLB_wrDBus;
  wire [0:1] plb_v46_0_PLB_wrPendPri;
  wire plb_v46_0_PLB_wrPendReq;
  wire [0:5] plb_v46_0_PLB_wrPrim;
  wire [0:5] plb_v46_0_SPLB_Rst;
  wire [0:5] plb_v46_0_Sl_MBusy;
  wire [0:5] plb_v46_0_Sl_MIRQ;
  wire [0:5] plb_v46_0_Sl_MRdErr;
  wire [0:5] plb_v46_0_Sl_MWrErr;
  wire [0:11] plb_v46_0_Sl_SSize;
  wire [0:5] plb_v46_0_Sl_addrAck;
  wire [0:5] plb_v46_0_Sl_rdBTerm;
  wire [0:5] plb_v46_0_Sl_rdComp;
  wire [0:5] plb_v46_0_Sl_rdDAck;
  wire [0:767] plb_v46_0_Sl_rdDBus;
  wire [0:23] plb_v46_0_Sl_rdWdAddr;
  wire [0:5] plb_v46_0_Sl_rearbitrate;
  wire [0:5] plb_v46_0_Sl_wait;
  wire [0:5] plb_v46_0_Sl_wrBTerm;
  wire [0:5] plb_v46_0_Sl_wrComp;
  wire [0:5] plb_v46_0_Sl_wrDAck;
  wire [0:1] plb_v46_1_MPLB_Rst;
  wire [0:63] plb_v46_1_M_ABus;
  wire [0:31] plb_v46_1_M_BE;
  wire [0:3] plb_v46_1_M_MSize;
  wire [0:1] plb_v46_1_M_RNW;
  wire [0:31] plb_v46_1_M_TAttribute;
  wire [0:63] plb_v46_1_M_UABus;
  wire [0:1] plb_v46_1_M_abort;
  wire [0:1] plb_v46_1_M_busLock;
  wire [0:1] plb_v46_1_M_lockErr;
  wire [0:3] plb_v46_1_M_priority;
  wire [0:1] plb_v46_1_M_rdBurst;
  wire [0:1] plb_v46_1_M_request;
  wire [0:7] plb_v46_1_M_size;
  wire [0:5] plb_v46_1_M_type;
  wire [0:1] plb_v46_1_M_wrBurst;
  wire [0:255] plb_v46_1_M_wrDBus;
  wire [0:31] plb_v46_1_PLB_ABus;
  wire [0:15] plb_v46_1_PLB_BE;
  wire [0:1] plb_v46_1_PLB_MAddrAck;
  wire [0:1] plb_v46_1_PLB_MBusy;
  wire [0:1] plb_v46_1_PLB_MIRQ;
  wire [0:1] plb_v46_1_PLB_MRdBTerm;
  wire [0:1] plb_v46_1_PLB_MRdDAck;
  wire [0:255] plb_v46_1_PLB_MRdDBus;
  wire [0:1] plb_v46_1_PLB_MRdErr;
  wire [0:7] plb_v46_1_PLB_MRdWdAddr;
  wire [0:1] plb_v46_1_PLB_MRearbitrate;
  wire [0:3] plb_v46_1_PLB_MSSize;
  wire [0:1] plb_v46_1_PLB_MSize;
  wire [0:1] plb_v46_1_PLB_MTimeout;
  wire [0:1] plb_v46_1_PLB_MWrBTerm;
  wire [0:1] plb_v46_1_PLB_MWrDAck;
  wire [0:1] plb_v46_1_PLB_MWrErr;
  wire plb_v46_1_PLB_PAValid;
  wire plb_v46_1_PLB_RNW;
  wire plb_v46_1_PLB_SAValid;
  wire [0:15] plb_v46_1_PLB_TAttribute;
  wire [0:31] plb_v46_1_PLB_UABus;
  wire plb_v46_1_PLB_abort;
  wire plb_v46_1_PLB_busLock;
  wire plb_v46_1_PLB_lockErr;
  wire [0:0] plb_v46_1_PLB_masterID;
  wire plb_v46_1_PLB_rdBurst;
  wire [0:1] plb_v46_1_PLB_rdPendPri;
  wire plb_v46_1_PLB_rdPendReq;
  wire [0:0] plb_v46_1_PLB_rdPrim;
  wire [0:1] plb_v46_1_PLB_reqPri;
  wire [0:3] plb_v46_1_PLB_size;
  wire [0:2] plb_v46_1_PLB_type;
  wire plb_v46_1_PLB_wrBurst;
  wire [0:127] plb_v46_1_PLB_wrDBus;
  wire [0:1] plb_v46_1_PLB_wrPendPri;
  wire plb_v46_1_PLB_wrPendReq;
  wire [0:0] plb_v46_1_PLB_wrPrim;
  wire [0:1] plb_v46_1_Sl_MBusy;
  wire [0:1] plb_v46_1_Sl_MIRQ;
  wire [0:1] plb_v46_1_Sl_MRdErr;
  wire [0:1] plb_v46_1_Sl_MWrErr;
  wire [0:1] plb_v46_1_Sl_SSize;
  wire [0:0] plb_v46_1_Sl_addrAck;
  wire [0:0] plb_v46_1_Sl_rdBTerm;
  wire [0:0] plb_v46_1_Sl_rdComp;
  wire [0:0] plb_v46_1_Sl_rdDAck;
  wire [0:127] plb_v46_1_Sl_rdDBus;
  wire [0:3] plb_v46_1_Sl_rdWdAddr;
  wire [0:0] plb_v46_1_Sl_rearbitrate;
  wire [0:0] plb_v46_1_Sl_wait;
  wire [0:0] plb_v46_1_Sl_wrBTerm;
  wire [0:0] plb_v46_1_Sl_wrComp;
  wire [0:0] plb_v46_1_Sl_wrDAck;
  wire plbv46_dvi_cntlr_0_TFT_LCD_CLK_N;
  wire plbv46_dvi_cntlr_0_TFT_LCD_CLK_P;
  wire [11:0] plbv46_dvi_cntlr_0_TFT_LCD_DATA;
  wire plbv46_dvi_cntlr_0_TFT_LCD_DE;
  wire plbv46_dvi_cntlr_0_TFT_LCD_HSYNC;
  wire plbv46_dvi_cntlr_0_TFT_LCD_VSYNC;
  wire ppc440_0_DMA0RXIRQ;
  wire ppc440_0_DMA0TXIRQ;
  wire [0:0] ppc440_mc_ddr2_0_mc_miaddrreadytoaccept;
  wire proc_sys_clk;
  wire reset_block_RESETPPC0_Chip_Reset_Req;
  wire reset_block_RESETPPC0_Core_Reset_Req;
  wire reset_block_RESETPPC0_RstcPPCresetcore;
  wire reset_block_RESETPPC0_RstcPPCresetsys;
  wire reset_block_RESETPPC0_RstsPPCresetchip;
  wire reset_block_RESETPPC0_System_Reset_Req;
  wire sys_bus_reset_1;
  wire sys_bus_reset_2;
  wire sys_clk_s;
  wire sys_rst_s;
  wire [0:31] xps_bram_if_cntlr_1_port_BRAM_Addr;
  wire xps_bram_if_cntlr_1_port_BRAM_Clk;
  wire [0:127] xps_bram_if_cntlr_1_port_BRAM_Din;
  wire [0:127] xps_bram_if_cntlr_1_port_BRAM_Dout;
  wire xps_bram_if_cntlr_1_port_BRAM_EN;
  wire xps_bram_if_cntlr_1_port_BRAM_Rst;
  wire [0:15] xps_bram_if_cntlr_1_port_BRAM_WEN;
  wire xps_central_dma_0_IP2INTC_Irpt;
  wire xps_iic_0_Scl_I;
  wire xps_iic_0_Scl_O;
  wire xps_iic_0_Scl_T;
  wire xps_iic_0_Sda_I;
  wire xps_iic_0_Sda_O;
  wire xps_iic_0_Sda_T;
  wire xps_uart16550_0_IP2INTC_Irpt;

  // Internal assignments

  assign fpga_0_RS232_Uart_1_sin = fpga_0_RS232_Uart_1_sin_pin;
  assign fpga_0_RS232_Uart_1_sout_pin = fpga_0_RS232_Uart_1_sout;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE[0];
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn[0];
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_DM_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_DM;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk;
  assign fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn_pin = fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn;
  assign dcm_clk_s = sys_clk_pin;
  assign sys_rst_s = sys_rst_pin;
  assign vga_reset_pin = sys_rst_s;
  assign ppc440_mc_ddr2_0_mc_miaddrreadytoaccept_pin = ppc440_mc_ddr2_0_mc_miaddrreadytoaccept[0];
  assign plbv46_dvi_cntlr_0_TFT_LCD_VSYNC_pin = plbv46_dvi_cntlr_0_TFT_LCD_VSYNC;
  assign plbv46_dvi_cntlr_0_TFT_LCD_HSYNC_pin = plbv46_dvi_cntlr_0_TFT_LCD_HSYNC;
  assign plbv46_dvi_cntlr_0_TFT_LCD_DATA_pin = plbv46_dvi_cntlr_0_TFT_LCD_DATA;
  assign plbv46_dvi_cntlr_0_TFT_LCD_DE_pin = plbv46_dvi_cntlr_0_TFT_LCD_DE;
  assign plbv46_dvi_cntlr_0_TFT_LCD_CLK_N_pin = plbv46_dvi_cntlr_0_TFT_LCD_CLK_N;
  assign plbv46_dvi_cntlr_0_TFT_LCD_CLK_P_pin = plbv46_dvi_cntlr_0_TFT_LCD_CLK_P;
  assign sys_bus_reset_1 = pgassign1[0];
  assign sys_bus_reset_2 = pgassign1[1];
  assign mc_bus_reset = pgassign1[2];
  assign pgassign2[3] = xps_uart16550_0_IP2INTC_Irpt;
  assign pgassign2[2] = xps_central_dma_0_IP2INTC_Irpt;
  assign pgassign2[1] = ppc440_0_DMA0RXIRQ;
  assign pgassign2[0] = ppc440_0_DMA0TXIRQ;
  assign net_gnd0 = 1'b0;
  assign net_gnd1[0:0] = 1'b0;
  assign net_gnd10[0:9] = 10'b0000000000;
  assign net_gnd128[0:127] = 128'b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000;
  assign net_gnd16[0:15] = 16'b0000000000000000;
  assign net_gnd2[0:1] = 2'b00;
  assign net_gnd3[0:2] = 3'b000;
  assign net_gnd32[0:31] = 32'b00000000000000000000000000000000;
  assign net_gnd4[0:3] = 4'b0000;
  assign net_gnd5[0:4] = 5'b00000;
  assign net_gnd8[0:7] = 8'b00000000;
  assign net_vcc0 = 1'b1;
  assign phy_mii_int_n = net_vcc0;

  xps_uart16550_0_wrapper
    xps_uart16550_0 (
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[0] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim[0] ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim[0] ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[0] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[0:1] ),
      .Sl_wait ( plb_v46_0_Sl_wait[0] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[0] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[0] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[0] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[0] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[0:127] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[0:3] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[0] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[0] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[0] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[0:0] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[0:0] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[0:0] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[0:0] ),
      .baudoutN (  ),
      .ctsN ( net_gnd0 ),
      .dcdN ( net_gnd0 ),
      .ddis (  ),
      .dsrN ( net_gnd0 ),
      .dtrN (  ),
      .out1N (  ),
      .out2N (  ),
      .rclk ( net_gnd0 ),
      .riN ( net_gnd0 ),
      .rtsN (  ),
      .rxrdyN (  ),
      .sin ( fpga_0_RS232_Uart_1_sin ),
      .sout ( fpga_0_RS232_Uart_1_sout ),
      .IP2INTC_Irpt ( xps_uart16550_0_IP2INTC_Irpt ),
      .txrdyN (  ),
      .xin ( net_gnd0 ),
      .xout (  ),
      .Freeze ( net_gnd0 )
    );

  xps_central_dma_0_wrapper
    xps_central_dma_0 (
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[1] ),
      .MPLB_Clk ( sys_clk_s ),
      .MPLB_Rst ( plb_v46_1_MPLB_Rst[0] ),
      .SPLB_ABus ( plb_v46_0_PLB_ABus ),
      .SPLB_BE ( plb_v46_0_PLB_BE ),
      .SPLB_UABus ( plb_v46_0_PLB_UABus ),
      .SPLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .SPLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .SPLB_rdPrim ( plb_v46_0_PLB_rdPrim[1] ),
      .SPLB_wrPrim ( plb_v46_0_PLB_wrPrim[1] ),
      .SPLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .SPLB_abort ( plb_v46_0_PLB_abort ),
      .SPLB_busLock ( plb_v46_0_PLB_busLock ),
      .SPLB_RNW ( plb_v46_0_PLB_RNW ),
      .SPLB_MSize ( plb_v46_0_PLB_MSize ),
      .SPLB_size ( plb_v46_0_PLB_size ),
      .SPLB_type ( plb_v46_0_PLB_type ),
      .SPLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .SPLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .SPLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .SPLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .SPLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .SPLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .SPLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .SPLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .SPLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .SPLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[1] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[2:3] ),
      .Sl_wait ( plb_v46_0_Sl_wait[1] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[1] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[1] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[1] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[1] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[128:255] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[4:7] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[1] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[1] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[1] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[1:1] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[1:1] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[1:1] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[1:1] ),
      .IP2INTC_Irpt ( xps_central_dma_0_IP2INTC_Irpt ),
      .MPLB_MAddrAck ( plb_v46_1_PLB_MAddrAck[0] ),
      .MPLB_MSSize ( plb_v46_1_PLB_MSSize[0:1] ),
      .MPLB_MRearbitrate ( plb_v46_1_PLB_MRearbitrate[0] ),
      .MPLB_MTimeout ( plb_v46_1_PLB_MTimeout[0] ),
      .MPLB_MBusy ( plb_v46_1_PLB_MBusy[0] ),
      .MPLB_MRdErr ( plb_v46_1_PLB_MRdErr[0] ),
      .MPLB_MWrErr ( plb_v46_1_PLB_MWrErr[0] ),
      .MPLB_MIRQ ( plb_v46_1_PLB_MIRQ[0] ),
      .MPLB_MRdDBus ( plb_v46_1_PLB_MRdDBus[0:127] ),
      .MPLB_MRdWdAddr ( plb_v46_1_PLB_MRdWdAddr[0:3] ),
      .MPLB_MRdDAck ( plb_v46_1_PLB_MRdDAck[0] ),
      .MPLB_MRdBTerm ( plb_v46_1_PLB_MRdBTerm[0] ),
      .MPLB_MWrDAck ( plb_v46_1_PLB_MWrDAck[0] ),
      .MPLB_MWrBTerm ( plb_v46_1_PLB_MWrBTerm[0] ),
      .M_request ( plb_v46_1_M_request[0] ),
      .M_priority ( plb_v46_1_M_priority[0:1] ),
      .M_busLock ( plb_v46_1_M_busLock[0] ),
      .M_RNW ( plb_v46_1_M_RNW[0] ),
      .M_BE ( plb_v46_1_M_BE[0:15] ),
      .M_MSize ( plb_v46_1_M_MSize[0:1] ),
      .M_size ( plb_v46_1_M_size[0:3] ),
      .M_type ( plb_v46_1_M_type[0:2] ),
      .M_TAttribute ( plb_v46_1_M_TAttribute[0:15] ),
      .M_lockErr ( plb_v46_1_M_lockErr[0] ),
      .M_abort ( plb_v46_1_M_abort[0] ),
      .M_UABus ( plb_v46_1_M_UABus[0:31] ),
      .M_ABus ( plb_v46_1_M_ABus[0:31] ),
      .M_wrDBus ( plb_v46_1_M_wrDBus[0:127] ),
      .M_wrBurst ( plb_v46_1_M_wrBurst[0] ),
      .M_rdBurst ( plb_v46_1_M_rdBurst[0] )
    );

  xps_bram_if_cntlr_1_bram_wrapper
    xps_bram_if_cntlr_1_bram (
      .BRAM_Rst_A ( xps_bram_if_cntlr_1_port_BRAM_Rst ),
      .BRAM_Clk_A ( xps_bram_if_cntlr_1_port_BRAM_Clk ),
      .BRAM_EN_A ( xps_bram_if_cntlr_1_port_BRAM_EN ),
      .BRAM_WEN_A ( xps_bram_if_cntlr_1_port_BRAM_WEN ),
      .BRAM_Addr_A ( xps_bram_if_cntlr_1_port_BRAM_Addr ),
      .BRAM_Din_A ( xps_bram_if_cntlr_1_port_BRAM_Din ),
      .BRAM_Dout_A ( xps_bram_if_cntlr_1_port_BRAM_Dout ),
      .BRAM_Rst_B ( net_gnd0 ),
      .BRAM_Clk_B ( net_gnd0 ),
      .BRAM_EN_B ( net_gnd0 ),
      .BRAM_WEN_B ( net_gnd16 ),
      .BRAM_Addr_B ( net_gnd32 ),
      .BRAM_Din_B (  ),
      .BRAM_Dout_B ( net_gnd128 )
    );

  xps_bram_if_cntlr_1_wrapper
    xps_bram_if_cntlr_1 (
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[2] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim[2] ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim[2] ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[2] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[4:5] ),
      .Sl_wait ( plb_v46_0_Sl_wait[2] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[2] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[2] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[2] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[2] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[256:383] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[8:11] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[2] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[2] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[2] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[2:2] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[2:2] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[2:2] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[2:2] ),
      .BRAM_Rst ( xps_bram_if_cntlr_1_port_BRAM_Rst ),
      .BRAM_Clk ( xps_bram_if_cntlr_1_port_BRAM_Clk ),
      .BRAM_EN ( xps_bram_if_cntlr_1_port_BRAM_EN ),
      .BRAM_WEN ( xps_bram_if_cntlr_1_port_BRAM_WEN ),
      .BRAM_Addr ( xps_bram_if_cntlr_1_port_BRAM_Addr ),
      .BRAM_Din ( xps_bram_if_cntlr_1_port_BRAM_Din ),
      .BRAM_Dout ( xps_bram_if_cntlr_1_port_BRAM_Dout )
    );

  reset_block_wrapper
    reset_block (
      .Slowest_sync_clk ( plb46_dvi_cntlr_0_clk ),
      .Ext_Reset_In ( sys_rst_s ),
      .Aux_Reset_In ( net_gnd0 ),
      .MB_Debug_Sys_Rst ( net_gnd0 ),
      .Core_Reset_Req_0 ( reset_block_RESETPPC0_Core_Reset_Req ),
      .Chip_Reset_Req_0 ( reset_block_RESETPPC0_Chip_Reset_Req ),
      .System_Reset_Req_0 ( reset_block_RESETPPC0_System_Reset_Req ),
      .Core_Reset_Req_1 ( net_gnd0 ),
      .Chip_Reset_Req_1 ( net_gnd0 ),
      .System_Reset_Req_1 ( net_gnd0 ),
      .Dcm_locked ( clock_generator_0_locked ),
      .RstcPPCresetcore_0 ( reset_block_RESETPPC0_RstcPPCresetcore ),
      .RstcPPCresetchip_0 ( reset_block_RESETPPC0_RstsPPCresetchip ),
      .RstcPPCresetsys_0 ( reset_block_RESETPPC0_RstcPPCresetsys ),
      .RstcPPCresetcore_1 (  ),
      .RstcPPCresetchip_1 (  ),
      .RstcPPCresetsys_1 (  ),
      .MB_Reset (  ),
      .Bus_Struct_Reset ( pgassign1 ),
      .Peripheral_Reset ( dcr_rst[0:0] )
    );

  ppc440_mc_ddr2_0_wrapper
    ppc440_mc_ddr2_0 (
      .mc_mibclk ( mc_clk ),
      .mi_mcclk90 ( mc_clk_90 ),
      .mi_mcreset ( mc_bus_reset ),
      .mi_mcclk_200 ( mc_200_mhz_s ),
      .mi_mcaddressvalid ( mc_mimcaddressvalid ),
      .mi_mcaddress ( mc_mimcaddress ),
      .mi_mcbankconflict ( mc_mimcbankconflict ),
      .mi_mcrowconflict ( mc_mimcrowconflict ),
      .mi_mcbyteenable ( mc_mimcbyteenable ),
      .mi_mcwritedataparity ( net_gnd16[0:15] ),
      .mi_mcwritedata ( mc_mimcwritedata ),
      .mi_mcreadnotwrite ( mc_mimcreadnotwrite ),
      .mi_mcwritedatavalid ( mc_mimcwritedatavalid ),
      .mc_miaddrreadytoaccept ( ppc440_mc_ddr2_0_mc_miaddrreadytoaccept[0] ),
      .mc_mibusy (  ),
      .mc_mireaddata ( mc_mcmireaddata[0:127] ),
      .mc_mireaddataparity (  ),
      .mc_mireaddataerr ( mc_mcmireaddataerr ),
      .mc_mireaddatavalid ( mc_mcmireaddatavalid ),
      .mc_miwillbebusy (  ),
      .mc_miwritereadytoaccept (  ),
      .DDR2_DQ ( DDR2_DQ ),
      .DDR2_DQS ( DDR2_DQS ),
      .DDR2_DQS_N ( DDR2_DQS_N ),
      .DDR2_A ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Addr ),
      .DDR2_BA ( fpga_0_DDR2_SDRAM_32Mx64_DDR_BankAddr ),
      .DDR2_RAS_N ( fpga_0_DDR2_SDRAM_32Mx64_DDR_RASn ),
      .DDR2_CAS_N ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CASn ),
      .DDR2_WE_N ( fpga_0_DDR2_SDRAM_32Mx64_DDR_WEn ),
      .DDR2_CS_N ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CSn[0:0] ),
      .DDR2_ODT ( fpga_0_DDR2_SDRAM_32Mx64_DDR_ODT ),
      .DDR2_CKE ( fpga_0_DDR2_SDRAM_32Mx64_DDR_CKE[0:0] ),
      .DDR2_DM ( fpga_0_DDR2_SDRAM_32Mx64_DDR_DM ),
      .DDR2_CK ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Clk ),
      .DDR2_CK_N ( fpga_0_DDR2_SDRAM_32Mx64_DDR_Clkn )
    );

  ppc440_0_wrapper
    ppc440_0 (
      .CPMC440CLK ( proc_sys_clk ),
      .CPMC440CLKEN ( net_vcc0 ),
      .CPMINTERCONNECTCLK ( interc_clk ),
      .CPMINTERCONNECTCLKEN ( net_vcc0 ),
      .CPMINTERCONNECTCLKNTO1 ( net_vcc0 ),
      .CPMC440CORECLOCKINACTIVE ( net_gnd0 ),
      .CPMC440TIMERCLOCK ( net_vcc0 ),
      .C440MACHINECHECK (  ),
      .C440CPMCORESLEEPREQ (  ),
      .C440CPMDECIRPTREQ (  ),
      .C440CPMFITIRPTREQ (  ),
      .C440CPMMSRCE (  ),
      .C440CPMMSREE (  ),
      .C440CPMTIMERRESETREQ (  ),
      .C440CPMWDIRPTREQ (  ),
      .PPCCPMINTERCONNECTBUSY (  ),
      .DBGC440DEBUGHALT ( net_gnd0 ),
      .DBGC440DEBUGHALTNEG ( net_vcc0 ),
      .DBGC440SYSTEMSTATUS ( net_gnd5 ),
      .DBGC440UNCONDDEBUGEVENT ( net_gnd0 ),
      .C440DBGSYSTEMCONTROL (  ),
      .SPLB0_Error (  ),
      .SPLB1_Error (  ),
      .EICC440CRITIRQ ( net_gnd0 ),
      .EICC440EXTIRQ ( dcr_intc_0_Irq ),
      .PPCEICINTERCONNECTIRQ (  ),
      .CPMDCRCLK ( sys_clk_s ),
      .DCRPPCDMACK ( dcr_v29_0_DCR_Ack ),
      .DCRPPCDMDBUSIN ( dcr_v29_0_DCR_M_DBus ),
      .DCRPPCDMTIMEOUTWAIT ( net_gnd0 ),
      .PPCDMDCRREAD ( dcr_v29_0_M_dcrRead ),
      .PPCDMDCRWRITE ( dcr_v29_0_M_dcrWrite ),
      .PPCDMDCRABUS ( dcr_v29_0_M_dcrABus ),
      .PPCDMDCRDBUSOUT ( dcr_v29_0_M_dcrDBus ),
      .DCRPPCDSREAD ( net_gnd0 ),
      .DCRPPCDSWRITE ( net_gnd0 ),
      .DCRPPCDSABUS ( net_gnd10 ),
      .DCRPPCDSDBUSOUT ( net_gnd32 ),
      .PPCDSDCRACK (  ),
      .PPCDSDCRDBUSIN (  ),
      .PPCDSDCRTIMEOUTWAIT (  ),
      .CPMFCMCLK ( apu_clk_s ),
      .FCMAPUCR ( fcb_v20_0_FCMAPUCR ),
      .FCMAPUDONE ( fcb_v20_0_FCMAPUDONE ),
      .FCMAPUEXCEPTION ( fcb_v20_0_FCMAPUEXCEPTION ),
      .FCMAPUFPSCRFEX ( fcb_v20_0_FCMAPUFPSCRFEX ),
      .FCMAPURESULT ( fcb_v20_0_FCMAPURESULT ),
      .FCMAPURESULTVALID ( fcb_v20_0_FCMAPURESULTVALID ),
      .FCMAPUSLEEPNOTREADY ( fcb_v20_0_FCMAPUSLEEPNOTREADY ),
      .FCMAPUCONFIRMINSTR ( fcb_v20_0_FCMAPUCONFIRMINSTR ),
      .FCMAPUSTOREDATA ( fcb_v20_0_FCMAPUSTOREDATA ),
      .APUFCMDECNONAUTON ( fcb_v20_0_APUFCMDECNONAUTON ),
      .APUFCMDECFPUOP ( fcb_v20_0_APUFCMDECFPUOP ),
      .APUFCMDECLDSTXFERSIZE ( fcb_v20_0_APUFCMDECLDSTXFERSIZE ),
      .APUFCMDECLOAD ( fcb_v20_0_APUFCMDECLOAD ),
      .APUFCMNEXTINSTRREADY ( fcb_v20_0_APUFCMNEXTINSTRREADY ),
      .APUFCMDECSTORE ( fcb_v20_0_APUFCMDECSTORE ),
      .APUFCMDECUDI ( fcb_v20_0_APUFCMDECUDI ),
      .APUFCMDECUDIVALID ( fcb_v20_0_APUFCMDECUDIVALID[0] ),
      .APUFCMENDIAN ( fcb_v20_0_APUFCMENDIAN[0] ),
      .APUFCMFLUSH ( fcb_v20_0_APUFCMFLUSH[0] ),
      .APUFCMINSTRUCTION ( fcb_v20_0_APUFCMINSTRUCTION ),
      .APUFCMINSTRVALID ( fcb_v20_0_APUFCMINSTRVALID ),
      .APUFCMLOADBYTEADDR ( fcb_v20_0_APUFCMLOADBYTEADDR ),
      .APUFCMLOADDATA ( fcb_v20_0_APUFCMLOADDATA ),
      .APUFCMLOADDVALID ( fcb_v20_0_APUFCMLOADDVALID ),
      .APUFCMOPERANDVALID ( fcb_v20_0_APUFCMOPERANDVALID[0] ),
      .APUFCMRADATA ( fcb_v20_0_APUFCMRADATA ),
      .APUFCMRBDATA ( fcb_v20_0_APUFCMRBDATA ),
      .APUFCMWRITEBACKOK ( fcb_v20_0_APUFCMWRITEBACKOK[0] ),
      .APUFCMMSRFE0 ( fcb_v20_0_APUFCMMSRFE0 ),
      .APUFCMMSRFE1 ( fcb_v20_0_APUFCMMSRFE1 ),
      .JTGC440TCK ( jtagppc_JTGC405TCK ),
      .JTGC440TDI ( jtagppc_JTGC405TDI ),
      .JTGC440TMS ( jtagppc_JTGC405TMS ),
      .JTGC440TRSTNEG ( jtagppc_JTGC405TRSTNEG ),
      .C440JTGTDO ( jtagppc_C405JTGTDO ),
      .C440JTGTDOEN ( jtagppc_C405JTGTDOEN ),
      .CPMMCCLK ( mc_clk ),
      .MCMIREADDATA ( mc_mcmireaddata ),
      .MCMIREADDATAVALID ( mc_mcmireaddatavalid ),
      .MCMIREADDATAERR ( mc_mcmireaddataerr ),
      .MCMIADDRREADYTOACCEPT ( ppc440_mc_ddr2_0_mc_miaddrreadytoaccept[0] ),
      .MIMCREADNOTWRITE ( mc_mimcreadnotwrite ),
      .MIMCADDRESS ( mc_mimcaddress[35:0] ),
      .MIMCADDRESSVALID ( mc_mimcaddressvalid ),
      .MIMCWRITEDATA ( mc_mimcwritedata[127:0] ),
      .MIMCWRITEDATAVALID ( mc_mimcwritedatavalid ),
      .MIMCBYTEENABLE ( mc_mimcbyteenable[15:0] ),
      .MIMCBANKCONFLICT ( mc_mimcbankconflict ),
      .MIMCROWCONFLICT ( mc_mimcrowconflict ),
      .CPMPPCMPLBCLK ( sys_clk_s ),
      .PLBPPCMMBUSY ( plb_v46_0_PLB_MBusy[0] ),
      .PLBPPCMMIRQ ( plb_v46_0_PLB_MIRQ[0] ),
      .PLBPPCMMRDERR ( plb_v46_0_PLB_MRdErr[0] ),
      .PLBPPCMMWRERR ( plb_v46_0_PLB_MWrErr[0] ),
      .PLBPPCMADDRACK ( plb_v46_0_PLB_MAddrAck[0] ),
      .PLBPPCMRDBTERM ( plb_v46_0_PLB_MRdBTerm[0] ),
      .PLBPPCMRDDACK ( plb_v46_0_PLB_MRdDAck[0] ),
      .PLBPPCMRDDBUS ( plb_v46_0_PLB_MRdDBus ),
      .PLBPPCMRDWDADDR ( plb_v46_0_PLB_MRdWdAddr ),
      .PLBPPCMREARBITRATE ( plb_v46_0_PLB_MRearbitrate[0] ),
      .PLBPPCMSSIZE ( plb_v46_0_PLB_MSSize ),
      .PLBPPCMTIMEOUT ( plb_v46_0_PLB_MTimeout[0] ),
      .PLBPPCMWRBTERM ( plb_v46_0_PLB_MWrBTerm[0] ),
      .PLBPPCMWRDACK ( plb_v46_0_PLB_MWrDAck[0] ),
      .PLBPPCMRDPENDPRI ( plb_v46_0_PLB_rdPendPri ),
      .PLBPPCMRDPENDREQ ( plb_v46_0_PLB_rdPendReq ),
      .PLBPPCMREQPRI ( plb_v46_0_PLB_reqPri ),
      .PLBPPCMWRPENDPRI ( plb_v46_0_PLB_wrPendPri ),
      .PLBPPCMWRPENDREQ ( plb_v46_0_PLB_wrPendReq ),
      .PPCMPLBABORT ( plb_v46_0_M_abort[0] ),
      .PPCMPLBABUS ( plb_v46_0_M_ABus ),
      .PPCMPLBBE ( plb_v46_0_M_BE ),
      .PPCMPLBBUSLOCK ( plb_v46_0_M_busLock[0] ),
      .PPCMPLBLOCKERR ( plb_v46_0_M_lockErr[0] ),
      .PPCMPLBMSIZE ( plb_v46_0_M_MSize ),
      .PPCMPLBPRIORITY ( plb_v46_0_M_priority ),
      .PPCMPLBRDBURST ( plb_v46_0_M_rdBurst[0] ),
      .PPCMPLBREQUEST ( plb_v46_0_M_request[0] ),
      .PPCMPLBRNW ( plb_v46_0_M_RNW[0] ),
      .PPCMPLBSIZE ( plb_v46_0_M_size ),
      .PPCMPLBTATTRIBUTE ( plb_v46_0_M_TAttribute ),
      .PPCMPLBTYPE ( plb_v46_0_M_type ),
      .PPCMPLBUABUS ( plb_v46_0_M_UABus ),
      .PPCMPLBWRBURST ( plb_v46_0_M_wrBurst[0] ),
      .PPCMPLBWRDBUS ( plb_v46_0_M_wrDBus ),
      .CPMPPCS0PLBCLK ( sys_clk_s ),
      .PLBPPCS0MASTERID ( plb_v46_1_PLB_masterID[0:0] ),
      .PLBPPCS0PAVALID ( plb_v46_1_PLB_PAValid ),
      .PLBPPCS0SAVALID ( plb_v46_1_PLB_SAValid ),
      .PLBPPCS0RDPENDREQ ( plb_v46_1_PLB_rdPendReq ),
      .PLBPPCS0WRPENDREQ ( plb_v46_1_PLB_wrPendReq ),
      .PLBPPCS0RDPENDPRI ( plb_v46_1_PLB_rdPendPri ),
      .PLBPPCS0WRPENDPRI ( plb_v46_1_PLB_wrPendPri ),
      .PLBPPCS0REQPRI ( plb_v46_1_PLB_reqPri ),
      .PLBPPCS0RDPRIM ( plb_v46_1_PLB_rdPrim[0] ),
      .PLBPPCS0WRPRIM ( plb_v46_1_PLB_wrPrim[0] ),
      .PLBPPCS0BUSLOCK ( plb_v46_1_PLB_busLock ),
      .PLBPPCS0ABORT ( plb_v46_1_PLB_abort ),
      .PLBPPCS0RNW ( plb_v46_1_PLB_RNW ),
      .PLBPPCS0BE ( plb_v46_1_PLB_BE ),
      .PLBPPCS0SIZE ( plb_v46_1_PLB_size ),
      .PLBPPCS0TYPE ( plb_v46_1_PLB_type ),
      .PLBPPCS0TATTRIBUTE ( plb_v46_1_PLB_TAttribute ),
      .PLBPPCS0LOCKERR ( plb_v46_1_PLB_lockErr ),
      .PLBPPCS0MSIZE ( plb_v46_1_PLB_MSize ),
      .PLBPPCS0UABUS ( plb_v46_1_PLB_UABus ),
      .PLBPPCS0ABUS ( plb_v46_1_PLB_ABus ),
      .PLBPPCS0WRDBUS ( plb_v46_1_PLB_wrDBus ),
      .PLBPPCS0WRBURST ( plb_v46_1_PLB_wrBurst ),
      .PLBPPCS0RDBURST ( plb_v46_1_PLB_rdBurst ),
      .PPCS0PLBADDRACK ( plb_v46_1_Sl_addrAck[0] ),
      .PPCS0PLBWAIT ( plb_v46_1_Sl_wait[0] ),
      .PPCS0PLBREARBITRATE ( plb_v46_1_Sl_rearbitrate[0] ),
      .PPCS0PLBWRDACK ( plb_v46_1_Sl_wrDAck[0] ),
      .PPCS0PLBWRCOMP ( plb_v46_1_Sl_wrComp[0] ),
      .PPCS0PLBRDDBUS ( plb_v46_1_Sl_rdDBus ),
      .PPCS0PLBRDWDADDR ( plb_v46_1_Sl_rdWdAddr ),
      .PPCS0PLBRDDACK ( plb_v46_1_Sl_rdDAck[0] ),
      .PPCS0PLBRDCOMP ( plb_v46_1_Sl_rdComp[0] ),
      .PPCS0PLBRDBTERM ( plb_v46_1_Sl_rdBTerm[0] ),
      .PPCS0PLBWRBTERM ( plb_v46_1_Sl_wrBTerm[0] ),
      .PPCS0PLBMBUSY ( plb_v46_1_Sl_MBusy ),
      .PPCS0PLBMRDERR ( plb_v46_1_Sl_MRdErr ),
      .PPCS0PLBMWRERR ( plb_v46_1_Sl_MWrErr ),
      .PPCS0PLBMIRQ ( plb_v46_1_Sl_MIRQ ),
      .PPCS0PLBSSIZE ( plb_v46_1_Sl_SSize ),
      .CPMPPCS1PLBCLK ( sys_clk_s ),
      .PLBPPCS1MASTERID ( net_gnd1[0:0] ),
      .PLBPPCS1PAVALID ( net_gnd0 ),
      .PLBPPCS1SAVALID ( net_gnd0 ),
      .PLBPPCS1RDPENDREQ ( net_gnd0 ),
      .PLBPPCS1WRPENDREQ ( net_gnd0 ),
      .PLBPPCS1RDPENDPRI ( net_gnd2 ),
      .PLBPPCS1WRPENDPRI ( net_gnd2 ),
      .PLBPPCS1REQPRI ( net_gnd2 ),
      .PLBPPCS1RDPRIM ( net_gnd0 ),
      .PLBPPCS1WRPRIM ( net_gnd0 ),
      .PLBPPCS1BUSLOCK ( net_gnd0 ),
      .PLBPPCS1ABORT ( net_gnd0 ),
      .PLBPPCS1RNW ( net_gnd0 ),
      .PLBPPCS1BE ( net_gnd16 ),
      .PLBPPCS1SIZE ( net_gnd4 ),
      .PLBPPCS1TYPE ( net_gnd3 ),
      .PLBPPCS1TATTRIBUTE ( net_gnd16 ),
      .PLBPPCS1LOCKERR ( net_gnd0 ),
      .PLBPPCS1MSIZE ( net_gnd2 ),
      .PLBPPCS1UABUS ( net_gnd32 ),
      .PLBPPCS1ABUS ( net_gnd32 ),
      .PLBPPCS1WRDBUS ( net_gnd128 ),
      .PLBPPCS1WRBURST ( net_gnd0 ),
      .PLBPPCS1RDBURST ( net_gnd0 ),
      .PPCS1PLBADDRACK (  ),
      .PPCS1PLBWAIT (  ),
      .PPCS1PLBREARBITRATE (  ),
      .PPCS1PLBWRDACK (  ),
      .PPCS1PLBWRCOMP (  ),
      .PPCS1PLBRDDBUS (  ),
      .PPCS1PLBRDWDADDR (  ),
      .PPCS1PLBRDDACK (  ),
      .PPCS1PLBRDCOMP (  ),
      .PPCS1PLBRDBTERM (  ),
      .PPCS1PLBWRBTERM (  ),
      .PPCS1PLBMBUSY (  ),
      .PPCS1PLBMRDERR (  ),
      .PPCS1PLBMWRERR (  ),
      .PPCS1PLBMIRQ (  ),
      .PPCS1PLBSSIZE (  ),
      .CPMDMA0LLCLK ( ll_clk ),
      .LLDMA0TXDSTRDYN ( net_vcc0 ),
      .LLDMA0RXD ( net_gnd32 ),
      .LLDMA0RXREM ( net_gnd4 ),
      .LLDMA0RXSOFN ( net_vcc0 ),
      .LLDMA0RXEOFN ( net_vcc0 ),
      .LLDMA0RXSOPN ( net_vcc0 ),
      .LLDMA0RXEOPN ( net_vcc0 ),
      .LLDMA0RXSRCRDYN ( net_vcc0 ),
      .LLDMA0RSTENGINEREQ ( net_gnd0 ),
      .DMA0LLTXD (  ),
      .DMA0LLTXREM (  ),
      .DMA0LLTXSOFN (  ),
      .DMA0LLTXEOFN (  ),
      .DMA0LLTXSOPN (  ),
      .DMA0LLTXEOPN (  ),
      .DMA0LLTXSRCRDYN (  ),
      .DMA0LLRXDSTRDYN (  ),
      .DMA0LLRSTENGINEACK (  ),
      .DMA0TXIRQ ( ppc440_0_DMA0TXIRQ ),
      .DMA0RXIRQ ( ppc440_0_DMA0RXIRQ ),
      .CPMDMA1LLCLK ( net_vcc0 ),
      .LLDMA1TXDSTRDYN ( net_vcc0 ),
      .LLDMA1RXD ( net_gnd32 ),
      .LLDMA1RXREM ( net_gnd4 ),
      .LLDMA1RXSOFN ( net_vcc0 ),
      .LLDMA1RXEOFN ( net_vcc0 ),
      .LLDMA1RXSOPN ( net_vcc0 ),
      .LLDMA1RXEOPN ( net_vcc0 ),
      .LLDMA1RXSRCRDYN ( net_vcc0 ),
      .LLDMA1RSTENGINEREQ ( net_gnd0 ),
      .DMA1LLTXD (  ),
      .DMA1LLTXREM (  ),
      .DMA1LLTXSOFN (  ),
      .DMA1LLTXEOFN (  ),
      .DMA1LLTXSOPN (  ),
      .DMA1LLTXEOPN (  ),
      .DMA1LLTXSRCRDYN (  ),
      .DMA1LLRXDSTRDYN (  ),
      .DMA1LLRSTENGINEACK (  ),
      .DMA1TXIRQ (  ),
      .DMA1RXIRQ (  ),
      .CPMDMA2LLCLK ( net_vcc0 ),
      .LLDMA2TXDSTRDYN ( net_vcc0 ),
      .LLDMA2RXD ( net_gnd32 ),
      .LLDMA2RXREM ( net_gnd4 ),
      .LLDMA2RXSOFN ( net_vcc0 ),
      .LLDMA2RXEOFN ( net_vcc0 ),
      .LLDMA2RXSOPN ( net_vcc0 ),
      .LLDMA2RXEOPN ( net_vcc0 ),
      .LLDMA2RXSRCRDYN ( net_vcc0 ),
      .LLDMA2RSTENGINEREQ ( net_gnd0 ),
      .DMA2LLTXD (  ),
      .DMA2LLTXREM (  ),
      .DMA2LLTXSOFN (  ),
      .DMA2LLTXEOFN (  ),
      .DMA2LLTXSOPN (  ),
      .DMA2LLTXEOPN (  ),
      .DMA2LLTXSRCRDYN (  ),
      .DMA2LLRXDSTRDYN (  ),
      .DMA2LLRSTENGINEACK (  ),
      .DMA2TXIRQ (  ),
      .DMA2RXIRQ (  ),
      .CPMDMA3LLCLK ( net_vcc0 ),
      .LLDMA3TXDSTRDYN ( net_vcc0 ),
      .LLDMA3RXD ( net_gnd32 ),
      .LLDMA3RXREM ( net_gnd4 ),
      .LLDMA3RXSOFN ( net_vcc0 ),
      .LLDMA3RXEOFN ( net_vcc0 ),
      .LLDMA3RXSOPN ( net_vcc0 ),
      .LLDMA3RXEOPN ( net_vcc0 ),
      .LLDMA3RXSRCRDYN ( net_vcc0 ),
      .LLDMA3RSTENGINEREQ ( net_gnd0 ),
      .DMA3LLTXD (  ),
      .DMA3LLTXREM (  ),
      .DMA3LLTXSOFN (  ),
      .DMA3LLTXEOFN (  ),
      .DMA3LLTXSOPN (  ),
      .DMA3LLTXEOPN (  ),
      .DMA3LLTXSRCRDYN (  ),
      .DMA3LLRXDSTRDYN (  ),
      .DMA3LLRSTENGINEACK (  ),
      .DMA3TXIRQ (  ),
      .DMA3RXIRQ (  ),
      .RSTC440RESETCORE ( reset_block_RESETPPC0_RstcPPCresetcore ),
      .RSTC440RESETCHIP ( reset_block_RESETPPC0_RstsPPCresetchip ),
      .RSTC440RESETSYSTEM ( reset_block_RESETPPC0_RstcPPCresetsys ),
      .C440RSTCORERESETREQ ( reset_block_RESETPPC0_Core_Reset_Req ),
      .C440RSTCHIPRESETREQ ( reset_block_RESETPPC0_Chip_Reset_Req ),
      .C440RSTSYSTEMRESETREQ ( reset_block_RESETPPC0_System_Reset_Req ),
      .TRCC440TRACEDISABLE ( net_gnd0 ),
      .TRCC440TRIGGEREVENTIN ( net_gnd0 ),
      .C440TRCBRANCHSTATUS (  ),
      .C440TRCCYCLE (  ),
      .C440TRCEXECUTIONSTATUS (  ),
      .C440TRCTRACESTATUS (  ),
      .C440TRCTRIGGEREVENTOUT (  ),
      .C440TRCTRIGGEREVENTTYPE (  )
    );

  plb_v46_1_wrapper
    plb_v46_1 (
      .PLB_Clk ( sys_clk_s ),
      .SYS_Rst ( sys_bus_reset_2 ),
      .PLB_Rst (  ),
      .SPLB_Rst (  ),
      .MPLB_Rst ( plb_v46_1_MPLB_Rst ),
      .PLB_dcrAck (  ),
      .PLB_dcrDBus (  ),
      .DCR_ABus ( net_gnd10 ),
      .DCR_DBus ( net_gnd32 ),
      .DCR_Read ( net_gnd0 ),
      .DCR_Write ( net_gnd0 ),
      .M_ABus ( plb_v46_1_M_ABus ),
      .M_UABus ( plb_v46_1_M_UABus ),
      .M_BE ( plb_v46_1_M_BE ),
      .M_RNW ( plb_v46_1_M_RNW ),
      .M_abort ( plb_v46_1_M_abort ),
      .M_busLock ( plb_v46_1_M_busLock ),
      .M_TAttribute ( plb_v46_1_M_TAttribute ),
      .M_lockErr ( plb_v46_1_M_lockErr ),
      .M_MSize ( plb_v46_1_M_MSize ),
      .M_priority ( plb_v46_1_M_priority ),
      .M_rdBurst ( plb_v46_1_M_rdBurst ),
      .M_request ( plb_v46_1_M_request ),
      .M_size ( plb_v46_1_M_size ),
      .M_type ( plb_v46_1_M_type ),
      .M_wrBurst ( plb_v46_1_M_wrBurst ),
      .M_wrDBus ( plb_v46_1_M_wrDBus ),
      .Sl_addrAck ( plb_v46_1_Sl_addrAck[0:0] ),
      .Sl_MRdErr ( plb_v46_1_Sl_MRdErr ),
      .Sl_MWrErr ( plb_v46_1_Sl_MWrErr ),
      .Sl_MBusy ( plb_v46_1_Sl_MBusy ),
      .Sl_rdBTerm ( plb_v46_1_Sl_rdBTerm[0:0] ),
      .Sl_rdComp ( plb_v46_1_Sl_rdComp[0:0] ),
      .Sl_rdDAck ( plb_v46_1_Sl_rdDAck[0:0] ),
      .Sl_rdDBus ( plb_v46_1_Sl_rdDBus ),
      .Sl_rdWdAddr ( plb_v46_1_Sl_rdWdAddr ),
      .Sl_rearbitrate ( plb_v46_1_Sl_rearbitrate[0:0] ),
      .Sl_SSize ( plb_v46_1_Sl_SSize ),
      .Sl_wait ( plb_v46_1_Sl_wait[0:0] ),
      .Sl_wrBTerm ( plb_v46_1_Sl_wrBTerm[0:0] ),
      .Sl_wrComp ( plb_v46_1_Sl_wrComp[0:0] ),
      .Sl_wrDAck ( plb_v46_1_Sl_wrDAck[0:0] ),
      .Sl_MIRQ ( plb_v46_1_Sl_MIRQ ),
      .PLB_MIRQ ( plb_v46_1_PLB_MIRQ ),
      .PLB_ABus ( plb_v46_1_PLB_ABus ),
      .PLB_UABus ( plb_v46_1_PLB_UABus ),
      .PLB_BE ( plb_v46_1_PLB_BE ),
      .PLB_MAddrAck ( plb_v46_1_PLB_MAddrAck ),
      .PLB_MTimeout ( plb_v46_1_PLB_MTimeout ),
      .PLB_MBusy ( plb_v46_1_PLB_MBusy ),
      .PLB_MRdErr ( plb_v46_1_PLB_MRdErr ),
      .PLB_MWrErr ( plb_v46_1_PLB_MWrErr ),
      .PLB_MRdBTerm ( plb_v46_1_PLB_MRdBTerm ),
      .PLB_MRdDAck ( plb_v46_1_PLB_MRdDAck ),
      .PLB_MRdDBus ( plb_v46_1_PLB_MRdDBus ),
      .PLB_MRdWdAddr ( plb_v46_1_PLB_MRdWdAddr ),
      .PLB_MRearbitrate ( plb_v46_1_PLB_MRearbitrate ),
      .PLB_MWrBTerm ( plb_v46_1_PLB_MWrBTerm ),
      .PLB_MWrDAck ( plb_v46_1_PLB_MWrDAck ),
      .PLB_MSSize ( plb_v46_1_PLB_MSSize ),
      .PLB_PAValid ( plb_v46_1_PLB_PAValid ),
      .PLB_RNW ( plb_v46_1_PLB_RNW ),
      .PLB_SAValid ( plb_v46_1_PLB_SAValid ),
      .PLB_abort ( plb_v46_1_PLB_abort ),
      .PLB_busLock ( plb_v46_1_PLB_busLock ),
      .PLB_TAttribute ( plb_v46_1_PLB_TAttribute ),
      .PLB_lockErr ( plb_v46_1_PLB_lockErr ),
      .PLB_masterID ( plb_v46_1_PLB_masterID[0:0] ),
      .PLB_MSize ( plb_v46_1_PLB_MSize ),
      .PLB_rdPendPri ( plb_v46_1_PLB_rdPendPri ),
      .PLB_wrPendPri ( plb_v46_1_PLB_wrPendPri ),
      .PLB_rdPendReq ( plb_v46_1_PLB_rdPendReq ),
      .PLB_wrPendReq ( plb_v46_1_PLB_wrPendReq ),
      .PLB_rdBurst ( plb_v46_1_PLB_rdBurst ),
      .PLB_rdPrim ( plb_v46_1_PLB_rdPrim[0:0] ),
      .PLB_reqPri ( plb_v46_1_PLB_reqPri ),
      .PLB_size ( plb_v46_1_PLB_size ),
      .PLB_type ( plb_v46_1_PLB_type ),
      .PLB_wrBurst ( plb_v46_1_PLB_wrBurst ),
      .PLB_wrDBus ( plb_v46_1_PLB_wrDBus ),
      .PLB_wrPrim ( plb_v46_1_PLB_wrPrim[0:0] ),
      .PLB_SaddrAck (  ),
      .PLB_SMRdErr (  ),
      .PLB_SMWrErr (  ),
      .PLB_SMBusy (  ),
      .PLB_SrdBTerm (  ),
      .PLB_SrdComp (  ),
      .PLB_SrdDAck (  ),
      .PLB_SrdDBus (  ),
      .PLB_SrdWdAddr (  ),
      .PLB_Srearbitrate (  ),
      .PLB_Sssize (  ),
      .PLB_Swait (  ),
      .PLB_SwrBTerm (  ),
      .PLB_SwrComp (  ),
      .PLB_SwrDAck (  ),
      .Bus_Error_Det (  )
    );

  plb_v46_0_wrapper
    plb_v46_0 (
      .PLB_Clk ( sys_clk_s ),
      .SYS_Rst ( sys_bus_reset_1 ),
      .PLB_Rst (  ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst ),
      .MPLB_Rst (  ),
      .PLB_dcrAck (  ),
      .PLB_dcrDBus (  ),
      .DCR_ABus ( net_gnd10 ),
      .DCR_DBus ( net_gnd32 ),
      .DCR_Read ( net_gnd0 ),
      .DCR_Write ( net_gnd0 ),
      .M_ABus ( plb_v46_0_M_ABus ),
      .M_UABus ( plb_v46_0_M_UABus ),
      .M_BE ( plb_v46_0_M_BE ),
      .M_RNW ( plb_v46_0_M_RNW[0:0] ),
      .M_abort ( plb_v46_0_M_abort[0:0] ),
      .M_busLock ( plb_v46_0_M_busLock[0:0] ),
      .M_TAttribute ( plb_v46_0_M_TAttribute ),
      .M_lockErr ( plb_v46_0_M_lockErr[0:0] ),
      .M_MSize ( plb_v46_0_M_MSize ),
      .M_priority ( plb_v46_0_M_priority ),
      .M_rdBurst ( plb_v46_0_M_rdBurst[0:0] ),
      .M_request ( plb_v46_0_M_request[0:0] ),
      .M_size ( plb_v46_0_M_size ),
      .M_type ( plb_v46_0_M_type ),
      .M_wrBurst ( plb_v46_0_M_wrBurst[0:0] ),
      .M_wrDBus ( plb_v46_0_M_wrDBus ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate ),
      .Sl_SSize ( plb_v46_0_Sl_SSize ),
      .Sl_wait ( plb_v46_0_Sl_wait ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ ),
      .PLB_MIRQ ( plb_v46_0_PLB_MIRQ[0:0] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MAddrAck ( plb_v46_0_PLB_MAddrAck[0:0] ),
      .PLB_MTimeout ( plb_v46_0_PLB_MTimeout[0:0] ),
      .PLB_MBusy ( plb_v46_0_PLB_MBusy[0:0] ),
      .PLB_MRdErr ( plb_v46_0_PLB_MRdErr[0:0] ),
      .PLB_MWrErr ( plb_v46_0_PLB_MWrErr[0:0] ),
      .PLB_MRdBTerm ( plb_v46_0_PLB_MRdBTerm[0:0] ),
      .PLB_MRdDAck ( plb_v46_0_PLB_MRdDAck[0:0] ),
      .PLB_MRdDBus ( plb_v46_0_PLB_MRdDBus ),
      .PLB_MRdWdAddr ( plb_v46_0_PLB_MRdWdAddr ),
      .PLB_MRearbitrate ( plb_v46_0_PLB_MRearbitrate[0:0] ),
      .PLB_MWrBTerm ( plb_v46_0_PLB_MWrBTerm[0:0] ),
      .PLB_MWrDAck ( plb_v46_0_PLB_MWrDAck[0:0] ),
      .PLB_MSSize ( plb_v46_0_PLB_MSSize ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim ),
      .PLB_SaddrAck (  ),
      .PLB_SMRdErr (  ),
      .PLB_SMWrErr (  ),
      .PLB_SMBusy (  ),
      .PLB_SrdBTerm (  ),
      .PLB_SrdComp (  ),
      .PLB_SrdDAck (  ),
      .PLB_SrdDBus (  ),
      .PLB_SrdWdAddr (  ),
      .PLB_Srearbitrate (  ),
      .PLB_Sssize (  ),
      .PLB_Swait (  ),
      .PLB_SwrBTerm (  ),
      .PLB_SwrComp (  ),
      .PLB_SwrDAck (  ),
      .Bus_Error_Det (  )
    );

  jtagppc_cntlr_0_wrapper
    jtagppc_cntlr_0 (
      .TRSTNEG ( net_vcc0 ),
      .HALTNEG0 ( net_vcc0 ),
      .DBGC405DEBUGHALT0 (  ),
      .HALTNEG1 ( net_vcc0 ),
      .DBGC405DEBUGHALT1 (  ),
      .C405JTGTDO0 ( jtagppc_C405JTGTDO ),
      .C405JTGTDOEN0 ( jtagppc_C405JTGTDOEN ),
      .JTGC405TCK0 ( jtagppc_JTGC405TCK ),
      .JTGC405TDI0 ( jtagppc_JTGC405TDI ),
      .JTGC405TMS0 ( jtagppc_JTGC405TMS ),
      .JTGC405TRSTNEG0 ( jtagppc_JTGC405TRSTNEG ),
      .C405JTGTDO1 ( net_gnd0 ),
      .C405JTGTDOEN1 ( net_gnd0 ),
      .JTGC405TCK1 (  ),
      .JTGC405TDI1 (  ),
      .JTGC405TMS1 (  ),
      .JTGC405TRSTNEG1 (  )
    );

  fcb_v20_0_wrapper
    fcb_v20_0 (
      .FCB_CLK ( apu_clk_s ),
      .SYS_RST ( sys_bus_reset_1 ),
      .FCB_RST ( fcb_v20_0_FCB_Rst ),
      .M_DECUDI ( fcb_v20_0_APUFCMDECUDI ),
      .M_DECUDIVALID ( fcb_v20_0_APUFCMDECUDIVALID[0:0] ),
      .M_ENDIAN ( fcb_v20_0_APUFCMENDIAN[0:0] ),
      .M_FLUSH ( fcb_v20_0_APUFCMFLUSH[0:0] ),
      .M_INSTRUCTION ( fcb_v20_0_APUFCMINSTRUCTION ),
      .M_INSTRVALID ( fcb_v20_0_APUFCMINSTRVALID ),
      .M_LOADBYTEADDR ( fcb_v20_0_APUFCMLOADBYTEADDR ),
      .M_LOADDATA ( fcb_v20_0_APUFCMLOADDATA ),
      .M_LOADDVALID ( fcb_v20_0_APUFCMLOADDVALID ),
      .M_OPERANDVALID ( fcb_v20_0_APUFCMOPERANDVALID[0:0] ),
      .M_RADATA ( fcb_v20_0_APUFCMRADATA ),
      .M_RBDATA ( fcb_v20_0_APUFCMRBDATA ),
      .M_WRITEBACKOK ( fcb_v20_0_APUFCMWRITEBACKOK[0:0] ),
      .M_DECFPUOP ( fcb_v20_0_APUFCMDECFPUOP ),
      .M_DECLOAD ( fcb_v20_0_APUFCMDECLOAD ),
      .M_DECSTORE ( fcb_v20_0_APUFCMDECSTORE ),
      .M_DECLDSTXFERSIZE ( fcb_v20_0_APUFCMDECLDSTXFERSIZE ),
      .M_DECNONAUTON ( fcb_v20_0_APUFCMDECNONAUTON ),
      .M_NEXTINSTRREADY ( fcb_v20_0_APUFCMNEXTINSTRREADY ),
      .M_MSRFE0 ( fcb_v20_0_APUFCMMSRFE0 ),
      .M_MSRFE1 ( fcb_v20_0_APUFCMMSRFE1 ),
      .FCB_CR ( fcb_v20_0_FCMAPUCR ),
      .FCB_DONE ( fcb_v20_0_FCMAPUDONE ),
      .FCB_EXCEPTION ( fcb_v20_0_FCMAPUEXCEPTION ),
      .FCB_RESULT ( fcb_v20_0_FCMAPURESULT ),
      .FCB_RESULTVALID ( fcb_v20_0_FCMAPURESULTVALID ),
      .FCB_SLEEPNOTREADY ( fcb_v20_0_FCMAPUSLEEPNOTREADY ),
      .FCB_STOREDATA ( fcb_v20_0_FCMAPUSTOREDATA ),
      .FCB_CONFIRMINSTR ( fcb_v20_0_FCMAPUCONFIRMINSTR ),
      .FCB_FPSCRFEX ( fcb_v20_0_FCMAPUFPSCRFEX ),
      .FCB_DECUDI ( fcb_v20_0_FCB_DECUDI ),
      .FCB_DECUDIVALID ( fcb_v20_0_FCB_DECUDIVALID ),
      .FCB_ENDIAN ( fcb_v20_0_FCB_ENDIAN ),
      .FCB_FLUSH ( fcb_v20_0_FCB_FLUSH ),
      .FCB_INSTRUCTION ( fcb_v20_0_FCB_INSTRUCTION ),
      .FCB_INSTRVALID ( fcb_v20_0_FCB_INSTRVALID ),
      .FCB_LOADBYTEADDR ( fcb_v20_0_FCB_LOADBYTEADDR ),
      .FCB_LOADDATA ( fcb_v20_0_FCB_LOADDATA ),
      .FCB_LOADDVALID ( fcb_v20_0_FCB_LOADDVALID ),
      .FCB_OPERANDVALID ( fcb_v20_0_FCB_OPERANDVALID ),
      .FCB_RADATA ( fcb_v20_0_FCB_RADATA ),
      .FCB_RBDATA ( fcb_v20_0_FCB_RBDATA ),
      .FCB_WRITEBACKOK ( fcb_v20_0_FCB_WRITEBACKOK ),
      .FCB_DECFPUOP ( fcb_v20_0_FCB_DECFPUOP ),
      .FCB_DECLOAD ( fcb_v20_0_FCB_DECLOAD ),
      .FCB_DECSTORE ( fcb_v20_0_FCB_DECSTORE ),
      .FCB_DECLDSTXFERSIZE ( fcb_v20_0_FCB_DECLDSTXFERSIZE ),
      .FCB_DECNONAUTON ( fcb_v20_0_FCB_DECNONAUTON ),
      .FCB_NEXTINSTRREADY ( fcb_v20_0_FCB_NEXTINSTRREADY ),
      .FCB_MSRFE0 (  ),
      .FCB_MSRFE1 (  ),
      .Sl_CR ( fcb_v20_0_Sl_CR ),
      .Sl_DONE ( fcb_v20_0_Sl_DONE[0:0] ),
      .Sl_EXCEPTION ( fcb_v20_0_Sl_EXCEPTION[0:0] ),
      .Sl_RESULT ( fcb_v20_0_Sl_RESULT ),
      .Sl_RESULTVALID ( fcb_v20_0_Sl_RESULTVALID[0:0] ),
      .Sl_SLEEPNOTREADY ( fcb_v20_0_Sl_SLEEPNOTREADY[0:0] ),
      .Sl_STOREDATA ( fcb_v20_0_Sl_STOREDATA ),
      .Sl_CONFIRMINSTR ( fcb_v20_0_Sl_CONFIRMINSTR[0:0] ),
      .Sl_FPSCRFEX ( fcb_v20_0_Sl_FPSCRFEX[0:0] )
    );

  ddr2_init_wrapper
    ddr2_init (
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[3] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim[3] ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim[3] ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[3] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[6:7] ),
      .Sl_wait ( plb_v46_0_Sl_wait[3] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[3] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[3] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[3] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[3] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[384:511] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[12:15] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[3] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[3] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[3] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[3:3] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[3:3] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[3:3] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[3:3] ),
      .IP2INTC_Irpt (  ),
      .GPIO_IO_I ( net_gnd1[0:0] ),
      .GPIO_IO_O (  ),
      .GPIO_IO_T (  ),
      .GPIO_in ( ppc440_mc_ddr2_0_mc_miaddrreadytoaccept[0:0] ),
      .GPIO_d_out (  ),
      .GPIO_t_out (  ),
      .GPIO2_IO_I ( net_gnd1[0:0] ),
      .GPIO2_IO_O (  ),
      .GPIO2_IO_T (  ),
      .GPIO2_in ( net_gnd1[0:0] ),
      .GPIO2_d_out (  ),
      .GPIO2_t_out (  )
    );

  dcr_v29_0_wrapper
    dcr_v29_0 (
      .M_dcrABus ( dcr_v29_0_M_dcrABus ),
      .M_dcrDBus ( dcr_v29_0_M_dcrDBus ),
      .M_dcrRead ( dcr_v29_0_M_dcrRead ),
      .M_dcrWrite ( dcr_v29_0_M_dcrWrite ),
      .DCR_M_DBus ( dcr_v29_0_DCR_M_DBus ),
      .DCR_Ack ( dcr_v29_0_DCR_Ack ),
      .DCR_ABus ( dcr_v29_0_DCR_ABus ),
      .DCR_Sl_DBus ( dcr_v29_0_DCR_Sl_DBus ),
      .DCR_Read ( dcr_v29_0_DCR_Read ),
      .DCR_Write ( dcr_v29_0_DCR_Write ),
      .Sl_dcrDBus ( dcr_v29_0_Sl_dcrDBus ),
      .Sl_dcrAck ( dcr_v29_0_Sl_dcrAck )
    );

  dcr_intc_0_wrapper
    dcr_intc_0 (
      .DCR_Clk ( sys_clk_s ),
      .Intr ( pgassign2 ),
      .DCR_Rst ( dcr_rst[0] ),
      .DCR_Read ( dcr_v29_0_DCR_Read[0] ),
      .DCR_Write ( dcr_v29_0_DCR_Write[0] ),
      .DCR_ABus ( dcr_v29_0_DCR_ABus[0:9] ),
      .DCR_DBus ( dcr_v29_0_DCR_Sl_DBus[0:31] ),
      .Intc_dcrDBus ( dcr_v29_0_Sl_dcrDBus[0:31] ),
      .Intc_dcrAck ( dcr_v29_0_Sl_dcrAck[0] ),
      .Irq ( dcr_intc_0_Irq )
    );

  clock_generator_0_wrapper
    clock_generator_0 (
      .CLKIN ( dcm_clk_s ),
      .CLKFBIN ( net_gnd0 ),
      .CLKOUT0 ( proc_sys_clk ),
      .CLKOUT1 ( interc_clk ),
      .CLKOUT2 ( sys_clk_s ),
      .CLKOUT3 ( mc_clk ),
      .CLKOUT4 ( mc_clk_90 ),
      .CLKOUT5 ( ll_clk ),
      .CLKOUT6 ( mc_200_mhz_s ),
      .CLKOUT7 ( apu_clk_s ),
      .CLKOUT8 ( plb46_dvi_cntlr_0_clk ),
      .CLKOUT9 (  ),
      .CLKOUT10 (  ),
      .CLKOUT11 (  ),
      .CLKOUT12 (  ),
      .CLKOUT13 (  ),
      .CLKOUT14 (  ),
      .CLKOUT15 (  ),
      .CLKFBOUT (  ),
      .RST ( sys_rst_s ),
      .LOCKED ( clock_generator_0_locked )
    );

  leds_8bit_wrapper
    LEDs_8Bit (
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[4] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim[4] ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim[4] ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[4] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[8:9] ),
      .Sl_wait ( plb_v46_0_Sl_wait[4] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[4] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[4] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[4] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[4] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[512:639] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[16:19] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[4] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[4] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[4] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[4:4] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[4:4] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[4:4] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[4:4] ),
      .IP2INTC_Irpt (  ),
      .GPIO_IO_I ( fpga_0_LEDs_8Bit_GPIO_IO_I ),
      .GPIO_IO_O ( fpga_0_LEDs_8Bit_GPIO_IO_O ),
      .GPIO_IO_T ( fpga_0_LEDs_8Bit_GPIO_IO_T ),
      .GPIO_in ( net_gnd8 ),
      .GPIO_d_out (  ),
      .GPIO_t_out (  ),
      .GPIO2_IO_I ( net_gnd8 ),
      .GPIO2_IO_O (  ),
      .GPIO2_IO_T (  ),
      .GPIO2_in ( net_gnd8 ),
      .GPIO2_d_out (  ),
      .GPIO2_t_out (  )
    );

  plbv46_dvi_cntlr_0_wrapper
    plbv46_dvi_cntlr_0 (
      .SYS_tftClk ( plb46_dvi_cntlr_0_clk ),
      .TFT_LCD_CLK_P ( plbv46_dvi_cntlr_0_TFT_LCD_CLK_P ),
      .TFT_LCD_CLK_N ( plbv46_dvi_cntlr_0_TFT_LCD_CLK_N ),
      .TFT_LCD_DE ( plbv46_dvi_cntlr_0_TFT_LCD_DE ),
      .TFT_LCD_DATA ( plbv46_dvi_cntlr_0_TFT_LCD_DATA ),
      .TFT_LCD_HSYNC ( plbv46_dvi_cntlr_0_TFT_LCD_HSYNC ),
      .TFT_LCD_VSYNC ( plbv46_dvi_cntlr_0_TFT_LCD_VSYNC ),
      .TFT_LCD_DPS (  ),
      .SYS_dcrClk ( sys_clk_s ),
      .DCR_Ack ( dcr_v29_0_Sl_dcrAck[1] ),
      .DCR_DBusOut ( dcr_v29_0_Sl_dcrDBus[32:63] ),
      .DCR_ABus ( dcr_v29_0_DCR_ABus[10:19] ),
      .DCR_DBusIn ( dcr_v29_0_DCR_Sl_DBus[32:63] ),
      .DCR_Read ( dcr_v29_0_DCR_Read[1] ),
      .DCR_Write ( dcr_v29_0_DCR_Write[1] ),
      .SPLB_Clk ( sys_clk_s ),
      .SPLB_Rst ( plb_v46_0_SPLB_Rst[5] ),
      .PLB_ABus ( plb_v46_0_PLB_ABus ),
      .PLB_UABus ( plb_v46_0_PLB_UABus ),
      .PLB_PAValid ( plb_v46_0_PLB_PAValid ),
      .PLB_SAValid ( plb_v46_0_PLB_SAValid ),
      .PLB_rdPrim ( plb_v46_0_PLB_rdPrim[5] ),
      .PLB_wrPrim ( plb_v46_0_PLB_wrPrim[5] ),
      .PLB_masterID ( plb_v46_0_PLB_masterID[0:0] ),
      .PLB_abort ( plb_v46_0_PLB_abort ),
      .PLB_busLock ( plb_v46_0_PLB_busLock ),
      .PLB_RNW ( plb_v46_0_PLB_RNW ),
      .PLB_BE ( plb_v46_0_PLB_BE ),
      .PLB_MSize ( plb_v46_0_PLB_MSize ),
      .PLB_size ( plb_v46_0_PLB_size ),
      .PLB_type ( plb_v46_0_PLB_type ),
      .PLB_lockErr ( plb_v46_0_PLB_lockErr ),
      .PLB_wrDBus ( plb_v46_0_PLB_wrDBus ),
      .PLB_wrBurst ( plb_v46_0_PLB_wrBurst ),
      .PLB_rdBurst ( plb_v46_0_PLB_rdBurst ),
      .PLB_wrPendReq ( plb_v46_0_PLB_wrPendReq ),
      .PLB_rdPendReq ( plb_v46_0_PLB_rdPendReq ),
      .PLB_wrPendPri ( plb_v46_0_PLB_wrPendPri ),
      .PLB_rdPendPri ( plb_v46_0_PLB_rdPendPri ),
      .PLB_reqPri ( plb_v46_0_PLB_reqPri ),
      .PLB_TAttribute ( plb_v46_0_PLB_TAttribute ),
      .Sl_addrAck ( plb_v46_0_Sl_addrAck[5] ),
      .Sl_SSize ( plb_v46_0_Sl_SSize[10:11] ),
      .Sl_wait ( plb_v46_0_Sl_wait[5] ),
      .Sl_rearbitrate ( plb_v46_0_Sl_rearbitrate[5] ),
      .Sl_wrDAck ( plb_v46_0_Sl_wrDAck[5] ),
      .Sl_wrComp ( plb_v46_0_Sl_wrComp[5] ),
      .Sl_wrBTerm ( plb_v46_0_Sl_wrBTerm[5] ),
      .Sl_rdDBus ( plb_v46_0_Sl_rdDBus[640:767] ),
      .Sl_rdWdAddr ( plb_v46_0_Sl_rdWdAddr[20:23] ),
      .Sl_rdDAck ( plb_v46_0_Sl_rdDAck[5] ),
      .Sl_rdComp ( plb_v46_0_Sl_rdComp[5] ),
      .Sl_rdBTerm ( plb_v46_0_Sl_rdBTerm[5] ),
      .Sl_MBusy ( plb_v46_0_Sl_MBusy[5:5] ),
      .Sl_MWrErr ( plb_v46_0_Sl_MWrErr[5:5] ),
      .Sl_MRdErr ( plb_v46_0_Sl_MRdErr[5:5] ),
      .Sl_MIRQ ( plb_v46_0_Sl_MIRQ[5:5] ),
      .MPLB_Clk ( sys_clk_s ),
      .MPLB_Rst ( plb_v46_1_MPLB_Rst[1] ),
      .MD_error (  ),
      .M_request ( plb_v46_1_M_request[1] ),
      .M_priority ( plb_v46_1_M_priority[2:3] ),
      .M_busLock ( plb_v46_1_M_busLock[1] ),
      .M_RNW ( plb_v46_1_M_RNW[1] ),
      .M_BE ( plb_v46_1_M_BE[16:31] ),
      .M_MSize ( plb_v46_1_M_MSize[2:3] ),
      .M_size ( plb_v46_1_M_size[4:7] ),
      .M_type ( plb_v46_1_M_type[3:5] ),
      .M_TAttribute ( plb_v46_1_M_TAttribute[16:31] ),
      .M_lockErr ( plb_v46_1_M_lockErr[1] ),
      .M_abort ( plb_v46_1_M_abort[1] ),
      .M_UABus ( plb_v46_1_M_UABus[32:63] ),
      .M_ABus ( plb_v46_1_M_ABus[32:63] ),
      .M_wrDBus ( plb_v46_1_M_wrDBus[128:255] ),
      .M_wrBurst ( plb_v46_1_M_wrBurst[1] ),
      .M_rdBurst ( plb_v46_1_M_rdBurst[1] ),
      .PLB_MAddrAck ( plb_v46_1_PLB_MAddrAck[1] ),
      .PLB_MSSize ( plb_v46_1_PLB_MSSize[2:3] ),
      .PLB_MRearbitrate ( plb_v46_1_PLB_MRearbitrate[1] ),
      .PLB_MTimeout ( plb_v46_1_PLB_MTimeout[1] ),
      .PLB_MBusy ( plb_v46_1_PLB_MBusy[1] ),
      .PLB_MRdErr ( plb_v46_1_PLB_MRdErr[1] ),
      .PLB_MWrErr ( plb_v46_1_PLB_MWrErr[1] ),
      .PLB_MIRQ ( plb_v46_1_PLB_MIRQ[1] ),
      .PLB_MRdDBus ( plb_v46_1_PLB_MRdDBus[128:255] ),
      .PLB_MRdWdAddr ( plb_v46_1_PLB_MRdWdAddr[4:7] ),
      .PLB_MRdDAck ( plb_v46_1_PLB_MRdDAck[1] ),
      .PLB_MRdBTerm ( plb_v46_1_PLB_MRdBTerm[1] ),
      .PLB_MWrDAck ( plb_v46_1_PLB_MWrDAck[1] ),
      .PLB_MWrBTerm ( plb_v46_1_PLB_MWrBTerm[1] ),
      .tft_iic_scl_I ( xps_iic_0_Scl_I ),
      .tft_iic_scl_O ( xps_iic_0_Scl_O ),
      .tft_iic_scl_T ( xps_iic_0_Scl_T ),
      .tft_iic_sda_I ( xps_iic_0_Sda_I ),
      .tft_iic_sda_O ( xps_iic_0_Sda_O ),
      .tft_iic_sda_T ( xps_iic_0_Sda_T )
    );

  apu_idct_colorconv_arch_0_wrapper
    apu_idct_colorconv_arch_0 (
      .FCMAPURESULT ( fcb_v20_0_Sl_RESULT ),
      .FCMAPUDONE ( fcb_v20_0_Sl_DONE[0] ),
      .FCMAPUSLEEPNOTREADY ( fcb_v20_0_Sl_SLEEPNOTREADY[0] ),
      .FCMAPURESULTVALID ( fcb_v20_0_Sl_RESULTVALID[0] ),
      .FCMAPUCR ( fcb_v20_0_Sl_CR ),
      .FCMAPUEXCEPTION ( fcb_v20_0_Sl_EXCEPTION[0] ),
      .FCMAPUSTOREDATA ( fcb_v20_0_Sl_STOREDATA ),
      .FCMAPUCONFIRMINSTR ( fcb_v20_0_Sl_CONFIRMINSTR[0] ),
      .FCMAPUFPSCRFEX ( fcb_v20_0_Sl_FPSCRFEX[0] ),
      .APUFCMINSTRUCTION ( fcb_v20_0_FCB_INSTRUCTION ),
      .APUFCMINSTRVALID ( fcb_v20_0_FCB_INSTRVALID ),
      .APUFCMRADATA ( fcb_v20_0_FCB_RADATA ),
      .APUFCMRBDATA ( fcb_v20_0_FCB_RBDATA ),
      .APUFCMOPERANDVALID ( fcb_v20_0_FCB_OPERANDVALID ),
      .APUFCMFLUSH ( fcb_v20_0_FCB_FLUSH ),
      .APUFCMWRITEBACKOK ( fcb_v20_0_FCB_WRITEBACKOK ),
      .APUFCMLOADDATA ( fcb_v20_0_FCB_LOADDATA ),
      .APUFCMLOADDVALID ( fcb_v20_0_FCB_LOADDVALID ),
      .APUFCMLOADBYTEADDR ( fcb_v20_0_FCB_LOADBYTEADDR ),
      .APUFCMENDIAN ( fcb_v20_0_FCB_ENDIAN ),
      .APUFCMDECUDI ( fcb_v20_0_FCB_DECUDI ),
      .APUFCMDECUDIVALID ( fcb_v20_0_FCB_DECUDIVALID ),
      .APUFCMDECFPUOP ( fcb_v20_0_FCB_DECFPUOP ),
      .APUFCMDECLOAD ( fcb_v20_0_FCB_DECLOAD ),
      .APUFCMDECSTORE ( fcb_v20_0_FCB_DECSTORE ),
      .APUFCMDECLDSTXFERSIZE ( fcb_v20_0_FCB_DECLDSTXFERSIZE ),
      .APUFCMDECNONAUTON ( fcb_v20_0_FCB_DECNONAUTON ),
      .APUFCMNEXTINSTRREADY ( fcb_v20_0_FCB_NEXTINSTRREADY ),
      .udidebug (  ),
      .apu_clk ( apu_clk_s ),
      .reset ( fcb_v20_0_FCB_Rst )
    );

  IOBUF
    iobuf_0 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[0] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[0] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[0] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[0] )
    );

  IOBUF
    iobuf_1 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[1] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[1] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[1] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[1] )
    );

  IOBUF
    iobuf_2 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[2] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[2] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[2] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[2] )
    );

  IOBUF
    iobuf_3 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[3] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[3] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[3] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[3] )
    );

  IOBUF
    iobuf_4 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[4] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[4] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[4] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[4] )
    );

  IOBUF
    iobuf_5 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[5] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[5] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[5] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[5] )
    );

  IOBUF
    iobuf_6 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[6] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[6] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[6] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[6] )
    );

  IOBUF
    iobuf_7 (
      .I ( fpga_0_LEDs_8Bit_GPIO_IO_O[7] ),
      .IO ( fpga_0_LEDs_8Bit_GPIO_IO_pin[7] ),
      .O ( fpga_0_LEDs_8Bit_GPIO_IO_I[7] ),
      .T ( fpga_0_LEDs_8Bit_GPIO_IO_T[7] )
    );

  IOBUF
    iobuf_8 (
      .I ( xps_iic_0_Scl_O ),
      .IO ( xps_iic_0_Scl ),
      .O ( xps_iic_0_Scl_I ),
      .T ( xps_iic_0_Scl_T )
    );

  IOBUF
    iobuf_9 (
      .I ( xps_iic_0_Sda_O ),
      .IO ( xps_iic_0_Sda ),
      .O ( xps_iic_0_Sda_I ),
      .T ( xps_iic_0_Sda_T )
    );

endmodule

// synthesis attribute BOX_TYPE of xps_uart16550_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of xps_central_dma_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of xps_bram_if_cntlr_1_bram_wrapper is black_box;
// synthesis attribute BOX_TYPE of xps_bram_if_cntlr_1_wrapper is black_box;
// synthesis attribute BOX_TYPE of reset_block_wrapper is black_box;
// synthesis attribute BOX_TYPE of ppc440_mc_ddr2_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of ppc440_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of plb_v46_1_wrapper is black_box;
// synthesis attribute BOX_TYPE of plb_v46_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of jtagppc_cntlr_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of fcb_v20_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of ddr2_init_wrapper is black_box;
// synthesis attribute BOX_TYPE of dcr_v29_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of dcr_intc_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of clock_generator_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of leds_8bit_wrapper is black_box;
// synthesis attribute BOX_TYPE of plbv46_dvi_cntlr_0_wrapper is black_box;
// synthesis attribute BOX_TYPE of apu_idct_colorconv_arch_0_wrapper is black_box;

module xps_uart16550_0_wrapper
  (
    SPLB_Clk,
    SPLB_Rst,
    PLB_ABus,
    PLB_UABus,
    PLB_PAValid,
    PLB_SAValid,
    PLB_rdPrim,
    PLB_wrPrim,
    PLB_masterID,
    PLB_abort,
    PLB_busLock,
    PLB_RNW,
    PLB_BE,
    PLB_MSize,
    PLB_size,
    PLB_type,
    PLB_lockErr,
    PLB_wrDBus,
    PLB_wrBurst,
    PLB_rdBurst,
    PLB_wrPendReq,
    PLB_rdPendReq,
    PLB_wrPendPri,
    PLB_rdPendPri,
    PLB_reqPri,
    PLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    baudoutN,
    ctsN,
    dcdN,
    ddis,
    dsrN,
    dtrN,
    out1N,
    out2N,
    rclk,
    riN,
    rtsN,
    rxrdyN,
    sin,
    sout,
    IP2INTC_Irpt,
    txrdyN,
    xin,
    xout,
    Freeze
  );
  input SPLB_Clk;
  input SPLB_Rst;
  input [0:31] PLB_ABus;
  input [0:31] PLB_UABus;
  input PLB_PAValid;
  input PLB_SAValid;
  input PLB_rdPrim;
  input PLB_wrPrim;
  input [0:0] PLB_masterID;
  input PLB_abort;
  input PLB_busLock;
  input PLB_RNW;
  input [0:15] PLB_BE;
  input [0:1] PLB_MSize;
  input [0:3] PLB_size;
  input [0:2] PLB_type;
  input PLB_lockErr;
  input [0:127] PLB_wrDBus;
  input PLB_wrBurst;
  input PLB_rdBurst;
  input PLB_wrPendReq;
  input PLB_rdPendReq;
  input [0:1] PLB_wrPendPri;
  input [0:1] PLB_rdPendPri;
  input [0:1] PLB_reqPri;
  input [0:15] PLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  output baudoutN;
  input ctsN;
  input dcdN;
  output ddis;
  input dsrN;
  output dtrN;
  output out1N;
  output out2N;
  input rclk;
  input riN;
  output rtsN;
  output rxrdyN;
  input sin;
  output sout;
  output IP2INTC_Irpt;
  output txrdyN;
  input xin;
  output xout;
  input Freeze;
endmodule

module xps_central_dma_0_wrapper
  (
    SPLB_Clk,
    SPLB_Rst,
    MPLB_Clk,
    MPLB_Rst,
    SPLB_ABus,
    SPLB_BE,
    SPLB_UABus,
    SPLB_PAValid,
    SPLB_SAValid,
    SPLB_rdPrim,
    SPLB_wrPrim,
    SPLB_masterID,
    SPLB_abort,
    SPLB_busLock,
    SPLB_RNW,
    SPLB_MSize,
    SPLB_size,
    SPLB_type,
    SPLB_lockErr,
    SPLB_wrDBus,
    SPLB_wrBurst,
    SPLB_rdBurst,
    SPLB_wrPendReq,
    SPLB_rdPendReq,
    SPLB_wrPendPri,
    SPLB_rdPendPri,
    SPLB_reqPri,
    SPLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    IP2INTC_Irpt,
    MPLB_MAddrAck,
    MPLB_MSSize,
    MPLB_MRearbitrate,
    MPLB_MTimeout,
    MPLB_MBusy,
    MPLB_MRdErr,
    MPLB_MWrErr,
    MPLB_MIRQ,
    MPLB_MRdDBus,
    MPLB_MRdWdAddr,
    MPLB_MRdDAck,
    MPLB_MRdBTerm,
    MPLB_MWrDAck,
    MPLB_MWrBTerm,
    M_request,
    M_priority,
    M_busLock,
    M_RNW,
    M_BE,
    M_MSize,
    M_size,
    M_type,
    M_TAttribute,
    M_lockErr,
    M_abort,
    M_UABus,
    M_ABus,
    M_wrDBus,
    M_wrBurst,
    M_rdBurst
  );
  input SPLB_Clk;
  input SPLB_Rst;
  input MPLB_Clk;
  input MPLB_Rst;
  input [0:31] SPLB_ABus;
  input [0:15] SPLB_BE;
  input [0:31] SPLB_UABus;
  input SPLB_PAValid;
  input SPLB_SAValid;
  input SPLB_rdPrim;
  input SPLB_wrPrim;
  input [0:0] SPLB_masterID;
  input SPLB_abort;
  input SPLB_busLock;
  input SPLB_RNW;
  input [0:1] SPLB_MSize;
  input [0:3] SPLB_size;
  input [0:2] SPLB_type;
  input SPLB_lockErr;
  input [0:127] SPLB_wrDBus;
  input SPLB_wrBurst;
  input SPLB_rdBurst;
  input SPLB_wrPendReq;
  input SPLB_rdPendReq;
  input [0:1] SPLB_wrPendPri;
  input [0:1] SPLB_rdPendPri;
  input [0:1] SPLB_reqPri;
  input [0:15] SPLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  output IP2INTC_Irpt;
  input MPLB_MAddrAck;
  input [0:1] MPLB_MSSize;
  input MPLB_MRearbitrate;
  input MPLB_MTimeout;
  input MPLB_MBusy;
  input MPLB_MRdErr;
  input MPLB_MWrErr;
  input MPLB_MIRQ;
  input [0:127] MPLB_MRdDBus;
  input [0:3] MPLB_MRdWdAddr;
  input MPLB_MRdDAck;
  input MPLB_MRdBTerm;
  input MPLB_MWrDAck;
  input MPLB_MWrBTerm;
  output M_request;
  output [0:1] M_priority;
  output M_busLock;
  output M_RNW;
  output [0:15] M_BE;
  output [0:1] M_MSize;
  output [0:3] M_size;
  output [0:2] M_type;
  output [0:15] M_TAttribute;
  output M_lockErr;
  output M_abort;
  output [0:31] M_UABus;
  output [0:31] M_ABus;
  output [0:127] M_wrDBus;
  output M_wrBurst;
  output M_rdBurst;
endmodule

module xps_bram_if_cntlr_1_bram_wrapper
  (
    BRAM_Rst_A,
    BRAM_Clk_A,
    BRAM_EN_A,
    BRAM_WEN_A,
    BRAM_Addr_A,
    BRAM_Din_A,
    BRAM_Dout_A,
    BRAM_Rst_B,
    BRAM_Clk_B,
    BRAM_EN_B,
    BRAM_WEN_B,
    BRAM_Addr_B,
    BRAM_Din_B,
    BRAM_Dout_B
  );
  input BRAM_Rst_A;
  input BRAM_Clk_A;
  input BRAM_EN_A;
  input [0:15] BRAM_WEN_A;
  input [0:31] BRAM_Addr_A;
  output [0:127] BRAM_Din_A;
  input [0:127] BRAM_Dout_A;
  input BRAM_Rst_B;
  input BRAM_Clk_B;
  input BRAM_EN_B;
  input [0:15] BRAM_WEN_B;
  input [0:31] BRAM_Addr_B;
  output [0:127] BRAM_Din_B;
  input [0:127] BRAM_Dout_B;
endmodule

module xps_bram_if_cntlr_1_wrapper
  (
    SPLB_Clk,
    SPLB_Rst,
    PLB_ABus,
    PLB_UABus,
    PLB_PAValid,
    PLB_SAValid,
    PLB_rdPrim,
    PLB_wrPrim,
    PLB_masterID,
    PLB_abort,
    PLB_busLock,
    PLB_RNW,
    PLB_BE,
    PLB_MSize,
    PLB_size,
    PLB_type,
    PLB_lockErr,
    PLB_wrDBus,
    PLB_wrBurst,
    PLB_rdBurst,
    PLB_wrPendReq,
    PLB_rdPendReq,
    PLB_wrPendPri,
    PLB_rdPendPri,
    PLB_reqPri,
    PLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    BRAM_Rst,
    BRAM_Clk,
    BRAM_EN,
    BRAM_WEN,
    BRAM_Addr,
    BRAM_Din,
    BRAM_Dout
  );
  input SPLB_Clk;
  input SPLB_Rst;
  input [0:31] PLB_ABus;
  input [0:31] PLB_UABus;
  input PLB_PAValid;
  input PLB_SAValid;
  input PLB_rdPrim;
  input PLB_wrPrim;
  input [0:0] PLB_masterID;
  input PLB_abort;
  input PLB_busLock;
  input PLB_RNW;
  input [0:15] PLB_BE;
  input [0:1] PLB_MSize;
  input [0:3] PLB_size;
  input [0:2] PLB_type;
  input PLB_lockErr;
  input [0:127] PLB_wrDBus;
  input PLB_wrBurst;
  input PLB_rdBurst;
  input PLB_wrPendReq;
  input PLB_rdPendReq;
  input [0:1] PLB_wrPendPri;
  input [0:1] PLB_rdPendPri;
  input [0:1] PLB_reqPri;
  input [0:15] PLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  output BRAM_Rst;
  output BRAM_Clk;
  output BRAM_EN;
  output [0:15] BRAM_WEN;
  output [0:31] BRAM_Addr;
  input [0:127] BRAM_Din;
  output [0:127] BRAM_Dout;
endmodule

module reset_block_wrapper
  (
    Slowest_sync_clk,
    Ext_Reset_In,
    Aux_Reset_In,
    MB_Debug_Sys_Rst,
    Core_Reset_Req_0,
    Chip_Reset_Req_0,
    System_Reset_Req_0,
    Core_Reset_Req_1,
    Chip_Reset_Req_1,
    System_Reset_Req_1,
    Dcm_locked,
    RstcPPCresetcore_0,
    RstcPPCresetchip_0,
    RstcPPCresetsys_0,
    RstcPPCresetcore_1,
    RstcPPCresetchip_1,
    RstcPPCresetsys_1,
    MB_Reset,
    Bus_Struct_Reset,
    Peripheral_Reset
  );
  input Slowest_sync_clk;
  input Ext_Reset_In;
  input Aux_Reset_In;
  input MB_Debug_Sys_Rst;
  input Core_Reset_Req_0;
  input Chip_Reset_Req_0;
  input System_Reset_Req_0;
  input Core_Reset_Req_1;
  input Chip_Reset_Req_1;
  input System_Reset_Req_1;
  input Dcm_locked;
  output RstcPPCresetcore_0;
  output RstcPPCresetchip_0;
  output RstcPPCresetsys_0;
  output RstcPPCresetcore_1;
  output RstcPPCresetchip_1;
  output RstcPPCresetsys_1;
  output MB_Reset;
  output [0:2] Bus_Struct_Reset;
  output [0:0] Peripheral_Reset;
endmodule

module ppc440_mc_ddr2_0_wrapper
  (
    mc_mibclk,
    mi_mcclk90,
    mi_mcreset,
    mi_mcclk_200,
    mi_mcaddressvalid,
    mi_mcaddress,
    mi_mcbankconflict,
    mi_mcrowconflict,
    mi_mcbyteenable,
    mi_mcwritedataparity,
    mi_mcwritedata,
    mi_mcreadnotwrite,
    mi_mcwritedatavalid,
    mc_miaddrreadytoaccept,
    mc_mibusy,
    mc_mireaddata,
    mc_mireaddataparity,
    mc_mireaddataerr,
    mc_mireaddatavalid,
    mc_miwillbebusy,
    mc_miwritereadytoaccept,
    DDR2_DQ,
    DDR2_DQS,
    DDR2_DQS_N,
    DDR2_A,
    DDR2_BA,
    DDR2_RAS_N,
    DDR2_CAS_N,
    DDR2_WE_N,
    DDR2_CS_N,
    DDR2_ODT,
    DDR2_CKE,
    DDR2_DM,
    DDR2_CK,
    DDR2_CK_N
  );
  input mc_mibclk;
  input mi_mcclk90;
  input mi_mcreset;
  input mi_mcclk_200;
  input mi_mcaddressvalid;
  input [35:0] mi_mcaddress;
  input mi_mcbankconflict;
  input mi_mcrowconflict;
  input [15:0] mi_mcbyteenable;
  input [15:0] mi_mcwritedataparity;
  input [127:0] mi_mcwritedata;
  input mi_mcreadnotwrite;
  input mi_mcwritedatavalid;
  output mc_miaddrreadytoaccept;
  output mc_mibusy;
  output [127:0] mc_mireaddata;
  output [15:0] mc_mireaddataparity;
  output mc_mireaddataerr;
  output mc_mireaddatavalid;
  output mc_miwillbebusy;
  output mc_miwritereadytoaccept;
  inout [63:0] DDR2_DQ;
  inout [7:0] DDR2_DQS;
  inout [7:0] DDR2_DQS_N;
  output [12:0] DDR2_A;
  output [1:0] DDR2_BA;
  output DDR2_RAS_N;
  output DDR2_CAS_N;
  output DDR2_WE_N;
  output [0:0] DDR2_CS_N;
  output [1:0] DDR2_ODT;
  output [0:0] DDR2_CKE;
  output [7:0] DDR2_DM;
  output [1:0] DDR2_CK;
  output [1:0] DDR2_CK_N;
endmodule

module ppc440_0_wrapper
  (
    CPMC440CLK,
    CPMC440CLKEN,
    CPMINTERCONNECTCLK,
    CPMINTERCONNECTCLKEN,
    CPMINTERCONNECTCLKNTO1,
    CPMC440CORECLOCKINACTIVE,
    CPMC440TIMERCLOCK,
    C440MACHINECHECK,
    C440CPMCORESLEEPREQ,
    C440CPMDECIRPTREQ,
    C440CPMFITIRPTREQ,
    C440CPMMSRCE,
    C440CPMMSREE,
    C440CPMTIMERRESETREQ,
    C440CPMWDIRPTREQ,
    PPCCPMINTERCONNECTBUSY,
    DBGC440DEBUGHALT,
    DBGC440DEBUGHALTNEG,
    DBGC440SYSTEMSTATUS,
    DBGC440UNCONDDEBUGEVENT,
    C440DBGSYSTEMCONTROL,
    SPLB0_Error,
    SPLB1_Error,
    EICC440CRITIRQ,
    EICC440EXTIRQ,
    PPCEICINTERCONNECTIRQ,
    CPMDCRCLK,
    DCRPPCDMACK,
    DCRPPCDMDBUSIN,
    DCRPPCDMTIMEOUTWAIT,
    PPCDMDCRREAD,
    PPCDMDCRWRITE,
    PPCDMDCRABUS,
    PPCDMDCRDBUSOUT,
    DCRPPCDSREAD,
    DCRPPCDSWRITE,
    DCRPPCDSABUS,
    DCRPPCDSDBUSOUT,
    PPCDSDCRACK,
    PPCDSDCRDBUSIN,
    PPCDSDCRTIMEOUTWAIT,
    CPMFCMCLK,
    FCMAPUCR,
    FCMAPUDONE,
    FCMAPUEXCEPTION,
    FCMAPUFPSCRFEX,
    FCMAPURESULT,
    FCMAPURESULTVALID,
    FCMAPUSLEEPNOTREADY,
    FCMAPUCONFIRMINSTR,
    FCMAPUSTOREDATA,
    APUFCMDECNONAUTON,
    APUFCMDECFPUOP,
    APUFCMDECLDSTXFERSIZE,
    APUFCMDECLOAD,
    APUFCMNEXTINSTRREADY,
    APUFCMDECSTORE,
    APUFCMDECUDI,
    APUFCMDECUDIVALID,
    APUFCMENDIAN,
    APUFCMFLUSH,
    APUFCMINSTRUCTION,
    APUFCMINSTRVALID,
    APUFCMLOADBYTEADDR,
    APUFCMLOADDATA,
    APUFCMLOADDVALID,
    APUFCMOPERANDVALID,
    APUFCMRADATA,
    APUFCMRBDATA,
    APUFCMWRITEBACKOK,
    APUFCMMSRFE0,
    APUFCMMSRFE1,
    JTGC440TCK,
    JTGC440TDI,
    JTGC440TMS,
    JTGC440TRSTNEG,
    C440JTGTDO,
    C440JTGTDOEN,
    CPMMCCLK,
    MCMIREADDATA,
    MCMIREADDATAVALID,
    MCMIREADDATAERR,
    MCMIADDRREADYTOACCEPT,
    MIMCREADNOTWRITE,
    MIMCADDRESS,
    MIMCADDRESSVALID,
    MIMCWRITEDATA,
    MIMCWRITEDATAVALID,
    MIMCBYTEENABLE,
    MIMCBANKCONFLICT,
    MIMCROWCONFLICT,
    CPMPPCMPLBCLK,
    PLBPPCMMBUSY,
    PLBPPCMMIRQ,
    PLBPPCMMRDERR,
    PLBPPCMMWRERR,
    PLBPPCMADDRACK,
    PLBPPCMRDBTERM,
    PLBPPCMRDDACK,
    PLBPPCMRDDBUS,
    PLBPPCMRDWDADDR,
    PLBPPCMREARBITRATE,
    PLBPPCMSSIZE,
    PLBPPCMTIMEOUT,
    PLBPPCMWRBTERM,
    PLBPPCMWRDACK,
    PLBPPCMRDPENDPRI,
    PLBPPCMRDPENDREQ,
    PLBPPCMREQPRI,
    PLBPPCMWRPENDPRI,
    PLBPPCMWRPENDREQ,
    PPCMPLBABORT,
    PPCMPLBABUS,
    PPCMPLBBE,
    PPCMPLBBUSLOCK,
    PPCMPLBLOCKERR,
    PPCMPLBMSIZE,
    PPCMPLBPRIORITY,
    PPCMPLBRDBURST,
    PPCMPLBREQUEST,
    PPCMPLBRNW,
    PPCMPLBSIZE,
    PPCMPLBTATTRIBUTE,
    PPCMPLBTYPE,
    PPCMPLBUABUS,
    PPCMPLBWRBURST,
    PPCMPLBWRDBUS,
    CPMPPCS0PLBCLK,
    PLBPPCS0MASTERID,
    PLBPPCS0PAVALID,
    PLBPPCS0SAVALID,
    PLBPPCS0RDPENDREQ,
    PLBPPCS0WRPENDREQ,
    PLBPPCS0RDPENDPRI,
    PLBPPCS0WRPENDPRI,
    PLBPPCS0REQPRI,
    PLBPPCS0RDPRIM,
    PLBPPCS0WRPRIM,
    PLBPPCS0BUSLOCK,
    PLBPPCS0ABORT,
    PLBPPCS0RNW,
    PLBPPCS0BE,
    PLBPPCS0SIZE,
    PLBPPCS0TYPE,
    PLBPPCS0TATTRIBUTE,
    PLBPPCS0LOCKERR,
    PLBPPCS0MSIZE,
    PLBPPCS0UABUS,
    PLBPPCS0ABUS,
    PLBPPCS0WRDBUS,
    PLBPPCS0WRBURST,
    PLBPPCS0RDBURST,
    PPCS0PLBADDRACK,
    PPCS0PLBWAIT,
    PPCS0PLBREARBITRATE,
    PPCS0PLBWRDACK,
    PPCS0PLBWRCOMP,
    PPCS0PLBRDDBUS,
    PPCS0PLBRDWDADDR,
    PPCS0PLBRDDACK,
    PPCS0PLBRDCOMP,
    PPCS0PLBRDBTERM,
    PPCS0PLBWRBTERM,
    PPCS0PLBMBUSY,
    PPCS0PLBMRDERR,
    PPCS0PLBMWRERR,
    PPCS0PLBMIRQ,
    PPCS0PLBSSIZE,
    CPMPPCS1PLBCLK,
    PLBPPCS1MASTERID,
    PLBPPCS1PAVALID,
    PLBPPCS1SAVALID,
    PLBPPCS1RDPENDREQ,
    PLBPPCS1WRPENDREQ,
    PLBPPCS1RDPENDPRI,
    PLBPPCS1WRPENDPRI,
    PLBPPCS1REQPRI,
    PLBPPCS1RDPRIM,
    PLBPPCS1WRPRIM,
    PLBPPCS1BUSLOCK,
    PLBPPCS1ABORT,
    PLBPPCS1RNW,
    PLBPPCS1BE,
    PLBPPCS1SIZE,
    PLBPPCS1TYPE,
    PLBPPCS1TATTRIBUTE,
    PLBPPCS1LOCKERR,
    PLBPPCS1MSIZE,
    PLBPPCS1UABUS,
    PLBPPCS1ABUS,
    PLBPPCS1WRDBUS,
    PLBPPCS1WRBURST,
    PLBPPCS1RDBURST,
    PPCS1PLBADDRACK,
    PPCS1PLBWAIT,
    PPCS1PLBREARBITRATE,
    PPCS1PLBWRDACK,
    PPCS1PLBWRCOMP,
    PPCS1PLBRDDBUS,
    PPCS1PLBRDWDADDR,
    PPCS1PLBRDDACK,
    PPCS1PLBRDCOMP,
    PPCS1PLBRDBTERM,
    PPCS1PLBWRBTERM,
    PPCS1PLBMBUSY,
    PPCS1PLBMRDERR,
    PPCS1PLBMWRERR,
    PPCS1PLBMIRQ,
    PPCS1PLBSSIZE,
    CPMDMA0LLCLK,
    LLDMA0TXDSTRDYN,
    LLDMA0RXD,
    LLDMA0RXREM,
    LLDMA0RXSOFN,
    LLDMA0RXEOFN,
    LLDMA0RXSOPN,
    LLDMA0RXEOPN,
    LLDMA0RXSRCRDYN,
    LLDMA0RSTENGINEREQ,
    DMA0LLTXD,
    DMA0LLTXREM,
    DMA0LLTXSOFN,
    DMA0LLTXEOFN,
    DMA0LLTXSOPN,
    DMA0LLTXEOPN,
    DMA0LLTXSRCRDYN,
    DMA0LLRXDSTRDYN,
    DMA0LLRSTENGINEACK,
    DMA0TXIRQ,
    DMA0RXIRQ,
    CPMDMA1LLCLK,
    LLDMA1TXDSTRDYN,
    LLDMA1RXD,
    LLDMA1RXREM,
    LLDMA1RXSOFN,
    LLDMA1RXEOFN,
    LLDMA1RXSOPN,
    LLDMA1RXEOPN,
    LLDMA1RXSRCRDYN,
    LLDMA1RSTENGINEREQ,
    DMA1LLTXD,
    DMA1LLTXREM,
    DMA1LLTXSOFN,
    DMA1LLTXEOFN,
    DMA1LLTXSOPN,
    DMA1LLTXEOPN,
    DMA1LLTXSRCRDYN,
    DMA1LLRXDSTRDYN,
    DMA1LLRSTENGINEACK,
    DMA1TXIRQ,
    DMA1RXIRQ,
    CPMDMA2LLCLK,
    LLDMA2TXDSTRDYN,
    LLDMA2RXD,
    LLDMA2RXREM,
    LLDMA2RXSOFN,
    LLDMA2RXEOFN,
    LLDMA2RXSOPN,
    LLDMA2RXEOPN,
    LLDMA2RXSRCRDYN,
    LLDMA2RSTENGINEREQ,
    DMA2LLTXD,
    DMA2LLTXREM,
    DMA2LLTXSOFN,
    DMA2LLTXEOFN,
    DMA2LLTXSOPN,
    DMA2LLTXEOPN,
    DMA2LLTXSRCRDYN,
    DMA2LLRXDSTRDYN,
    DMA2LLRSTENGINEACK,
    DMA2TXIRQ,
    DMA2RXIRQ,
    CPMDMA3LLCLK,
    LLDMA3TXDSTRDYN,
    LLDMA3RXD,
    LLDMA3RXREM,
    LLDMA3RXSOFN,
    LLDMA3RXEOFN,
    LLDMA3RXSOPN,
    LLDMA3RXEOPN,
    LLDMA3RXSRCRDYN,
    LLDMA3RSTENGINEREQ,
    DMA3LLTXD,
    DMA3LLTXREM,
    DMA3LLTXSOFN,
    DMA3LLTXEOFN,
    DMA3LLTXSOPN,
    DMA3LLTXEOPN,
    DMA3LLTXSRCRDYN,
    DMA3LLRXDSTRDYN,
    DMA3LLRSTENGINEACK,
    DMA3TXIRQ,
    DMA3RXIRQ,
    RSTC440RESETCORE,
    RSTC440RESETCHIP,
    RSTC440RESETSYSTEM,
    C440RSTCORERESETREQ,
    C440RSTCHIPRESETREQ,
    C440RSTSYSTEMRESETREQ,
    TRCC440TRACEDISABLE,
    TRCC440TRIGGEREVENTIN,
    C440TRCBRANCHSTATUS,
    C440TRCCYCLE,
    C440TRCEXECUTIONSTATUS,
    C440TRCTRACESTATUS,
    C440TRCTRIGGEREVENTOUT,
    C440TRCTRIGGEREVENTTYPE
  );
  input CPMC440CLK;
  input CPMC440CLKEN;
  input CPMINTERCONNECTCLK;
  input CPMINTERCONNECTCLKEN;
  input CPMINTERCONNECTCLKNTO1;
  input CPMC440CORECLOCKINACTIVE;
  input CPMC440TIMERCLOCK;
  output C440MACHINECHECK;
  output C440CPMCORESLEEPREQ;
  output C440CPMDECIRPTREQ;
  output C440CPMFITIRPTREQ;
  output C440CPMMSRCE;
  output C440CPMMSREE;
  output C440CPMTIMERRESETREQ;
  output C440CPMWDIRPTREQ;
  output PPCCPMINTERCONNECTBUSY;
  input DBGC440DEBUGHALT;
  input DBGC440DEBUGHALTNEG;
  input [0:4] DBGC440SYSTEMSTATUS;
  input DBGC440UNCONDDEBUGEVENT;
  output [0:7] C440DBGSYSTEMCONTROL;
  output [0:3] SPLB0_Error;
  output [0:3] SPLB1_Error;
  input EICC440CRITIRQ;
  input EICC440EXTIRQ;
  output PPCEICINTERCONNECTIRQ;
  input CPMDCRCLK;
  input DCRPPCDMACK;
  input [0:31] DCRPPCDMDBUSIN;
  input DCRPPCDMTIMEOUTWAIT;
  output PPCDMDCRREAD;
  output PPCDMDCRWRITE;
  output [0:9] PPCDMDCRABUS;
  output [0:31] PPCDMDCRDBUSOUT;
  input DCRPPCDSREAD;
  input DCRPPCDSWRITE;
  input [0:9] DCRPPCDSABUS;
  input [0:31] DCRPPCDSDBUSOUT;
  output PPCDSDCRACK;
  output [0:31] PPCDSDCRDBUSIN;
  output PPCDSDCRTIMEOUTWAIT;
  input CPMFCMCLK;
  input [0:3] FCMAPUCR;
  input FCMAPUDONE;
  input FCMAPUEXCEPTION;
  input FCMAPUFPSCRFEX;
  input [0:31] FCMAPURESULT;
  input FCMAPURESULTVALID;
  input FCMAPUSLEEPNOTREADY;
  input FCMAPUCONFIRMINSTR;
  input [0:127] FCMAPUSTOREDATA;
  output APUFCMDECNONAUTON;
  output APUFCMDECFPUOP;
  output [0:2] APUFCMDECLDSTXFERSIZE;
  output APUFCMDECLOAD;
  output APUFCMNEXTINSTRREADY;
  output APUFCMDECSTORE;
  output [0:3] APUFCMDECUDI;
  output APUFCMDECUDIVALID;
  output APUFCMENDIAN;
  output APUFCMFLUSH;
  output [0:31] APUFCMINSTRUCTION;
  output APUFCMINSTRVALID;
  output [0:3] APUFCMLOADBYTEADDR;
  output [0:127] APUFCMLOADDATA;
  output APUFCMLOADDVALID;
  output APUFCMOPERANDVALID;
  output [0:31] APUFCMRADATA;
  output [0:31] APUFCMRBDATA;
  output APUFCMWRITEBACKOK;
  output APUFCMMSRFE0;
  output APUFCMMSRFE1;
  input JTGC440TCK;
  input JTGC440TDI;
  input JTGC440TMS;
  input JTGC440TRSTNEG;
  output C440JTGTDO;
  output C440JTGTDOEN;
  input CPMMCCLK;
  input [0:127] MCMIREADDATA;
  input MCMIREADDATAVALID;
  input MCMIREADDATAERR;
  input MCMIADDRREADYTOACCEPT;
  output MIMCREADNOTWRITE;
  output [0:35] MIMCADDRESS;
  output MIMCADDRESSVALID;
  output [0:127] MIMCWRITEDATA;
  output MIMCWRITEDATAVALID;
  output [0:15] MIMCBYTEENABLE;
  output MIMCBANKCONFLICT;
  output MIMCROWCONFLICT;
  input CPMPPCMPLBCLK;
  input PLBPPCMMBUSY;
  input PLBPPCMMIRQ;
  input PLBPPCMMRDERR;
  input PLBPPCMMWRERR;
  input PLBPPCMADDRACK;
  input PLBPPCMRDBTERM;
  input PLBPPCMRDDACK;
  input [0:127] PLBPPCMRDDBUS;
  input [0:3] PLBPPCMRDWDADDR;
  input PLBPPCMREARBITRATE;
  input [0:1] PLBPPCMSSIZE;
  input PLBPPCMTIMEOUT;
  input PLBPPCMWRBTERM;
  input PLBPPCMWRDACK;
  input [0:1] PLBPPCMRDPENDPRI;
  input PLBPPCMRDPENDREQ;
  input [0:1] PLBPPCMREQPRI;
  input [0:1] PLBPPCMWRPENDPRI;
  input PLBPPCMWRPENDREQ;
  output PPCMPLBABORT;
  output [0:31] PPCMPLBABUS;
  output [0:15] PPCMPLBBE;
  output PPCMPLBBUSLOCK;
  output PPCMPLBLOCKERR;
  output [0:1] PPCMPLBMSIZE;
  output [0:1] PPCMPLBPRIORITY;
  output PPCMPLBRDBURST;
  output PPCMPLBREQUEST;
  output PPCMPLBRNW;
  output [0:3] PPCMPLBSIZE;
  output [0:15] PPCMPLBTATTRIBUTE;
  output [0:2] PPCMPLBTYPE;
  output [0:31] PPCMPLBUABUS;
  output PPCMPLBWRBURST;
  output [0:127] PPCMPLBWRDBUS;
  input CPMPPCS0PLBCLK;
  input [0:0] PLBPPCS0MASTERID;
  input PLBPPCS0PAVALID;
  input PLBPPCS0SAVALID;
  input PLBPPCS0RDPENDREQ;
  input PLBPPCS0WRPENDREQ;
  input [0:1] PLBPPCS0RDPENDPRI;
  input [0:1] PLBPPCS0WRPENDPRI;
  input [0:1] PLBPPCS0REQPRI;
  input PLBPPCS0RDPRIM;
  input PLBPPCS0WRPRIM;
  input PLBPPCS0BUSLOCK;
  input PLBPPCS0ABORT;
  input PLBPPCS0RNW;
  input [0:15] PLBPPCS0BE;
  input [0:3] PLBPPCS0SIZE;
  input [0:2] PLBPPCS0TYPE;
  input [0:15] PLBPPCS0TATTRIBUTE;
  input PLBPPCS0LOCKERR;
  input [0:1] PLBPPCS0MSIZE;
  input [0:31] PLBPPCS0UABUS;
  input [0:31] PLBPPCS0ABUS;
  input [0:127] PLBPPCS0WRDBUS;
  input PLBPPCS0WRBURST;
  input PLBPPCS0RDBURST;
  output PPCS0PLBADDRACK;
  output PPCS0PLBWAIT;
  output PPCS0PLBREARBITRATE;
  output PPCS0PLBWRDACK;
  output PPCS0PLBWRCOMP;
  output [0:127] PPCS0PLBRDDBUS;
  output [0:3] PPCS0PLBRDWDADDR;
  output PPCS0PLBRDDACK;
  output PPCS0PLBRDCOMP;
  output PPCS0PLBRDBTERM;
  output PPCS0PLBWRBTERM;
  output [0:1] PPCS0PLBMBUSY;
  output [0:1] PPCS0PLBMRDERR;
  output [0:1] PPCS0PLBMWRERR;
  output [0:1] PPCS0PLBMIRQ;
  output [0:1] PPCS0PLBSSIZE;
  input CPMPPCS1PLBCLK;
  input [0:0] PLBPPCS1MASTERID;
  input PLBPPCS1PAVALID;
  input PLBPPCS1SAVALID;
  input PLBPPCS1RDPENDREQ;
  input PLBPPCS1WRPENDREQ;
  input [0:1] PLBPPCS1RDPENDPRI;
  input [0:1] PLBPPCS1WRPENDPRI;
  input [0:1] PLBPPCS1REQPRI;
  input PLBPPCS1RDPRIM;
  input PLBPPCS1WRPRIM;
  input PLBPPCS1BUSLOCK;
  input PLBPPCS1ABORT;
  input PLBPPCS1RNW;
  input [0:15] PLBPPCS1BE;
  input [0:3] PLBPPCS1SIZE;
  input [0:2] PLBPPCS1TYPE;
  input [0:15] PLBPPCS1TATTRIBUTE;
  input PLBPPCS1LOCKERR;
  input [0:1] PLBPPCS1MSIZE;
  input [0:31] PLBPPCS1UABUS;
  input [0:31] PLBPPCS1ABUS;
  input [0:127] PLBPPCS1WRDBUS;
  input PLBPPCS1WRBURST;
  input PLBPPCS1RDBURST;
  output PPCS1PLBADDRACK;
  output PPCS1PLBWAIT;
  output PPCS1PLBREARBITRATE;
  output PPCS1PLBWRDACK;
  output PPCS1PLBWRCOMP;
  output [0:127] PPCS1PLBRDDBUS;
  output [0:3] PPCS1PLBRDWDADDR;
  output PPCS1PLBRDDACK;
  output PPCS1PLBRDCOMP;
  output PPCS1PLBRDBTERM;
  output PPCS1PLBWRBTERM;
  output [0:0] PPCS1PLBMBUSY;
  output [0:0] PPCS1PLBMRDERR;
  output [0:0] PPCS1PLBMWRERR;
  output [0:0] PPCS1PLBMIRQ;
  output [0:1] PPCS1PLBSSIZE;
  input CPMDMA0LLCLK;
  input LLDMA0TXDSTRDYN;
  input [0:31] LLDMA0RXD;
  input [0:3] LLDMA0RXREM;
  input LLDMA0RXSOFN;
  input LLDMA0RXEOFN;
  input LLDMA0RXSOPN;
  input LLDMA0RXEOPN;
  input LLDMA0RXSRCRDYN;
  input LLDMA0RSTENGINEREQ;
  output [0:31] DMA0LLTXD;
  output [0:3] DMA0LLTXREM;
  output DMA0LLTXSOFN;
  output DMA0LLTXEOFN;
  output DMA0LLTXSOPN;
  output DMA0LLTXEOPN;
  output DMA0LLTXSRCRDYN;
  output DMA0LLRXDSTRDYN;
  output DMA0LLRSTENGINEACK;
  output DMA0TXIRQ;
  output DMA0RXIRQ;
  input CPMDMA1LLCLK;
  input LLDMA1TXDSTRDYN;
  input [0:31] LLDMA1RXD;
  input [0:3] LLDMA1RXREM;
  input LLDMA1RXSOFN;
  input LLDMA1RXEOFN;
  input LLDMA1RXSOPN;
  input LLDMA1RXEOPN;
  input LLDMA1RXSRCRDYN;
  input LLDMA1RSTENGINEREQ;
  output [0:31] DMA1LLTXD;
  output [0:3] DMA1LLTXREM;
  output DMA1LLTXSOFN;
  output DMA1LLTXEOFN;
  output DMA1LLTXSOPN;
  output DMA1LLTXEOPN;
  output DMA1LLTXSRCRDYN;
  output DMA1LLRXDSTRDYN;
  output DMA1LLRSTENGINEACK;
  output DMA1TXIRQ;
  output DMA1RXIRQ;
  input CPMDMA2LLCLK;
  input LLDMA2TXDSTRDYN;
  input [0:31] LLDMA2RXD;
  input [0:3] LLDMA2RXREM;
  input LLDMA2RXSOFN;
  input LLDMA2RXEOFN;
  input LLDMA2RXSOPN;
  input LLDMA2RXEOPN;
  input LLDMA2RXSRCRDYN;
  input LLDMA2RSTENGINEREQ;
  output [0:31] DMA2LLTXD;
  output [0:3] DMA2LLTXREM;
  output DMA2LLTXSOFN;
  output DMA2LLTXEOFN;
  output DMA2LLTXSOPN;
  output DMA2LLTXEOPN;
  output DMA2LLTXSRCRDYN;
  output DMA2LLRXDSTRDYN;
  output DMA2LLRSTENGINEACK;
  output DMA2TXIRQ;
  output DMA2RXIRQ;
  input CPMDMA3LLCLK;
  input LLDMA3TXDSTRDYN;
  input [0:31] LLDMA3RXD;
  input [0:3] LLDMA3RXREM;
  input LLDMA3RXSOFN;
  input LLDMA3RXEOFN;
  input LLDMA3RXSOPN;
  input LLDMA3RXEOPN;
  input LLDMA3RXSRCRDYN;
  input LLDMA3RSTENGINEREQ;
  output [0:31] DMA3LLTXD;
  output [0:3] DMA3LLTXREM;
  output DMA3LLTXSOFN;
  output DMA3LLTXEOFN;
  output DMA3LLTXSOPN;
  output DMA3LLTXEOPN;
  output DMA3LLTXSRCRDYN;
  output DMA3LLRXDSTRDYN;
  output DMA3LLRSTENGINEACK;
  output DMA3TXIRQ;
  output DMA3RXIRQ;
  input RSTC440RESETCORE;
  input RSTC440RESETCHIP;
  input RSTC440RESETSYSTEM;
  output C440RSTCORERESETREQ;
  output C440RSTCHIPRESETREQ;
  output C440RSTSYSTEMRESETREQ;
  input TRCC440TRACEDISABLE;
  input TRCC440TRIGGEREVENTIN;
  output [0:2] C440TRCBRANCHSTATUS;
  output C440TRCCYCLE;
  output [0:4] C440TRCEXECUTIONSTATUS;
  output [0:6] C440TRCTRACESTATUS;
  output C440TRCTRIGGEREVENTOUT;
  output [0:13] C440TRCTRIGGEREVENTTYPE;
endmodule

module plb_v46_1_wrapper
  (
    PLB_Clk,
    SYS_Rst,
    PLB_Rst,
    SPLB_Rst,
    MPLB_Rst,
    PLB_dcrAck,
    PLB_dcrDBus,
    DCR_ABus,
    DCR_DBus,
    DCR_Read,
    DCR_Write,
    M_ABus,
    M_UABus,
    M_BE,
    M_RNW,
    M_abort,
    M_busLock,
    M_TAttribute,
    M_lockErr,
    M_MSize,
    M_priority,
    M_rdBurst,
    M_request,
    M_size,
    M_type,
    M_wrBurst,
    M_wrDBus,
    Sl_addrAck,
    Sl_MRdErr,
    Sl_MWrErr,
    Sl_MBusy,
    Sl_rdBTerm,
    Sl_rdComp,
    Sl_rdDAck,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rearbitrate,
    Sl_SSize,
    Sl_wait,
    Sl_wrBTerm,
    Sl_wrComp,
    Sl_wrDAck,
    Sl_MIRQ,
    PLB_MIRQ,
    PLB_ABus,
    PLB_UABus,
    PLB_BE,
    PLB_MAddrAck,
    PLB_MTimeout,
    PLB_MBusy,
    PLB_MRdErr,
    PLB_MWrErr,
    PLB_MRdBTerm,
    PLB_MRdDAck,
    PLB_MRdDBus,
    PLB_MRdWdAddr,
    PLB_MRearbitrate,
    PLB_MWrBTerm,
    PLB_MWrDAck,
    PLB_MSSize,
    PLB_PAValid,
    PLB_RNW,
    PLB_SAValid,
    PLB_abort,
    PLB_busLock,
    PLB_TAttribute,
    PLB_lockErr,
    PLB_masterID,
    PLB_MSize,
    PLB_rdPendPri,
    PLB_wrPendPri,
    PLB_rdPendReq,
    PLB_wrPendReq,
    PLB_rdBurst,
    PLB_rdPrim,
    PLB_reqPri,
    PLB_size,
    PLB_type,
    PLB_wrBurst,
    PLB_wrDBus,
    PLB_wrPrim,
    PLB_SaddrAck,
    PLB_SMRdErr,
    PLB_SMWrErr,
    PLB_SMBusy,
    PLB_SrdBTerm,
    PLB_SrdComp,
    PLB_SrdDAck,
    PLB_SrdDBus,
    PLB_SrdWdAddr,
    PLB_Srearbitrate,
    PLB_Sssize,
    PLB_Swait,
    PLB_SwrBTerm,
    PLB_SwrComp,
    PLB_SwrDAck,
    Bus_Error_Det
  );
  input PLB_Clk;
  input SYS_Rst;
  output PLB_Rst;
  output [0:0] SPLB_Rst;
  output [0:1] MPLB_Rst;
  output PLB_dcrAck;
  output [0:31] PLB_dcrDBus;
  input [0:9] DCR_ABus;
  input [0:31] DCR_DBus;
  input DCR_Read;
  input DCR_Write;
  input [0:63] M_ABus;
  input [0:63] M_UABus;
  input [0:31] M_BE;
  input [0:1] M_RNW;
  input [0:1] M_abort;
  input [0:1] M_busLock;
  input [0:31] M_TAttribute;
  input [0:1] M_lockErr;
  input [0:3] M_MSize;
  input [0:3] M_priority;
  input [0:1] M_rdBurst;
  input [0:1] M_request;
  input [0:7] M_size;
  input [0:5] M_type;
  input [0:1] M_wrBurst;
  input [0:255] M_wrDBus;
  input [0:0] Sl_addrAck;
  input [0:1] Sl_MRdErr;
  input [0:1] Sl_MWrErr;
  input [0:1] Sl_MBusy;
  input [0:0] Sl_rdBTerm;
  input [0:0] Sl_rdComp;
  input [0:0] Sl_rdDAck;
  input [0:127] Sl_rdDBus;
  input [0:3] Sl_rdWdAddr;
  input [0:0] Sl_rearbitrate;
  input [0:1] Sl_SSize;
  input [0:0] Sl_wait;
  input [0:0] Sl_wrBTerm;
  input [0:0] Sl_wrComp;
  input [0:0] Sl_wrDAck;
  input [0:1] Sl_MIRQ;
  output [0:1] PLB_MIRQ;
  output [0:31] PLB_ABus;
  output [0:31] PLB_UABus;
  output [0:15] PLB_BE;
  output [0:1] PLB_MAddrAck;
  output [0:1] PLB_MTimeout;
  output [0:1] PLB_MBusy;
  output [0:1] PLB_MRdErr;
  output [0:1] PLB_MWrErr;
  output [0:1] PLB_MRdBTerm;
  output [0:1] PLB_MRdDAck;
  output [0:255] PLB_MRdDBus;
  output [0:7] PLB_MRdWdAddr;
  output [0:1] PLB_MRearbitrate;
  output [0:1] PLB_MWrBTerm;
  output [0:1] PLB_MWrDAck;
  output [0:3] PLB_MSSize;
  output PLB_PAValid;
  output PLB_RNW;
  output PLB_SAValid;
  output PLB_abort;
  output PLB_busLock;
  output [0:15] PLB_TAttribute;
  output PLB_lockErr;
  output [0:0] PLB_masterID;
  output [0:1] PLB_MSize;
  output [0:1] PLB_rdPendPri;
  output [0:1] PLB_wrPendPri;
  output PLB_rdPendReq;
  output PLB_wrPendReq;
  output PLB_rdBurst;
  output [0:0] PLB_rdPrim;
  output [0:1] PLB_reqPri;
  output [0:3] PLB_size;
  output [0:2] PLB_type;
  output PLB_wrBurst;
  output [0:127] PLB_wrDBus;
  output [0:0] PLB_wrPrim;
  output PLB_SaddrAck;
  output [0:1] PLB_SMRdErr;
  output [0:1] PLB_SMWrErr;
  output [0:1] PLB_SMBusy;
  output PLB_SrdBTerm;
  output PLB_SrdComp;
  output PLB_SrdDAck;
  output [0:127] PLB_SrdDBus;
  output [0:3] PLB_SrdWdAddr;
  output PLB_Srearbitrate;
  output [0:1] PLB_Sssize;
  output PLB_Swait;
  output PLB_SwrBTerm;
  output PLB_SwrComp;
  output PLB_SwrDAck;
  output Bus_Error_Det;
endmodule

module plb_v46_0_wrapper
  (
    PLB_Clk,
    SYS_Rst,
    PLB_Rst,
    SPLB_Rst,
    MPLB_Rst,
    PLB_dcrAck,
    PLB_dcrDBus,
    DCR_ABus,
    DCR_DBus,
    DCR_Read,
    DCR_Write,
    M_ABus,
    M_UABus,
    M_BE,
    M_RNW,
    M_abort,
    M_busLock,
    M_TAttribute,
    M_lockErr,
    M_MSize,
    M_priority,
    M_rdBurst,
    M_request,
    M_size,
    M_type,
    M_wrBurst,
    M_wrDBus,
    Sl_addrAck,
    Sl_MRdErr,
    Sl_MWrErr,
    Sl_MBusy,
    Sl_rdBTerm,
    Sl_rdComp,
    Sl_rdDAck,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rearbitrate,
    Sl_SSize,
    Sl_wait,
    Sl_wrBTerm,
    Sl_wrComp,
    Sl_wrDAck,
    Sl_MIRQ,
    PLB_MIRQ,
    PLB_ABus,
    PLB_UABus,
    PLB_BE,
    PLB_MAddrAck,
    PLB_MTimeout,
    PLB_MBusy,
    PLB_MRdErr,
    PLB_MWrErr,
    PLB_MRdBTerm,
    PLB_MRdDAck,
    PLB_MRdDBus,
    PLB_MRdWdAddr,
    PLB_MRearbitrate,
    PLB_MWrBTerm,
    PLB_MWrDAck,
    PLB_MSSize,
    PLB_PAValid,
    PLB_RNW,
    PLB_SAValid,
    PLB_abort,
    PLB_busLock,
    PLB_TAttribute,
    PLB_lockErr,
    PLB_masterID,
    PLB_MSize,
    PLB_rdPendPri,
    PLB_wrPendPri,
    PLB_rdPendReq,
    PLB_wrPendReq,
    PLB_rdBurst,
    PLB_rdPrim,
    PLB_reqPri,
    PLB_size,
    PLB_type,
    PLB_wrBurst,
    PLB_wrDBus,
    PLB_wrPrim,
    PLB_SaddrAck,
    PLB_SMRdErr,
    PLB_SMWrErr,
    PLB_SMBusy,
    PLB_SrdBTerm,
    PLB_SrdComp,
    PLB_SrdDAck,
    PLB_SrdDBus,
    PLB_SrdWdAddr,
    PLB_Srearbitrate,
    PLB_Sssize,
    PLB_Swait,
    PLB_SwrBTerm,
    PLB_SwrComp,
    PLB_SwrDAck,
    Bus_Error_Det
  );
  input PLB_Clk;
  input SYS_Rst;
  output PLB_Rst;
  output [0:5] SPLB_Rst;
  output [0:0] MPLB_Rst;
  output PLB_dcrAck;
  output [0:31] PLB_dcrDBus;
  input [0:9] DCR_ABus;
  input [0:31] DCR_DBus;
  input DCR_Read;
  input DCR_Write;
  input [0:31] M_ABus;
  input [0:31] M_UABus;
  input [0:15] M_BE;
  input [0:0] M_RNW;
  input [0:0] M_abort;
  input [0:0] M_busLock;
  input [0:15] M_TAttribute;
  input [0:0] M_lockErr;
  input [0:1] M_MSize;
  input [0:1] M_priority;
  input [0:0] M_rdBurst;
  input [0:0] M_request;
  input [0:3] M_size;
  input [0:2] M_type;
  input [0:0] M_wrBurst;
  input [0:127] M_wrDBus;
  input [0:5] Sl_addrAck;
  input [0:5] Sl_MRdErr;
  input [0:5] Sl_MWrErr;
  input [0:5] Sl_MBusy;
  input [0:5] Sl_rdBTerm;
  input [0:5] Sl_rdComp;
  input [0:5] Sl_rdDAck;
  input [0:767] Sl_rdDBus;
  input [0:23] Sl_rdWdAddr;
  input [0:5] Sl_rearbitrate;
  input [0:11] Sl_SSize;
  input [0:5] Sl_wait;
  input [0:5] Sl_wrBTerm;
  input [0:5] Sl_wrComp;
  input [0:5] Sl_wrDAck;
  input [0:5] Sl_MIRQ;
  output [0:0] PLB_MIRQ;
  output [0:31] PLB_ABus;
  output [0:31] PLB_UABus;
  output [0:15] PLB_BE;
  output [0:0] PLB_MAddrAck;
  output [0:0] PLB_MTimeout;
  output [0:0] PLB_MBusy;
  output [0:0] PLB_MRdErr;
  output [0:0] PLB_MWrErr;
  output [0:0] PLB_MRdBTerm;
  output [0:0] PLB_MRdDAck;
  output [0:127] PLB_MRdDBus;
  output [0:3] PLB_MRdWdAddr;
  output [0:0] PLB_MRearbitrate;
  output [0:0] PLB_MWrBTerm;
  output [0:0] PLB_MWrDAck;
  output [0:1] PLB_MSSize;
  output PLB_PAValid;
  output PLB_RNW;
  output PLB_SAValid;
  output PLB_abort;
  output PLB_busLock;
  output [0:15] PLB_TAttribute;
  output PLB_lockErr;
  output [0:0] PLB_masterID;
  output [0:1] PLB_MSize;
  output [0:1] PLB_rdPendPri;
  output [0:1] PLB_wrPendPri;
  output PLB_rdPendReq;
  output PLB_wrPendReq;
  output PLB_rdBurst;
  output [0:5] PLB_rdPrim;
  output [0:1] PLB_reqPri;
  output [0:3] PLB_size;
  output [0:2] PLB_type;
  output PLB_wrBurst;
  output [0:127] PLB_wrDBus;
  output [0:5] PLB_wrPrim;
  output PLB_SaddrAck;
  output [0:0] PLB_SMRdErr;
  output [0:0] PLB_SMWrErr;
  output [0:0] PLB_SMBusy;
  output PLB_SrdBTerm;
  output PLB_SrdComp;
  output PLB_SrdDAck;
  output [0:127] PLB_SrdDBus;
  output [0:3] PLB_SrdWdAddr;
  output PLB_Srearbitrate;
  output [0:1] PLB_Sssize;
  output PLB_Swait;
  output PLB_SwrBTerm;
  output PLB_SwrComp;
  output PLB_SwrDAck;
  output Bus_Error_Det;
endmodule

module jtagppc_cntlr_0_wrapper
  (
    TRSTNEG,
    HALTNEG0,
    DBGC405DEBUGHALT0,
    HALTNEG1,
    DBGC405DEBUGHALT1,
    C405JTGTDO0,
    C405JTGTDOEN0,
    JTGC405TCK0,
    JTGC405TDI0,
    JTGC405TMS0,
    JTGC405TRSTNEG0,
    C405JTGTDO1,
    C405JTGTDOEN1,
    JTGC405TCK1,
    JTGC405TDI1,
    JTGC405TMS1,
    JTGC405TRSTNEG1
  );
  input TRSTNEG;
  input HALTNEG0;
  output DBGC405DEBUGHALT0;
  input HALTNEG1;
  output DBGC405DEBUGHALT1;
  input C405JTGTDO0;
  input C405JTGTDOEN0;
  output JTGC405TCK0;
  output JTGC405TDI0;
  output JTGC405TMS0;
  output JTGC405TRSTNEG0;
  input C405JTGTDO1;
  input C405JTGTDOEN1;
  output JTGC405TCK1;
  output JTGC405TDI1;
  output JTGC405TMS1;
  output JTGC405TRSTNEG1;
endmodule

module fcb_v20_0_wrapper
  (
    FCB_CLK,
    SYS_RST,
    FCB_RST,
    M_DECUDI,
    M_DECUDIVALID,
    M_ENDIAN,
    M_FLUSH,
    M_INSTRUCTION,
    M_INSTRVALID,
    M_LOADBYTEADDR,
    M_LOADDATA,
    M_LOADDVALID,
    M_OPERANDVALID,
    M_RADATA,
    M_RBDATA,
    M_WRITEBACKOK,
    M_DECFPUOP,
    M_DECLOAD,
    M_DECSTORE,
    M_DECLDSTXFERSIZE,
    M_DECNONAUTON,
    M_NEXTINSTRREADY,
    M_MSRFE0,
    M_MSRFE1,
    FCB_CR,
    FCB_DONE,
    FCB_EXCEPTION,
    FCB_RESULT,
    FCB_RESULTVALID,
    FCB_SLEEPNOTREADY,
    FCB_STOREDATA,
    FCB_CONFIRMINSTR,
    FCB_FPSCRFEX,
    FCB_DECUDI,
    FCB_DECUDIVALID,
    FCB_ENDIAN,
    FCB_FLUSH,
    FCB_INSTRUCTION,
    FCB_INSTRVALID,
    FCB_LOADBYTEADDR,
    FCB_LOADDATA,
    FCB_LOADDVALID,
    FCB_OPERANDVALID,
    FCB_RADATA,
    FCB_RBDATA,
    FCB_WRITEBACKOK,
    FCB_DECFPUOP,
    FCB_DECLOAD,
    FCB_DECSTORE,
    FCB_DECLDSTXFERSIZE,
    FCB_DECNONAUTON,
    FCB_NEXTINSTRREADY,
    FCB_MSRFE0,
    FCB_MSRFE1,
    Sl_CR,
    Sl_DONE,
    Sl_EXCEPTION,
    Sl_RESULT,
    Sl_RESULTVALID,
    Sl_SLEEPNOTREADY,
    Sl_STOREDATA,
    Sl_CONFIRMINSTR,
    Sl_FPSCRFEX
  );
  input FCB_CLK;
  input SYS_RST;
  output FCB_RST;
  input [0:3] M_DECUDI;
  input [0:0] M_DECUDIVALID;
  input [0:0] M_ENDIAN;
  input [0:0] M_FLUSH;
  input [0:31] M_INSTRUCTION;
  input M_INSTRVALID;
  input [0:3] M_LOADBYTEADDR;
  input [0:127] M_LOADDATA;
  input M_LOADDVALID;
  input [0:0] M_OPERANDVALID;
  input [0:31] M_RADATA;
  input [0:31] M_RBDATA;
  input [0:0] M_WRITEBACKOK;
  input M_DECFPUOP;
  input M_DECLOAD;
  input M_DECSTORE;
  input [0:2] M_DECLDSTXFERSIZE;
  input M_DECNONAUTON;
  input M_NEXTINSTRREADY;
  input M_MSRFE0;
  input M_MSRFE1;
  output [0:3] FCB_CR;
  output FCB_DONE;
  output FCB_EXCEPTION;
  output [0:31] FCB_RESULT;
  output FCB_RESULTVALID;
  output FCB_SLEEPNOTREADY;
  output [0:127] FCB_STOREDATA;
  output FCB_CONFIRMINSTR;
  output FCB_FPSCRFEX;
  output [0:3] FCB_DECUDI;
  output FCB_DECUDIVALID;
  output FCB_ENDIAN;
  output FCB_FLUSH;
  output [0:31] FCB_INSTRUCTION;
  output FCB_INSTRVALID;
  output [0:3] FCB_LOADBYTEADDR;
  output [0:127] FCB_LOADDATA;
  output FCB_LOADDVALID;
  output FCB_OPERANDVALID;
  output [0:31] FCB_RADATA;
  output [0:31] FCB_RBDATA;
  output FCB_WRITEBACKOK;
  output FCB_DECFPUOP;
  output FCB_DECLOAD;
  output FCB_DECSTORE;
  output [0:2] FCB_DECLDSTXFERSIZE;
  output FCB_DECNONAUTON;
  output FCB_NEXTINSTRREADY;
  output FCB_MSRFE0;
  output FCB_MSRFE1;
  input [0:3] Sl_CR;
  input [0:0] Sl_DONE;
  input [0:0] Sl_EXCEPTION;
  input [0:31] Sl_RESULT;
  input [0:0] Sl_RESULTVALID;
  input [0:0] Sl_SLEEPNOTREADY;
  input [0:127] Sl_STOREDATA;
  input [0:0] Sl_CONFIRMINSTR;
  input [0:0] Sl_FPSCRFEX;
endmodule

module ddr2_init_wrapper
  (
    SPLB_Clk,
    SPLB_Rst,
    PLB_ABus,
    PLB_UABus,
    PLB_PAValid,
    PLB_SAValid,
    PLB_rdPrim,
    PLB_wrPrim,
    PLB_masterID,
    PLB_abort,
    PLB_busLock,
    PLB_RNW,
    PLB_BE,
    PLB_MSize,
    PLB_size,
    PLB_type,
    PLB_lockErr,
    PLB_wrDBus,
    PLB_wrBurst,
    PLB_rdBurst,
    PLB_wrPendReq,
    PLB_rdPendReq,
    PLB_wrPendPri,
    PLB_rdPendPri,
    PLB_reqPri,
    PLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    IP2INTC_Irpt,
    GPIO_IO_I,
    GPIO_IO_O,
    GPIO_IO_T,
    GPIO_in,
    GPIO_d_out,
    GPIO_t_out,
    GPIO2_IO_I,
    GPIO2_IO_O,
    GPIO2_IO_T,
    GPIO2_in,
    GPIO2_d_out,
    GPIO2_t_out
  );
  input SPLB_Clk;
  input SPLB_Rst;
  input [0:31] PLB_ABus;
  input [0:31] PLB_UABus;
  input PLB_PAValid;
  input PLB_SAValid;
  input PLB_rdPrim;
  input PLB_wrPrim;
  input [0:0] PLB_masterID;
  input PLB_abort;
  input PLB_busLock;
  input PLB_RNW;
  input [0:15] PLB_BE;
  input [0:1] PLB_MSize;
  input [0:3] PLB_size;
  input [0:2] PLB_type;
  input PLB_lockErr;
  input [0:127] PLB_wrDBus;
  input PLB_wrBurst;
  input PLB_rdBurst;
  input PLB_wrPendReq;
  input PLB_rdPendReq;
  input [0:1] PLB_wrPendPri;
  input [0:1] PLB_rdPendPri;
  input [0:1] PLB_reqPri;
  input [0:15] PLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  output IP2INTC_Irpt;
  input [0:0] GPIO_IO_I;
  output [0:0] GPIO_IO_O;
  output [0:0] GPIO_IO_T;
  input [0:0] GPIO_in;
  output [0:0] GPIO_d_out;
  output [0:0] GPIO_t_out;
  input [0:0] GPIO2_IO_I;
  output [0:0] GPIO2_IO_O;
  output [0:0] GPIO2_IO_T;
  input [0:0] GPIO2_in;
  output [0:0] GPIO2_d_out;
  output [0:0] GPIO2_t_out;
endmodule

module dcr_v29_0_wrapper
  (
    M_dcrABus,
    M_dcrDBus,
    M_dcrRead,
    M_dcrWrite,
    DCR_M_DBus,
    DCR_Ack,
    DCR_ABus,
    DCR_Sl_DBus,
    DCR_Read,
    DCR_Write,
    Sl_dcrDBus,
    Sl_dcrAck
  );
  input [0:9] M_dcrABus;
  input [0:31] M_dcrDBus;
  input M_dcrRead;
  input M_dcrWrite;
  output [0:31] DCR_M_DBus;
  output DCR_Ack;
  output [0:19] DCR_ABus;
  output [0:63] DCR_Sl_DBus;
  output [0:1] DCR_Read;
  output [0:1] DCR_Write;
  input [0:63] Sl_dcrDBus;
  input [0:1] Sl_dcrAck;
endmodule

module dcr_intc_0_wrapper
  (
    DCR_Clk,
    Intr,
    DCR_Rst,
    DCR_Read,
    DCR_Write,
    DCR_ABus,
    DCR_DBus,
    Intc_dcrDBus,
    Intc_dcrAck,
    Irq
  );
  input DCR_Clk;
  input [3:0] Intr;
  input DCR_Rst;
  input DCR_Read;
  input DCR_Write;
  input [0:9] DCR_ABus;
  input [0:31] DCR_DBus;
  output [0:31] Intc_dcrDBus;
  output Intc_dcrAck;
  output Irq;
endmodule

module clock_generator_0_wrapper
  (
    CLKIN,
    CLKFBIN,
    CLKOUT0,
    CLKOUT1,
    CLKOUT2,
    CLKOUT3,
    CLKOUT4,
    CLKOUT5,
    CLKOUT6,
    CLKOUT7,
    CLKOUT8,
    CLKOUT9,
    CLKOUT10,
    CLKOUT11,
    CLKOUT12,
    CLKOUT13,
    CLKOUT14,
    CLKOUT15,
    CLKFBOUT,
    RST,
    LOCKED
  );
  input CLKIN;
  input CLKFBIN;
  output CLKOUT0;
  output CLKOUT1;
  output CLKOUT2;
  output CLKOUT3;
  output CLKOUT4;
  output CLKOUT5;
  output CLKOUT6;
  output CLKOUT7;
  output CLKOUT8;
  output CLKOUT9;
  output CLKOUT10;
  output CLKOUT11;
  output CLKOUT12;
  output CLKOUT13;
  output CLKOUT14;
  output CLKOUT15;
  output CLKFBOUT;
  input RST;
  output LOCKED;
endmodule

module leds_8bit_wrapper
  (
    SPLB_Clk,
    SPLB_Rst,
    PLB_ABus,
    PLB_UABus,
    PLB_PAValid,
    PLB_SAValid,
    PLB_rdPrim,
    PLB_wrPrim,
    PLB_masterID,
    PLB_abort,
    PLB_busLock,
    PLB_RNW,
    PLB_BE,
    PLB_MSize,
    PLB_size,
    PLB_type,
    PLB_lockErr,
    PLB_wrDBus,
    PLB_wrBurst,
    PLB_rdBurst,
    PLB_wrPendReq,
    PLB_rdPendReq,
    PLB_wrPendPri,
    PLB_rdPendPri,
    PLB_reqPri,
    PLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    IP2INTC_Irpt,
    GPIO_IO_I,
    GPIO_IO_O,
    GPIO_IO_T,
    GPIO_in,
    GPIO_d_out,
    GPIO_t_out,
    GPIO2_IO_I,
    GPIO2_IO_O,
    GPIO2_IO_T,
    GPIO2_in,
    GPIO2_d_out,
    GPIO2_t_out
  );
  input SPLB_Clk;
  input SPLB_Rst;
  input [0:31] PLB_ABus;
  input [0:31] PLB_UABus;
  input PLB_PAValid;
  input PLB_SAValid;
  input PLB_rdPrim;
  input PLB_wrPrim;
  input [0:0] PLB_masterID;
  input PLB_abort;
  input PLB_busLock;
  input PLB_RNW;
  input [0:15] PLB_BE;
  input [0:1] PLB_MSize;
  input [0:3] PLB_size;
  input [0:2] PLB_type;
  input PLB_lockErr;
  input [0:127] PLB_wrDBus;
  input PLB_wrBurst;
  input PLB_rdBurst;
  input PLB_wrPendReq;
  input PLB_rdPendReq;
  input [0:1] PLB_wrPendPri;
  input [0:1] PLB_rdPendPri;
  input [0:1] PLB_reqPri;
  input [0:15] PLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  output IP2INTC_Irpt;
  input [0:7] GPIO_IO_I;
  output [0:7] GPIO_IO_O;
  output [0:7] GPIO_IO_T;
  input [0:7] GPIO_in;
  output [0:7] GPIO_d_out;
  output [0:7] GPIO_t_out;
  input [0:7] GPIO2_IO_I;
  output [0:7] GPIO2_IO_O;
  output [0:7] GPIO2_IO_T;
  input [0:7] GPIO2_in;
  output [0:7] GPIO2_d_out;
  output [0:7] GPIO2_t_out;
endmodule

module plbv46_dvi_cntlr_0_wrapper
  (
    SYS_tftClk,
    TFT_LCD_CLK_P,
    TFT_LCD_CLK_N,
    TFT_LCD_DE,
    TFT_LCD_DATA,
    TFT_LCD_HSYNC,
    TFT_LCD_VSYNC,
    TFT_LCD_DPS,
    SYS_dcrClk,
    DCR_Ack,
    DCR_DBusOut,
    DCR_ABus,
    DCR_DBusIn,
    DCR_Read,
    DCR_Write,
    SPLB_Clk,
    SPLB_Rst,
    PLB_ABus,
    PLB_UABus,
    PLB_PAValid,
    PLB_SAValid,
    PLB_rdPrim,
    PLB_wrPrim,
    PLB_masterID,
    PLB_abort,
    PLB_busLock,
    PLB_RNW,
    PLB_BE,
    PLB_MSize,
    PLB_size,
    PLB_type,
    PLB_lockErr,
    PLB_wrDBus,
    PLB_wrBurst,
    PLB_rdBurst,
    PLB_wrPendReq,
    PLB_rdPendReq,
    PLB_wrPendPri,
    PLB_rdPendPri,
    PLB_reqPri,
    PLB_TAttribute,
    Sl_addrAck,
    Sl_SSize,
    Sl_wait,
    Sl_rearbitrate,
    Sl_wrDAck,
    Sl_wrComp,
    Sl_wrBTerm,
    Sl_rdDBus,
    Sl_rdWdAddr,
    Sl_rdDAck,
    Sl_rdComp,
    Sl_rdBTerm,
    Sl_MBusy,
    Sl_MWrErr,
    Sl_MRdErr,
    Sl_MIRQ,
    MPLB_Clk,
    MPLB_Rst,
    MD_error,
    M_request,
    M_priority,
    M_busLock,
    M_RNW,
    M_BE,
    M_MSize,
    M_size,
    M_type,
    M_TAttribute,
    M_lockErr,
    M_abort,
    M_UABus,
    M_ABus,
    M_wrDBus,
    M_wrBurst,
    M_rdBurst,
    PLB_MAddrAck,
    PLB_MSSize,
    PLB_MRearbitrate,
    PLB_MTimeout,
    PLB_MBusy,
    PLB_MRdErr,
    PLB_MWrErr,
    PLB_MIRQ,
    PLB_MRdDBus,
    PLB_MRdWdAddr,
    PLB_MRdDAck,
    PLB_MRdBTerm,
    PLB_MWrDAck,
    PLB_MWrBTerm,
    tft_iic_scl_I,
    tft_iic_scl_O,
    tft_iic_scl_T,
    tft_iic_sda_I,
    tft_iic_sda_O,
    tft_iic_sda_T
  );
  input SYS_tftClk;
  output TFT_LCD_CLK_P;
  output TFT_LCD_CLK_N;
  output TFT_LCD_DE;
  output [11:0] TFT_LCD_DATA;
  output TFT_LCD_HSYNC;
  output TFT_LCD_VSYNC;
  output TFT_LCD_DPS;
  input SYS_dcrClk;
  output DCR_Ack;
  output [0:31] DCR_DBusOut;
  input [0:9] DCR_ABus;
  input [0:31] DCR_DBusIn;
  input DCR_Read;
  input DCR_Write;
  input SPLB_Clk;
  input SPLB_Rst;
  input [0:31] PLB_ABus;
  input [0:31] PLB_UABus;
  input PLB_PAValid;
  input PLB_SAValid;
  input PLB_rdPrim;
  input PLB_wrPrim;
  input [0:0] PLB_masterID;
  input PLB_abort;
  input PLB_busLock;
  input PLB_RNW;
  input [0:15] PLB_BE;
  input [0:1] PLB_MSize;
  input [0:3] PLB_size;
  input [0:2] PLB_type;
  input PLB_lockErr;
  input [0:127] PLB_wrDBus;
  input PLB_wrBurst;
  input PLB_rdBurst;
  input PLB_wrPendReq;
  input PLB_rdPendReq;
  input [0:1] PLB_wrPendPri;
  input [0:1] PLB_rdPendPri;
  input [0:1] PLB_reqPri;
  input [0:15] PLB_TAttribute;
  output Sl_addrAck;
  output [0:1] Sl_SSize;
  output Sl_wait;
  output Sl_rearbitrate;
  output Sl_wrDAck;
  output Sl_wrComp;
  output Sl_wrBTerm;
  output [0:127] Sl_rdDBus;
  output [0:3] Sl_rdWdAddr;
  output Sl_rdDAck;
  output Sl_rdComp;
  output Sl_rdBTerm;
  output [0:0] Sl_MBusy;
  output [0:0] Sl_MWrErr;
  output [0:0] Sl_MRdErr;
  output [0:0] Sl_MIRQ;
  input MPLB_Clk;
  input MPLB_Rst;
  output MD_error;
  output M_request;
  output [0:1] M_priority;
  output M_busLock;
  output M_RNW;
  output [0:15] M_BE;
  output [0:1] M_MSize;
  output [0:3] M_size;
  output [0:2] M_type;
  output [0:15] M_TAttribute;
  output M_lockErr;
  output M_abort;
  output [0:31] M_UABus;
  output [0:31] M_ABus;
  output [0:127] M_wrDBus;
  output M_wrBurst;
  output M_rdBurst;
  input PLB_MAddrAck;
  input [0:1] PLB_MSSize;
  input PLB_MRearbitrate;
  input PLB_MTimeout;
  input PLB_MBusy;
  input PLB_MRdErr;
  input PLB_MWrErr;
  input PLB_MIRQ;
  input [0:127] PLB_MRdDBus;
  input [0:3] PLB_MRdWdAddr;
  input PLB_MRdDAck;
  input PLB_MRdBTerm;
  input PLB_MWrDAck;
  input PLB_MWrBTerm;
  input tft_iic_scl_I;
  output tft_iic_scl_O;
  output tft_iic_scl_T;
  input tft_iic_sda_I;
  output tft_iic_sda_O;
  output tft_iic_sda_T;
endmodule

module apu_idct_colorconv_arch_0_wrapper
  (
    FCMAPURESULT,
    FCMAPUDONE,
    FCMAPUSLEEPNOTREADY,
    FCMAPURESULTVALID,
    FCMAPUCR,
    FCMAPUEXCEPTION,
    FCMAPUSTOREDATA,
    FCMAPUCONFIRMINSTR,
    FCMAPUFPSCRFEX,
    APUFCMINSTRUCTION,
    APUFCMINSTRVALID,
    APUFCMRADATA,
    APUFCMRBDATA,
    APUFCMOPERANDVALID,
    APUFCMFLUSH,
    APUFCMWRITEBACKOK,
    APUFCMLOADDATA,
    APUFCMLOADDVALID,
    APUFCMLOADBYTEADDR,
    APUFCMENDIAN,
    APUFCMDECUDI,
    APUFCMDECUDIVALID,
    APUFCMDECFPUOP,
    APUFCMDECLOAD,
    APUFCMDECSTORE,
    APUFCMDECLDSTXFERSIZE,
    APUFCMDECNONAUTON,
    APUFCMNEXTINSTRREADY,
    udidebug,
    apu_clk,
    reset
  );
  output [0:31] FCMAPURESULT;
  output FCMAPUDONE;
  output FCMAPUSLEEPNOTREADY;
  output FCMAPURESULTVALID;
  output [0:3] FCMAPUCR;
  output FCMAPUEXCEPTION;
  output [0:127] FCMAPUSTOREDATA;
  output FCMAPUCONFIRMINSTR;
  output FCMAPUFPSCRFEX;
  input [0:31] APUFCMINSTRUCTION;
  input APUFCMINSTRVALID;
  input [0:31] APUFCMRADATA;
  input [0:31] APUFCMRBDATA;
  input APUFCMOPERANDVALID;
  input APUFCMFLUSH;
  input APUFCMWRITEBACKOK;
  input [0:127] APUFCMLOADDATA;
  input APUFCMLOADDVALID;
  input [0:3] APUFCMLOADBYTEADDR;
  input APUFCMENDIAN;
  input [0:3] APUFCMDECUDI;
  input APUFCMDECUDIVALID;
  input APUFCMDECFPUOP;
  input APUFCMDECLOAD;
  input APUFCMDECSTORE;
  input [0:2] APUFCMDECLDSTXFERSIZE;
  input APUFCMDECNONAUTON;
  input APUFCMNEXTINSTRREADY;
  output [153:0] udidebug;
  input apu_clk;
  input reset;
endmodule

